//Матричный график. Для триггеров.
function DrawArchitecturePlot(NameNN) {
    //------------------------------------------------------------------------------------------------------------------
    //G.C.DivC= false;
    //let inDiv = G.C.DivContainer;
    //inDiv.innerHTML = "";
    Manager_G_C_S_Display();

    if (G.C.ChartType != "Architecture") {//После графиков другого типа ( Standard, Trigger)
        ChartWin("Architecture");
    }

    let DivC = G.C.DivC;
    //0.Очишаем
    DivC.innerHTML = "";

    //Размеры контейнера
    //let DivC = WindowContainer([0, "", 0, ""], ["100%", "100%"], inDiv);
    let SizeWin = GetDivSizeContent(DivC);

    //console.log("GetDivSizeContent(inDiv).w=" + GetDivSizeContent(inDiv).w + " GetDivSizeContent(DivC).w=" + GetDivSizeContent(DivC).w);


    let NNSet = G.NN.N[NameNN].Set;
    let NNSetNNLayerN = NNSet.NN.LayerN;//[]int Количество нейронов в i слое, начиная со входящего.
    let NNSetNNLayerID = NNSet.NN.LayerID //[]int Индекс первого нейрона в i слое, начиная со входящего.
    let NeuronMaxLayerN = Math.max(...NNSetNNLayerN); //Максимальное число нейронов в слое, среди всех слоев
    let LayerN = NNSetNNLayerN.length;//Количество слоев   
    //1. Рисуем схему так чтобы она хорошо смотрелась в текущих размерах окна. 
    //2. Затем из неё делаем пиксельную карту для трансформацией (масштабирование/перемещение) с помощью мыши

    //Размеры для текущих размеров окна. 
    let Size = {};
    Size.w = SizeWin.w;
    Size.h = SizeWin.h;


    Size.LineWidth = 1;//Толщина линии.
    Size.GapNeuronW = 2; //Зазор между кружками нейронов по горизонтали.
    Size.GapWin = 16; //Зазор рамка
    Size.DMaxNeuron = 30;//Максимальный диаметр нейрона, габаритный, т.е. вместе с контуром.
    Size.GapNeuronH = 2 * Size.DMaxNeuron; //Минимальный зазор между кружками нейронов по вертикали. (не между центрами) Зависит от диаметра нейрона.



    let GBoxW = SizeWin.w - 2 * Size.GapWin;//Графическая область с зазором
    let GBoxH = SizeWin.h - 2 * Size.GapWin;//Графическая область с зазором

    let DNeuronW = ((GBoxW + Size.GapNeuronW) / NeuronMaxLayerN) - Size.GapNeuronW;//Вычисленный диаметр нейрона.  По самому большому слою и всей ширине окна.
    let DNeuronH = GBoxH / (5 * LayerN);//Вычисленный диаметр нейрона.  По количеству слоев и всей высоте окна.
    //console.log("DNeuronW=" + DNeuronW + " DNeuronH=" + DNeuronH);

    Size.DNeuron = Math.min(DNeuronW, DNeuronH, Size.DMaxNeuron);//Выбираем минимальный диаметр
    //console.log("Size.DNeuron=" + Size.DNeuron);

    Size.GapNeuronH = (GBoxH - LayerN * Size.DNeuron) / (LayerN - 1); //Уточняем зазор между кружками нейронов по вертикали.
    //console.log("Size.GapNeuronH=" + Size.GapNeuronH);

    Size.RNeuron = (Size.DNeuron - Size.LineWidth) / 2;//Радиус нейрона.
    //console.log("Size.RNeuron=" + Size.RNeuron);
    //console.log("Size.RNeuron=" + Size.RNeuron);

    let AxonCon = [];//Массив объектов. i соответствует аксона AxonCon[ID аксона].
    //AxonColor[ID аксона] = *.From = ID нейрона из которого вышел этот аксон; *.To = ID нейрона в который зайдет этот аксон;
    //Заполняем массив.
    for (let IDNeuron = 0; IDNeuron < NNSet.NN.Neuron.length; IDNeuron++) {
        if (NNSet.NN.Neuron[IDNeuron] == undefined) {
            console.log("undefined IDNeuron=" + IDNeuron);
            continue
        }
        if (NNSet.NN.Neuron[IDNeuron].NLayers != 0) {//Все нейроны кроме входящих нейронов (т.е. кроме первого слоя). 
            for (let NConnection = 0; NConnection < NNSet.NN.Neuron[IDNeuron].IDNeuronIn.length; NConnection++) {//перебор входящих нейронов
                IDAxon = NNSet.NN.Neuron[IDNeuron].IDAxonIn[NConnection];//ID аксона соединённого со входом текущего нейрона
                AxonCon[IDAxon] = {};
                AxonCon[IDAxon].From = NNSet.NN.Neuron[IDNeuron].IDNeuronIn[NConnection];//ID входящего нейрона
                AxonCon[IDAxon].To = IDNeuron;//ID текущего нейрона 
                //console.log(" NeuronWeight[IDNeuron]=" + NeuronWeight[IDNeuron]);
            }
        }
        //console.log(" AxonMaxWeightInLayer[nLayers]=" + AxonMaxWeightInLayer[nLayers]);
    }


    let NeuronPos = [];//Массив объектов. i соответствует ID нейрона NeuronPos[ID нейрона].
    //NeuronPos[ID нейрона] = *.T Координата центра окружности, вверх; *.L Координата центра окружности, лево; 
    //Заполняем массив.
    for (let nLayers = 0; nLayers < LayerN; nLayers++) {//Перебор слоёв
        let w = NNSetNNLayerN[nLayers] * (Size.DNeuron + Size.GapNeuronW) - Size.GapNeuronW;//Ширина слоя (габарит)
        let l0 = Size.GapWin + (GBoxW - w) / 2 + Size.RNeuron;//Координата центра окружности первого нейрона в слое
        let t0 = Size.GapWin + nLayers * (Size.DNeuron + Size.GapNeuronH) + Size.RNeuron;//Координата центра окружности всех нейронов в этом слое
        //let l0 = Size.GapWin + (GBoxW - w) / 2;//Координата лева окружности первого нейрона в слое
        //let t0 = Size.GapWin + nLayers * (Size.DNeuron + Size.GapNeuronH);//Координата верха окружности всех нейронов в этом слое
        for (let n = 0; n < NNSetNNLayerN[nLayers]; n++) {//Перебор нейронов в слое.
            let N = {};//Объект нейрона.
            N.T = t0;// Координата центра окружности, вверх
            N.L = l0 + n * (Size.DNeuron + Size.GapNeuronW);// Координата центра окружности, лево
            let IDNeuron = n + NNSetNNLayerID[nLayers];//Вычисляем оригинальный ID нейрона
            NeuronPos[IDNeuron] = N;
        }
    }

    let AxonPos = [];//Массив объектов. i соответствует ID аксона AxonPos[ID аксона].
    //AxonPos[ID аксона] = *.T1 *.L1 *.T2 *.L2 Координата точек, вверх и лево; 
    //Заполняем массив.
    for (let IDAxon = 0; IDAxon < AxonCon.length; IDAxon++) {

        let a = AxonCon[IDAxon]; //Axon[i]= объект: .in ID входящего нейрона; .out ID текущего нейрона;.IDAxon ID аксона соединённого со входом текущего нейрона; .Weight вес входящего аксона
        //Центра нейронов, которые соединит этот аксон.
        let T1 = NeuronPos[a.From].T;
        let L1 = NeuronPos[a.From].L;
        let T2 = NeuronPos[a.To].T;
        let L2 = NeuronPos[a.To].L;
        //Аксоны будут подходить к низу и вверху кружочков нейрона.
        T1 += Size.RNeuron;
        T2 -= Size.RNeuron;
        AxonPos[IDAxon] = {};
        AxonPos[IDAxon].T1 = T1;
        AxonPos[IDAxon].T2 = T2;
        AxonPos[IDAxon].L1 = L1;
        AxonPos[IDAxon].L2 = L2;
    }


    //Для нормализации внутри слоя.
    let NeuronWeightInLayerMax = [];//NeuronMaxWeightInLayer[№ слоя] = Максимальный модуль суммы всех весов(аксонов) входящих и выходящих в этот нейрон, в слое . 
    let NeuronWeightInLayerMin = [];//NeuronMaxWeightInLayer[№ слоя] = Максимальный модуль суммы всех весов(аксонов) входящих и выходящих в этот нейрон, в слое . 
    let NeuronWeight = [];//NeuronMaxWeightInLayer[IDNeuron] = Сумма всех весов(аксонов) входящих и выходящих в этот нейрон . 

    for (let IDNeuron = 0; IDNeuron < NNSet.NN.Neuron.length; IDNeuron++) {
        if (NNSet.NN.Neuron[IDNeuron] == undefined) {
            console.log("undefined IDNeuron=" + IDNeuron);
            continue
        }
        let nLayers = NNSet.NN.Neuron[IDNeuron].NLayers;// № слоя в котором находиться этот нейрон.

        //Инициализация массивов
        NeuronWeightInLayerMax[nLayers] = (NeuronWeightInLayerMax[nLayers] === undefined) ? -Infinity : NeuronWeightInLayerMax[nLayers];
        NeuronWeightInLayerMin[nLayers] = (NeuronWeightInLayerMin[nLayers] === undefined) ? Infinity : NeuronWeightInLayerMin[nLayers];
        NeuronWeight[IDNeuron] = 0;

        if (NNSet.NN.Neuron[IDNeuron].NLayers != 0) {//Все нейроны кроме входящих нейронов (т.е. кроме первого слоя). 
            for (let NConnection = 0; NConnection < NNSet.NN.Neuron[IDNeuron].IDAxonIn.length; NConnection++) {//перебор входящих нейронов

                IDAxon = NNSet.NN.Neuron[IDNeuron].IDAxonIn[NConnection];//ID аксона соединённого со входом текущего нейрона
                let Weight = NNSet.NN.Axon[IDAxon].Weight; //Вес выходящего аксона
                NeuronWeight[IDNeuron] += Math.abs(Weight);
            }
        }


        if (NNSet.NN.Neuron[IDNeuron].NLayers != NNSet.NN.LayerN.length - 1) {//Все нейроны кроме выходящих нейронов (т.е. кроме последнего слоя). 
            for (let NConnection = 0; NConnection < NNSet.NN.Neuron[IDNeuron].IDAxonOut.length; NConnection++) {//перебор входящих нейронов

                IDAxon = NNSet.NN.Neuron[IDNeuron].IDAxonOut[NConnection];//ID аксона соединённого со входом текущего нейрона
                let Weight = NNSet.NN.Axon[IDAxon].Weight; //Вес выходящего аксона
                NeuronWeight[IDNeuron] += Math.abs(Weight);

                //console.log(" ax.Weight=" + ax.Weight);
                //console.log(" NeuronWeight[IDNeuron]=" + NeuronWeight[IDNeuron]);
            }
        }

        //Максимальный модуль веса аксона в слое.
        if (NeuronWeightInLayerMax[nLayers] < NeuronWeight[IDNeuron]) {
            NeuronWeightInLayerMax[nLayers] = NeuronWeight[IDNeuron];
        }

        //Минимальный модуль веса аксона в слое.
        if (NeuronWeightInLayerMin[nLayers] > NeuronWeight[IDNeuron]) {
            NeuronWeightInLayerMin[nLayers] = NeuronWeight[IDNeuron];
        }


        //console.log(" NeuronMaxWeightInLayer[nLayers]=" + NeuronMaxWeightInLayer[nLayers]);
        //console.log(" AxonMaxWeightInLayer[nLayers]=" + AxonMaxWeightInLayer[nLayers]);
    }
    //console.log("NeuronWeightInLayerMin=" + NeuronWeightInLayerMin);
    //console.log("NeuronWeightInLayerMax=" + NeuronWeightInLayerMax);
    //console.log("NeuronWeight=" + NeuronWeight);



    //Для нормализации внутри слоя.
    let AxonWeightInLayerMax = []; //AxonMaxWeightInLayer[№ слоя] = Максимальный модуль веса аксона в слое. 
    let AxonWeightInLayerMin = []; //AxonMaxWeightInLayer[№ слоя] = Максимальный модуль веса аксона в слое. 


    for (let IDNeuron = 0; IDNeuron < NNSet.NN.Neuron.length; IDNeuron++) {
        if (NNSet.NN.Neuron[IDNeuron] == undefined) {
            console.log("undefined IDNeuron=" + IDNeuron);
            continue
        }

        if (NNSet.NN.Neuron[IDNeuron].NLayers == 0) {//Все нейроны кроме входящих нейронов (т.е. кроме первого слоя). 
            continue;
        }

        let nLayers = NNSet.NN.Neuron[IDNeuron].NLayers;// № слоя в котором находиться этот нейрон.

        //Инициализация массивов
        AxonWeightInLayerMax[nLayers] = (AxonWeightInLayerMax[nLayers] === undefined) ? -Infinity : AxonWeightInLayerMax[nLayers];
        AxonWeightInLayerMin[nLayers] = (AxonWeightInLayerMin[nLayers] === undefined) ? Infinity : AxonWeightInLayerMin[nLayers];

        for (let NConnection = 0; NConnection < NNSet.NN.Neuron[IDNeuron].IDAxonIn.length; NConnection++) {//перебор входящих нейронов

            IDAxon = NNSet.NN.Neuron[IDNeuron].IDAxonIn[NConnection];//ID аксона соединённого со входом текущего нейрона
            let Weight = NNSet.NN.Axon[IDAxon].Weight; //Вес выходящего аксона
            Weight = Math.abs(Weight);
            //Максимальный модуль веса аксона в слое.
            if (AxonWeightInLayerMax[nLayers] < Weight) {
                AxonWeightInLayerMax[nLayers] = Weight;
            }

            //Минимальный модуль веса аксона в слое.
            if (AxonWeightInLayerMin[nLayers] > Weight) {
                AxonWeightInLayerMin[nLayers] = Weight;
            }
        }


        //console.log(" NeuronMaxWeightInLayer[nLayers]=" + NeuronMaxWeightInLayer[nLayers]);
        //console.log(" AxonMaxWeightInLayer[nLayers]=" + AxonMaxWeightInLayer[nLayers]);
    }
    //console.log("AxonWeightInLayerMin=" + AxonWeightInLayerMin);
    //console.log("AxonWeightInLayerMax=" + AxonWeightInLayerMax);



    let NeuronColor = [];//Массив объектов. i соответствует ID нейрона NeuronColor[ID нейрона].
    //NeuronColor[ID нейрона] = *.ColorFill цвет заполнения в формате "rgba(" + R + "," + G + "," + B + "," + Transporent + ")"; *.ColorStroke цвет оконтовки круга
    //Заполняем массив.
    let NeuronColorFill = G.D.C.Palette[7];//Заполнение
    let NeuronColorStroke = G.D.C.Palette[0];//Окантовка
    for (let IDNeuron = 0; IDNeuron < NNSet.NN.Neuron.length; IDNeuron++) {
        if (NNSet.NN.Neuron[IDNeuron] == undefined) {
            console.log("undefined IDNeuron=" + IDNeuron);
            continue
        }
        let nLayers = NNSet.NN.Neuron[IDNeuron].NLayers;// № слоя в котором находиться этот нейрон.

        let Transporent = 1;
        if (NeuronWeightInLayerMax[nLayers] - NeuronWeightInLayerMin[nLayers] != 0) {
            Transporent = (NeuronWeight[IDNeuron] - NeuronWeightInLayerMin[nLayers]) / (NeuronWeightInLayerMax[nLayers] - NeuronWeightInLayerMin[nLayers]);//Нормализация выходные значения от 0 до +1

        }
        //Transporent = Math.pow(Transporent,2);
        Transporent = 0.95 * Transporent + 0.05;//Минимальная прозрачность
        NeuronColor[IDNeuron] = {};
        NeuronColor[IDNeuron].ColorStroke = "rgba(" + NeuronColorStroke[0] + "," + NeuronColorStroke[1] + "," + NeuronColorStroke[2] + ",1)";
        NeuronColor[IDNeuron].ColorFill = "rgba(" + NeuronColorFill[0] + "," + NeuronColorFill[1] + "," + NeuronColorFill[2] + "," + Transporent + ")";

        //console.log("NeuronColorFill=" + NeuronColor[IDNeuron].ColorFill);

    }


    let AxonColor = [];//Массив объектов. i соответствует ID аксона AxonColor[ID аксона].
    //AxonColor[ID аксона] = *.ColorStroke цвет в формате "rgba(" + R + "," + G + "," + B + "," + Transporent + ")";
    //Заполняем массив.
    let AxonColorStroke = G.D.C.Palette[8];//берюзовый
    for (let IDNeuron = 0; IDNeuron < NNSet.NN.Neuron.length; IDNeuron++) {
        if (NNSet.NN.Neuron[IDNeuron] == undefined) {
            console.log("undefined IDNeuron=" + IDNeuron);
            continue
        }
        let nLayers = NNSet.NN.Neuron[IDNeuron].NLayers;// № слоя в котором находиться этот нейрон.

        if (nLayers != 0) {//Все нейроны кроме входящих нейронов (т.е. кроме первого слоя). 
            for (let NConnection = 0; NConnection < NNSet.NN.Neuron[IDNeuron].IDAxonIn.length; NConnection++) {//перебор входящих нейронов

                IDAxon = NNSet.NN.Neuron[IDNeuron].IDAxonIn[NConnection];//ID аксона соединённого со входом текущего нейрона
                let Weight = NNSet.NN.Axon[IDAxon].Weight; //Вес выходящего аксона
                Weight = Math.abs(Weight);
                let Transporent = 1;
                if (AxonWeightInLayerMax[nLayers] - AxonWeightInLayerMin[nLayers] != 0) {
                    Transporent = (Weight - AxonWeightInLayerMin[nLayers]) / (AxonWeightInLayerMax[nLayers] - AxonWeightInLayerMin[nLayers]);//Нормализация выходные значения от 0 до +1
                }
                //Нормализация 1
                Transporent = Math.pow(Transporent, 2);//
                //Нормализация 2
                //let a = 2.0;
                //Transporent = 1.0 / (1 + Math.pow(Transporent / (1.0 - Transporent), a));


                let MinTransporent = 0.05 //Минимальная прозрачность
                let NAxon = NNSet.NN.LayerN[nLayers] * NNSet.NN.LayerN[nLayers - 1];//количество возможных наложений линий аксонов
                if (MinTransporent > 1.0 / NAxon) {
                    MinTransporent = 1.0 / NAxon;
                }

                Transporent = (1.0 - MinTransporent) * Transporent + MinTransporent;

                AxonColor[IDAxon] = {};

                AxonColor[IDAxon].ColorStroke = "rgba(" + AxonColorStroke[0] + "," + AxonColorStroke[1] + "," + AxonColorStroke[2] + "," + Transporent + ")";
                //console.log("AxonColor=" + AxonColor[IDAxon].ColorStroke);

            }
        }

        //console.log(" NeuronMaxWeightInLayer[nLayers]=" + NeuronMaxWeightInLayer[nLayers]);
        //console.log(" AxonMaxWeightInLayer[nLayers]=" + AxonMaxWeightInLayer[nLayers]);
    }


    //Type =  "Default" обычный график архитектуры | "Pruning" покажет удаляемые элементы для операции прореживания.  | "Extension" покажет добовляемые элементы для операции расширения. 
    switch (G.TypeArchitecturePlot) {
        case "Extension":// покажет добовляемые элементы для операции расширения. 
            let R = ExtensionArchitecturePlot(NeuronColor, AxonColor, NameNN);
            NeuronColor = R.NeuronColor;
            AxonColor = R.AxonColor;
            break;
        case "Pruning"://покажет удаляемые элементы для операции прореживания.
            let Rp = PruningArchitecturePlot(NeuronColor, AxonColor, NameNN);
            NeuronColor = Rp.NeuronColor;
            AxonColor = Rp.AxonColor;
            break;
        case "Default"://обычный график архитектуры
            break;
    }


    //2. Создаем CANVAS      
    let canvas = document.createElement("CANVAS");
    canvas.width = SizeWin.w;
    canvas.height = SizeWin.h;
    //вставляем в inDiv
    DivC.appendChild(canvas);
    //Присваиваем элементу контекст
    let context = canvas.getContext("2d");


    //Текущая трансформация
    Size.Scale = 1;
    Size.T0 = 0;
    Size.L0 = 0;

    //Применить трансформацию
    let Scale = 1;
    let T0 = 0;
    let L0 = 0;


    //Сразу первая прорисовка.
    let D = { NameNN: NameNN, NeuronPos: NeuronPos, AxonPos: AxonPos, NeuronColor: NeuronColor, AxonColor: AxonColor, Size: Size, context: context };
    ReDrawArchitecturePlot(D, T0, L0, Scale, DivC);
    EventArchitecturePlot(D, DivC);
}



function PruningArchitecturePlot(NeuronColor, AxonColor, NameNN) {
    let NNSet = G.NN.N[NameNN].Set;

    let AxonColorStroke = G.D.C.Palette[4];//красн
    let Transporent = 0.9;
    for (let IDNeuron = 0; IDNeuron < NNSet.NN.Neuron.length; IDNeuron++) { //перебор ID нейронов.

        if (NNSet.NN.Neuron[IDNeuron].NLayers == NNSet.NN.LayerN.length - 1) { //Это нейроны выходного слоя.
            continue;
        }

        //Вычисляем среднее значение по модулю всех входящих аксонов.
        let SumWeight = 0;
        for (let NConnection = 0; NConnection < NNSet.NN.Neuron[IDNeuron].IDAxonOut.length; NConnection++) {//перебор входящих нейронов
            let IDAxonOut = NNSet.NN.Neuron[IDNeuron].IDAxonOut[NConnection];
            SumWeight += Math.abs(NNSet.NN.Axon[IDAxonOut].Weight);
        }
        let Avg = SumWeight / NNSet.NN.Neuron[IDNeuron].IDAxonOut.length
        //нижняя граница
        let LowerLimit = Avg * G.PartDelete;

        //все значения, по модулю, которые ниже границы, удаляем.
        for (let NConnection = 0; NConnection < NNSet.NN.Neuron[IDNeuron].IDAxonOut.length; NConnection++) {//перебор входящих нейронов
            let IDAxonOut = NNSet.NN.Neuron[IDNeuron].IDAxonOut[NConnection];
            let Weight = Math.abs(NNSet.NN.Axon[IDAxonOut].Weight);

            if (Weight <= LowerLimit) {
                AxonColor[IDAxonOut].ColorStroke = "rgba(" + AxonColorStroke[0] + "," + AxonColorStroke[1] + "," + AxonColorStroke[2] + "," + Transporent + ")";

            }

        }


    }

    return { NeuronColor: NeuronColor, AxonColor: AxonColor };
}




function ExtensionArchitecturePlot(NeuronColor, AxonColor, NameNN) {
    let NNSet = G.NN.N[NameNN].Set;

    let FluctuationMax = -Infinity;
    let FluctuationMin = Infinity;


    for (let IDAxon = 0; IDAxon < NNSet.NN.Axon.length; IDAxon++) {

        if (FluctuationMax < NNSet.NN.Axon[IDAxon].Fluctuation) {
            FluctuationMax = NNSet.NN.Axon[IDAxon].Fluctuation;
        }
        if (FluctuationMin > NNSet.NN.Axon[IDAxon].Fluctuation) {
            FluctuationMin = NNSet.NN.Axon[IDAxon].Fluctuation;
        }
    }
    if (FluctuationMax == FluctuationMin) {
        return { NeuronColor: NeuronColor, AxonColor: AxonColor };
    }

    let Threshold = (FluctuationMax - FluctuationMin) * G.PartAdd + FluctuationMin;

    let NeuronColorFill = G.D.C.Palette[4];//фиолет
    let AxonColorStroke = G.D.C.Palette[4];//красн
    let Transporent = 0.9;

    for (let IDNeuron = 0; IDNeuron < NNSet.NN.Neuron.length; IDNeuron++) { //перебор ID нейронов.

        if (NNSet.NN.Neuron[IDNeuron].NLayers == 0) { //Это нейроны входного слоя.
            continue;
        }
        if (NNSet.NN.Neuron[IDNeuron].NLayers == NNSet.NN.LayerN.length - 1) { //Это нейроны выходного слоя.
            continue;
        }
        for (let NConnection = 0; NConnection < NNSet.NN.Neuron[IDNeuron].IDAxonIn.length; NConnection++) {//перебор входящих нейронов
            let IDAxonIn = NNSet.NN.Neuron[IDNeuron].IDAxonIn[NConnection];
            if (NNSet.NN.Axon[IDAxonIn].Fluctuation >= Threshold) {

                NeuronColor[IDNeuron].ColorFill = "rgba(" + NeuronColorFill[0] + "," + NeuronColorFill[1] + "," + NeuronColorFill[2] + "," + Transporent + ")";
                AxonColor[IDAxonIn].ColorStroke = "rgba(" + AxonColorStroke[0] + "," + AxonColorStroke[1] + "," + AxonColorStroke[2] + "," + Transporent + ")";

            }
        }


        for (let NConnection = 0; NConnection < NNSet.NN.Neuron[IDNeuron].IDAxonOut.length; NConnection++) {//перебор входящих нейронов
            let IDAxonOut = NNSet.NN.Neuron[IDNeuron].IDAxonOut[NConnection];
            if (NNSet.NN.Axon[IDAxonOut].Fluctuation >= Threshold) {

                NeuronColor[IDNeuron].ColorFill = "rgba(" + NeuronColorFill[0] + "," + NeuronColorFill[1] + "," + NeuronColorFill[2] + "," + Transporent + ")";
                AxonColor[IDAxonOut].ColorStroke = "rgba(" + AxonColorStroke[0] + "," + AxonColorStroke[1] + "," + AxonColorStroke[2] + "," + Transporent + ")";

            }
        }

    }


    return { NeuronColor: NeuronColor, AxonColor: AxonColor };
}


//Перерисовывает. D - нормальное положение и масштаб
function ReDrawArchitecturePlot(D, T0, L0, Scale) {


    let NeuronPos = D.NeuronPos;
    let AxonPos = D.AxonPos;
    let NeuronColor = D.NeuronColor;
    let AxonColor = D.AxonColor;

    let Size = D.Size;
    let context = D.context;
    let NameNN = D.NameNN;

    let NNSet = G.NN.N[NameNN].Set;


    if (Scale < 1) {
        Scale = 1;
        T0 = 0;
        L0 = 0;
    } else if (Scale > 500) {
        return;
    }



    //Очистка
    context.clearRect(0, 0, Size.w, Size.h);
    context.beginPath(); //canvas line clear
    //console.log("Size.w=" + Size.w + "Size.h=" + Size.h);
    //Трансформация NeuronPos
    let NeuronTPos = [];
    if (T0 != 0 || L0 != 0 || Scale != 1) {
        for (let IDNeuron = 0; IDNeuron < NeuronPos.length; IDNeuron++) {//Значения: 0,5 - 1
            NeuronTPos[IDNeuron] = {};//Объект нейрона
            NeuronTPos[IDNeuron].T = T0 + Scale * NeuronPos[IDNeuron].T;
            NeuronTPos[IDNeuron].L = L0 + Scale * NeuronPos[IDNeuron].L;
        }
    } else {
        NeuronTPos = NeuronPos;
    }


    let AxonTPos = [];
    if (T0 != 0 || L0 != 0 || Scale != 1) {
        for (let IDAxon = 0; IDAxon < AxonPos.length; IDAxon++) {//Значения: 0,5 - 1
            AxonTPos[IDAxon] = {};//Объект нейрона
            AxonTPos[IDAxon].T1 = T0 + Scale * AxonPos[IDAxon].T1;
            AxonTPos[IDAxon].L1 = L0 + Scale * AxonPos[IDAxon].L1;
            AxonTPos[IDAxon].T2 = T0 + Scale * AxonPos[IDAxon].T2;
            AxonTPos[IDAxon].L2 = L0 + Scale * AxonPos[IDAxon].L2;
        }
    } else {
        AxonTPos = AxonPos;
    }

    Size.Scale = Scale;
    Size.T0 = T0;
    Size.L0 = L0;
    //console.log(" Size.Scale=" + Size.Scale + " Size.T0=" + Size.T0 + " Size.L0=" + Size.L0);

    //Отрисовка Аксонов
    for (let IDAxon = 0; IDAxon < AxonTPos.length; IDAxon++) {
        //Центра нейронов, которые соединит этот аксон.
        let t1 = AxonTPos[IDAxon].T1;
        let l1 = AxonTPos[IDAxon].L1;
        let t2 = AxonTPos[IDAxon].T2;
        let l2 = AxonTPos[IDAxon].L2;
        //Аксоны будут подходить к низу и вверху кружочков нейрона.
        //t1 += Scale * Size.RNeuron;
        //t2 -= Scale * Size.RNeuron;

        //console.log(" ax.Weight=" + ax.Weight + " WeightTransporent=" + WeightTransporent);
        //Отрисовка аксонов.
        context.beginPath();
        context.moveTo(l1, t1);
        context.lineTo(l2, t2);
        context.strokeStyle = AxonColor[IDAxon].ColorStroke;
        context.lineCap = "round";
        context.stroke();
    }
    //Отрисовка Нейронов
    for (let IDNeuron = 0; IDNeuron < NeuronTPos.length; IDNeuron++) {
        let centerT = NeuronTPos[IDNeuron].T;
        let centerL = NeuronTPos[IDNeuron].L;
        let R = Scale * Size.RNeuron;//Радиус нейрона
        //console.log(" R=" + R);
        //отрисовка круга
        context.beginPath();
        //arc(x, y, radius, startAngle, endAngle, anticlockwise)
        context.arc(centerL, centerT, R, 0, 2 * Math.PI);
        // Толщина и цвет линии дуги
        context.lineWidth = Size.LineWidth;
        context.strokeStyle = NeuronColor[IDNeuron].ColorStroke;
        context.stroke();
        // Заливка
        context.fillStyle = NeuronColor[IDNeuron].ColorFill;
        context.fill();
    }



}

//События графика
function EventArchitecturePlot(D, DivC) {
    let NeuronPos = D.NeuronPos;
    let Size = D.Size;
    let context = D.context;
    let NameNN = D.NameNN;

    let NNSet = G.NN.N[NameNN].Set;


    //Масштабирование
    DivC.onwheel = function (event) {  //Колесико мыши+ фокус на контейнере графика 
        //*В местоположении курсора мыши будет центр масштабирования осей.
        //let DeltaMouse = 1 + event.deltaY / 500;//знаменатель-это скорость масштаба. event.deltaY возвращает от отрицательных до положительных значений.

        //*Значения event.deltaY: вниз (от 100 до более чем 2000 с шагом 100 ) вверх (от -100 до более чем -2000 с шагом 100) где 100-400 -нормальная 800 - быстро, а 2000 - удар шелбаном
        //console.log("event.deltaY=" + event.deltaY);
        let DeltaMouse = -event.deltaY / 275;//знаменатель-это обратная скорость масштаба. 100-быстро, 500-норма, 1000 медленно.
        DeltaMouse = DeltaMouse / (1 + Math.abs(DeltaMouse));      //Нормализация выходные значения от -1 до +1 (не включительно) где 0 это бездействие
        //console.log("1. DeltaMouse=" + DeltaMouse);
        if (DeltaMouse <= 0) {// Значения (от 0 до -1) преобразуем в (от 1 до 0);  
            DeltaMouse = 1 + DeltaMouse;
        } else {// Значения (от 0 до 1) преобразуем в (от 1 до +Infinity). 
            DeltaMouse = 1 / (1 - DeltaMouse);
        }
        Scale = DeltaMouse;

        //Центр масштабирования в пикселях. event.clientX - относительно вью порта. GetDivPS_Viewport(DivC).l - относительно вью порта
        //*В местоположении курсора мыши будет центр масштабирования осей.
        let MousePositionX = event.clientX - GetDivPS_Viewport(DivC).l;
        let MousePositionY = event.clientY - GetDivPS_Viewport(DivC).t;
        //console.log("MousePositionX=" + MousePositionX + "  MousePositionY=" + MousePositionY);


        T0 = MousePositionY - Scale * (MousePositionY - Size.T0);
        L0 = MousePositionX - Scale * (MousePositionX - Size.L0);

        Scale = Scale * Size.Scale;

        //console.log(" Scale=" + Scale + " T0=" + T0 + " L0=" + L0);

        ReDrawArchitecturePlot(D, T0, L0, Scale);

    }

    //Перетаскивание
    DivC.onmousedown = function (event) {//Клик на контейнере графика
        if (event.button != 0) {
            //нажата НЕ левая кнопка мыши. Срабатывание не происходит
            return;
        }
        let Start = {};
        Start.MousePositionX = event.pageX;
        Start.MousePositionY = event.pageY;
        //Движение за курсором
        document.onmousemove = function (event) {

            //Позиция курсора относительно начального значения (клика)
            let DX = event.pageX - Start.MousePositionX;
            let DY = event.pageY - Start.MousePositionY;


            T0 = Size.T0 + DY;
            L0 = Size.L0 + DX;

            Scale = Size.Scale;


            Start.MousePositionX = event.pageX;
            Start.MousePositionY = event.pageY;

            ReDrawArchitecturePlot(D, T0, L0, Scale);

            //console.log("Длительность = " + (Date.now() - StartTimer) / 1000 + " [c]");

        };
        //Прекращение движения
        document.onmouseup = StopDragnDropChart;
        document.oncontextmenu = StopDragnDropChart;
    };


}

