
//Обновление данных и отрисовка, если есть в списке G.C.S.Display
//Обновление ETHUSDT (2.9M свеч) 380-420мс -> 70(230)ms. 95% = f02
function UpdateDataChart(aName1, aName2, aData, aXunit, aYunit) {
    //Данные для графика. Пришедшее сообщение - это событие для создания или обновления графика
    //Data = входящая [X, Y,  ...]; выходящая [[X, Y],  ...]
    //Name1= Первое имя. Price/Convergence/Smooth/Compression/OutputData/OutputTest/NNOutTrade/NNOutTest/OrderTest/OrderTrade
    //Name2= Второе имя. Пара/имя НС/""
    //Name = Name1+Name2 - Уникальное имя графика. 
    //Yunit = Пара/1/convergence/Interval
    //Xunit = time/iteration
    //*Если Data пустая, то значения, скорее всего закончились.




    Manager_G_C_S_Display();


    if (!G.GUIChartLoad) {//Флаг загрузки пользовательских настроек графиков
        return;
    }


    let DataHandling = function (Name1, Name2, Data, Xunit, Yunit) {
        //console.log(" Данные для графика Name1 = " + Name1 + ". Name2 =" + Name2);
        //console.log(" Данные для графика Xunit = " + Xunit + ". Yunit =" + Yunit);

        let Name = Name1 + Name2;
        //console.log(" Данные для графика " + Name + ": Количество точек =" + Data.length / 2);
        if (Name == "OutputData0test") {//инфо блок
            //console.log(" Данные для графика " + Name + ": Количество точек =" + Data.length / 2);
            //console.log(" Данные для графика " + Name + ": Первая точка: X=" + Data[0] + " Y=" + Data[1]);
            //console.log(" Данные для графика " + Name + ": Последняя точка: X=" + Data[Data.length - 2] + " Y=" + Data[Data.length - 1]);
        }



        //Есть ли данные на график?  
        if (!(Name in G.C.N)) {//Данных на этот график нет. Создаём.                
            G.C.N[Name] = {};
            let GCNName = G.C.N[Name];//объект отрисовываемого графика
            GCNName.Data = [];
            //GCNName.Yunit = Yunit; // Единица. Если единица совпадает с другими данными, то ось становиться общая для этих графиков.
            // GCNName.Xunit = Xunit; // Единица. Если единица совпадает с другими данными, то ось становиться общая для этих графиков.
            GCNName.Name1 = Name1;
            GCNName.Name2 = Name2;
            G.Page.ChartSetUpDate = true;//Изменились ли данные окна настройки графика
            //Инициализация подобъектов
            GCNName.X = {};
            GCNName.Y = {};
            GCNName.X.AutoScale = true;
            GCNName.Y.AutoScale = true;
            //let iRandomPalette = Math.round(Math.random() * (G.D.C.Palette.length - 1));//случайный индекс цвета

            //В независимости от наличия сохраненных пользовательских настроек, установка параметров:
            switch (Name1) {
                case "ConvergenceAverage":
                    GCNName.Title = G.L[G.S.L].g01;//"Сходимость средняя"
                    GCNName.Xunit = "iteration";
                    GCNName.Yunit = "convergence";
                    break;
                case "ConvergenceNoSignal":
                    GCNName.Title = G.L[G.S.L].g02;//"Сходимость нет сигнала"
                    GCNName.Xunit = "iteration";
                    GCNName.Yunit = "convergence";
                    break;
                case "ConvergenceBuy":
                    GCNName.Title = G.L[G.S.L].g08;//"Сходимость покупка"
                    GCNName.Xunit = "iteration";
                    GCNName.Yunit = "convergence";
                    break;
                case "ConvergenceSale":
                    GCNName.Title = G.L[G.S.L].g07;//"Сходимость продажа";
                    GCNName.Xunit = "iteration";
                    GCNName.Yunit = "convergence";
                    break;
                case "Price":
                    GCNName.Title = G.L[G.S.L].Price;//"Цена"
                    GCNName.Xunit = "time";
                    GCNName.Yunit = Name2;
                    break;
                case "Compression":
                    GCNName.Title = G.L[G.S.L].g03;//"компрессия"
                    GCNName.Xunit = "time";
                    {
                        let NameNN = Name2;
                        let NNSet = G.NN.N[NameNN].Set;
                        let Symbol = NNSet.DataStatisticSymbol
                        GCNName.Yunit = Symbol;
                    }
                    break;
                case "Smooth":
                    GCNName.Title = G.L[G.S.L].g04;//"сглаженность"
                    GCNName.Xunit = "time";
                    {
                        let NameNN = Name2;
                        let NNSet = G.NN.N[NameNN].Set;
                        let Symbol = NNSet.DataStatisticSymbol
                        GCNName.Yunit = Symbol;
                    }
                    break;
                case "OutputData"://выходящие данные для обучения НС в окне настройки данных
                case "OutputTest"://выходящие данные для обучения НС в тесте
                    GCNName.Title = G.L[G.S.L].g05;//"выход"
                    GCNName.Xunit = "time";
                    GCNName.Yunit = "100";
                    /**/
                    GCNName.Y.AutoScale = false;
                    GCNName.Y.DisplayMin = -100;
                    GCNName.Y.DisplayMax = 100;
                    break;
                case "NNOutTrade"://Ответ НС в торговле
                case "NNOutTest"://Ответ НС в тесте
                    GCNName.Title = G.L[G.S.L].g06;//"ответ НС"
                    GCNName.Xunit = "time";
                    GCNName.Yunit = "100";
                    /**/
                    GCNName.Y.AutoScale = false;
                    GCNName.Y.DisplayMin = -100;
                    GCNName.Y.DisplayMax = 100;
                    break;
                case "NNOutSum":
                    GCNName.Title = G.L[G.S.L].Signal;//"Сигнал"
                    GCNName.Xunit = "time";
                    GCNName.Yunit = "100";
                    break;
                case "OrderTest"://Сделки в тесте
                    GCNName.Title = G.L[G.S.L].t3;// = "Сделки";
                    GCNName.Xunit = "time";
                    GCNName.Yunit = "100";
                    /**/
                    GCNName.Y.AutoScale = false;
                    GCNName.Y.DisplayMin = -100;
                    GCNName.Y.DisplayMax = 100;
                    break;
                case "Interval"://состоит из 2х точек Х от и до. Образуют полупрозрачный прямоугольник
                    GCNName.Title = G.L[G.S.L].Interval;//"Интервал"
                    GCNName.Data = [[Data[0], 0], [Data[1], 1]];
                    Data = [];
                    GCNName.Y.AutoScale = false;
                    GCNName.Y.DisplayMin = 0;
                    GCNName.Y.DisplayMax = 1;
                    break;
                default:
                    console.log("ОШИБКА!!! Неизвестный график " + Name1);

            }



            if (Name in G.GUIChart) {//Есть пользовательские настройки.     
                GCNName.Type = G.GUIChart[Name].Type;
                GCNName.ColorR = G.GUIChart[Name].ColorR;
                GCNName.ColorG = G.GUIChart[Name].ColorG;
                GCNName.ColorB = G.GUIChart[Name].ColorB;
                GCNName.ColorA = G.GUIChart[Name].ColorA;
                //console.log(" Данные для графика  GCNName.Name1 = " + GCNName.Name1 + " GCNName.Name2 = " + GCNName.Name2 + ". GCNName.Title =" + GCNName.Title);
            } else {//Нет пользовательских настроек.  Настройки внешнего вида по умолчанию. 

                switch (Name1) {
                    case "ConvergenceAverage":
                        GCNName.Type = "Line";
                        GCNName.ColorR = 0;//черный
                        GCNName.ColorG = 0;
                        GCNName.ColorB = 0;
                        GCNName.ColorA = 1;
                        // GCNName.Title = "средняя";
                        //GCNName.Color = "rgb(" + Math.round(Math.random() * 255) + "," + Math.round(Math.random() * 255) + "," + Math.round(Math.random() * 225) + ")";
                        break;
                    case "ConvergenceNoSignal":
                        GCNName.Type = "Line";
                        GCNName.ColorR = G.D.C.Palette[2][0];//серый
                        GCNName.ColorG = G.D.C.Palette[2][1];
                        GCNName.ColorB = G.D.C.Palette[2][2];
                        GCNName.ColorA = 1;
                        //GCNName.Title = "нет сигнала";
                        //GCNName.Color = "rgb(" + Math.round(Math.random() * 255) + "," + Math.round(Math.random() * 255) + "," + Math.round(Math.random() * 225) + ")";
                        break;
                    case "ConvergenceBuy":
                        GCNName.Type = "Line";
                        GCNName.ColorR = G.D.C.Palette[4][0];
                        GCNName.ColorG = G.D.C.Palette[4][1];//красный
                        GCNName.ColorB = G.D.C.Palette[4][2];
                        GCNName.ColorA = 1;
                        //GCNName.Title = "покупка";
                        //GCNName.Color = "rgb(" + Math.round(Math.random() * 255) + "," + Math.round(Math.random() * 255) + "," + Math.round(Math.random() * 225) + ")";
                        break;
                    case "ConvergenceSale":
                        GCNName.Type = "Line";
                        GCNName.ColorR = G.D.C.Palette[7][0];//зеленый
                        GCNName.ColorG = G.D.C.Palette[7][1];
                        GCNName.ColorB = G.D.C.Palette[7][2];
                        GCNName.ColorA = 1;
                        //GCNName.Title = "продажа";
                        //GCNName.Color = "rgb(" + Math.round(Math.random() * 255) + "," + Math.round(Math.random() * 255) + "," + Math.round(Math.random() * 225) + ")";
                        break;
                    case "Price":
                        GCNName.Type = "Box";
                        GCNName.ColorR = G.D.C.Palette[2][0];//серый
                        GCNName.ColorG = G.D.C.Palette[2][1];
                        GCNName.ColorB = G.D.C.Palette[2][2];
                        GCNName.ColorA = 1;
                        //GCNName.Title = "цена";
                        break;
                    case "Compression":
                        GCNName.Type = "Dot";
                        GCNName.ColorR = 0;//черный
                        GCNName.ColorG = 0;
                        GCNName.ColorB = 0;
                        GCNName.ColorA = 1;
                        //GCNName.Title = "компрессия";
                        break;
                    case "Smooth":
                        GCNName.Type = "Line";
                        GCNName.ColorR = G.D.C.Palette[6][0];//желтый
                        GCNName.ColorG = G.D.C.Palette[6][1];
                        GCNName.ColorB = G.D.C.Palette[6][2];
                        GCNName.ColorA = 1;
                        //GCNName.Title = "сглаженность";
                        break;
                    case "OutputData"://выходящие данные для обучения НС в окне настройки данных
                    case "OutputTest"://выходящие данные для обучения НС в тесте
                        GCNName.Type = "Line";
                        GCNName.ColorR = G.D.C.Palette[7][0];//зеленый
                        GCNName.ColorG = G.D.C.Palette[7][1];
                        GCNName.ColorB = G.D.C.Palette[7][2];
                        GCNName.ColorA = 1;
                        /*
                        GCNName.Y.AutoScale = false;
                        GCNName.Y.DisplayMin = -100;
                        GCNName.Y.DisplayMax = 100;
                        */
                        //GCNName.Title = "выход";
                        break;
                    case "NNOutTrade"://Ответ НС в торговле
                    case "NNOutTest"://Ответ НС в тесте
                        GCNName.Type = "LineSeparated";
                        GCNName.ColorR = G.D.C.Palette[9][0];//голубой
                        GCNName.ColorG = G.D.C.Palette[9][1];
                        GCNName.ColorB = G.D.C.Palette[9][2];
                        GCNName.ColorA = 1;
                        /*
                        GCNName.Y.AutoScale = false;
                        GCNName.Y.DisplayMin = -100;
                        GCNName.Y.DisplayMax = 100;
                        */
                        //GCNName.Title = "ответ НС";
                        break;
                    case "NNOutSum":
                        GCNName.Type = "LineSeparated";
                        GCNName.ColorR = G.D.C.Palette[4][0]; //красный
                        GCNName.ColorG = G.D.C.Palette[4][1];
                        GCNName.ColorB = G.D.C.Palette[4][2];
                        GCNName.ColorA = 1;
                        /*
                        GCNName.Y.AutoScale = false;
                        GCNName.Y.DisplayMin = -100;
                        GCNName.Y.DisplayMax = 100;
                        */
                        //GCNName.Title = "сигнал";
                        break;
                    case "OrderTest"://Сделки в тесте
                        GCNName.Type = "Dot";
                        GCNName.ColorR = 0;//черный
                        GCNName.ColorG = 0;
                        GCNName.ColorB = 0;
                        GCNName.ColorA = 1;
                        //GCNName.Title = "сделки";
                        break;
                    case "Interval"://состоит из 2х точек Х от и до. Образуют полупрозрачный прямоугольник
                        GCNName.Type = "Interval";
                        GCNName.ColorR = 0;
                        GCNName.ColorG = 255;
                        GCNName.ColorB = 0;
                        GCNName.ColorA = 0.1;
                        /*
                        GCNName.Data = [[Data[0], 0], [Data[1], 1]];
                        Data = [];
                        GCNName.Y.AutoScale = false;
                        GCNName.Y.DisplayMin = 0;
                        GCNName.Y.DisplayMax = 1;
                        */
                        //GCNName.Title = "интервал";
                        break;
                    default:
                        console.log("ОШИБКА!!! Неизвестный график " + Name1);

                }
                //console.log(" Данные для графика GCNName.Name2 = " + GCNName.Name2 + ". GCNName.Title =" + GCNName.Title);

            }

        }
        let GCNName = G.C.N[Name];//объект отрисовываемого графика
        if (GCNName.Data.length) {
            //console.log("Количество точек графика до обновления" + GCNName.Data.length + ". Последняя точка: X=" + GCNName.Data[GCNName.Data.length - 1][0] + " Y=" + GCNName.Data[GCNName.Data.length - 1][1]);
        }

        //Преобразуем массив в двумерный. Из [X, Y,  ...] в [[X, Y],  ...]
        let DataNew = []; // Пришедшие данные
        let f0_0 = function () {
            for (let i = 0; i < Data.length; i = i + 2) {
                DataNew.push([Data[i], Data[i + 1]]);
            }
        }
        f0_0();//
        //console.log(" Данные для графика " + Name + ": Количество точек =" + DataNew.length);


        //Объединение данных
        let f1_1 = function () {
            //При условии что оба массива упорядочены, нужно просто сопрячь их по их границам.
            //Первый и последний X нового массива
            let XNewStart = undefined;
            let XNewStop = undefined;
            if (DataNew.length != 0) {//Данные не пустые
                XNewStart = DataNew[0][0];
                XNewStop = DataNew[DataNew.length - 1][0];
            }
            //Первый и последний X старого массива
            let XOldStart = undefined;
            let XOldStop = undefined;
            if (GCNName.Data.length != 0) {//До этого график имел данные
                //console.log("GCNName.Data.length=" + GCNName.Data.length);
                XOldStart = GCNName.Data[0][0];
                XOldStop = GCNName.Data[GCNName.Data.length - 1][0];
            }
            //console.log("XNewStart=" + XNewStart / 1000 + ", XOldStart=" + XOldStart / 1000 + ", XNewStop=" + XNewStop / 1000 + ", XOldStop=" + XOldStop / 1000);
            //Ошибка, последовательность :
            //XNewStart=1692464640, XOldStart=NaN, XNewStop=1692464640, XOldStop=NaN
            //XNewStart=1692464640, XOldStart=1692464640, XNewStop=1692464640, XOldStop=1692464640
            //XNewStart=1502942400, XOldStart=1692464640, XNewStop=1692464640, XOldStop=1692464640
            switch (true) {
                case XNewStart == undefined && XOldStart == undefined://Данных не было и пришли пустые данные
                    {
                        //console.log("Объединение данных: Данных не было и пришли пустые данные");
                        return
                    }
                case XNewStart == undefined://Пришли пустые данные
                    {
                        //console.log("Объединение данных: Пришли пустые данные");
                    }
                    break;
                case XOldStart == undefined://Новый график, старого не было
                    {
                        //console.log("Объединение данных: Новый график");
                        GCNName.Data = DataNew;//Замена старого массива на новый
                    }
                    break;
                case XNewStart <= XOldStart && XNewStop >= XOldStop://Новый массив больше или равен старому с двух сторон.
                    {
                        //console.log("Объединение данных: Новый массив больше или равен старому с двух сторон.");
                        GCNName.Data = DataNew;//Замена старого массива на новый
                    }
                    break;
                case XOldStart == XNewStart && XOldStop > XNewStop://Старый массив больше нового с правой стороны.
                    {
                        //console.log("Объединение данных: Старый массив больше нового с правой стороны.");
                        //Ищем мндексы в старом массиве, которые соответствуют граничным значениям нового
                        let iStop;
                        for (let i = GCNName.Data.length - 1; i >= 0; i--) {
                            if (GCNName.Data[i][0] <= XNewStop) {
                                iStop = i;
                                break;
                            }
                        }
                        //Извлекаем из старого массива часть вышедшие за границы нового 
                        let DataP2 = GCNName.Data.slice(iStop + 1); //подрезаем       
                        GCNName.Data = [...DataNew, ...DataP2];//Объединяем
                    }
                    break;
                case XOldStart < XNewStart && XOldStop == XNewStop://Старый массив больше нового с левой стороны.
                    {
                        //console.log("Объединение данных: Старый массив больше нового с левой стороны.");
                        if (DataNew.length == 1) { // Авто обновление. Пришёл 1 элемент (До этого график имел данные)    
                            //console.log("Объединение данных: Авто обновление. Пришёл 1 элемент на замену старому.");
                            GCNName.Data[GCNName.Data.length - 1] = DataNew[0];//Пришедший элемент заменяет последний элемент имеющихся данных
                        } else {//это не Авто обновление.
                            //console.log("Объединение данных: Старый массив больше нового с левой стороны.");
                            //Ищем индексы в старом массиве, которые соответствуют граничным значениям нового
                            let iStart;
                            for (let i = 0; i < GCNName.Data.length; i++) {
                                if (GCNName.Data[i][0] >= XNewStart) {
                                    iStart = i;
                                    break;
                                }
                            }

                            //Извлекаем из старого массива часть вышедшие за границы нового 
                            let DataP1 = GCNName.Data.slice(0, iStart); //подрезаем       
                            GCNName.Data = [...DataP1, ...DataNew];//Объединяем
                        }
                    }
                    break;
                case XOldStart < XNewStart && XOldStop > XNewStop://Старый массив больше нового с двух сторон.
                    {
                        //console.log("Объединение данных: Старый массив больше нового с двух сторон.");
                        //Ищем мндексы в старом массиве, которые соответствуют граничным значениям нового
                        let iStart;
                        for (let i = 0; i < GCNName.Data.length; i++) {
                            if (GCNName.Data[i][0] >= XNewStart) {
                                iStart = i;
                                break;
                            }
                        }
                        let iStop;
                        for (let i = GCNName.Data.length - 1; i >= 0; i--) {
                            if (GCNName.Data[i][0] <= XNewStop) {
                                iStop = i;
                                break;
                            }
                        }
                        //Извлекаем из старого массива часть вышедшие за границы нового 
                        let DataP1 = GCNName.Data.slice(0, iStart); //подрезаем       
                        let DataP2 = GCNName.Data.slice(iStop + 1); //подрезаем       
                        GCNName.Data = [...DataP1, ...DataNew, ...DataP2];//Объединяем
                    }
                    break;
                case XOldStop < XNewStart://Новый массив идет после старого.
                    {
                        if (DataNew.length == 1) { // Авто обновление. Пришёл 1 элемент (До этого график имел данные)     
                            //console.log("Объеденение данных: Авто обновление. Пришёл 1 элемент на добавление к старому.");
                            GCNName.Data.push(DataNew[0]);//Пришедший элемент добавляется в конец имеющихся данным
                        } else {//это не Авто обновление.
                            //console.log("Объединение данных: Новый массив идет после старого.");
                            GCNName.Data = [...GCNName.Data, ...DataNew];//Объединяем
                        }
                    }
                    break;
                case XOldStart > XNewStop://Старый массив идет после нового.
                    {
                        // console.log("Объеденение данных: Старый массив идет после нового.");
                        GCNName.Data = [...DataNew, ...GCNName.Data];//Объединяем
                    }
                    break;
                default:
                    console.log("Объединение данных: ОШИБКА!!! Неизвестная комбинация данных");
                    //Добавим к старым данным
                    GCNName.Data = [...GCNName.Data, ...DataNew];

                    //Отсортируем массив по X, так чтобы было удобно его перебирать
                    let f1 = function () {
                        let compareX = function (a, b) { //Сортируем массив по X [0]
                            if (a[0] > b[0]) return 1;
                            if (a[0] < b[0]) return -1;
                        };
                        GCNName.Data.sort(compareX);
                    }
                    f1();//Обновление ETHUSDT (2.9M свеч) 105-120ms !!! Не уменьшается при уменьшении интервала !!!

                    //удалить дубликаты по X. 
                    let f2 = function () {
                        for (let i = 0; i < GCNName.Data.length - 1; i++) {
                            if (GCNName.Data[i][0] == GCNName.Data[i + 1][0]) {
                                GCNName.Data.splice(i, 1); //Удаляет элементы начиная с i 1 шт.         
                                i--;
                            }
                            //if (i == Math.round(GCNName.Data.length / 1000) || i == Math.round(GCNName.Data.length / 100) || i == Math.round(GCNName.Data.length / 10)) {
                            //console.log("i=" + i);
                            //}
                        }
                    }
                    f2();//Обновление ETHUSDT (2.9M свеч) 33ms 
                //console.log("Стало элементов = " + GCNName.Data.length);

            }
        }
        f1_1();//Обновление ETHUSDT (2.9M свеч) 33ms 


        //console.log(" Данные для графика " + Name + ": Количество точек =" + DataNew.length);


    }


    if (Array.isArray(aName1)) {
        //Name1 это массив, значит обновляються сразу несколько графиков
        //console.log(" Количество графиков =" + aName1.length);

        for (let i = 0; i < aName1.length; i++) {
            let Name1 = aName1[i];
            let Name2 = aName2[i];
            let Data = aData[i];
            let Xunit = aXunit[i];
            let Yunit = aYunit[i];
            DataHandling(Name1, Name2, Data, Xunit, Yunit);
        }
        for (let i = 0; i < aName1.length; i++) {
            let Name1 = aName1[i];
            let Name2 = aName2[i];
            let Name = Name1 + Name2;
            if (G.C.S.Display.includes(Name)) {
                //Name найден в G.C.S.Display
                DrawChart();//Отрисовка графика
                break;

            }

        }
    } else {
        //Name1 это не массив, значит обновляються сразу несколько графиков
        let Name1 = aName1;
        let Name2 = aName2;
        let Data = aData;
        let Xunit = aXunit;
        let Yunit = aYunit;
        DataHandling(Name1, Name2, Data, Xunit, Yunit);

        let Name = Name1 + Name2;
        //Отрисовка графика, если есть в G.C.S.Display
        for (let i = 0; i < G.C.S.Display.length; i++) {
            if (G.C.S.Display[i] == Name) {
                DrawChart();//Отрисовка графика
                break;
            }
        }

    }










    // }

}


//Подготавливаем для отрисовки. Запуск при первой отрисовке. Инициализация.
//Вызов при: Обновление данных, новая отрисовка.
function DrawChart() {
    //console.log("DrawChart()  ");

    //0. Очищаем
    //1. Получаем размеры графической части.
    //2. Создаем CANVAS  
    //3. Верификация.   
    //4. Абсолютное наибольшее и наименьшее значение по X.  
    //5. Для старых графиков изменяем область отображаемых данных, в случае если включено авто обновление. 
    //6. Для новых графиков, вычисляем недостающие свойства.
    //7. Перерисовываем, включаем обработчик событий, отображаем окно настроек.

    if (G.C.DivContainer == undefined) {//При старте приходят данные графика, а окна еще не построены
        return;
    }

    Manager_G_C_S_Display();

    if (G.C.ChartType != "Standard") {//После графиков другого типа ( Architecture, Trigger)
        ChartWin("Standard");
    }
    ChartStandardSet();//отображено окно настроек
    //console.log("G.C.DivC=" + G.C.DivC);

    //console.log("DrawChart");
    //console.log("G.C.S.Display = "+G.C.S.Display);

    let DivC = G.C.DivC;
    //0.Очишаем
    DivC.innerHTML = "";
    //1. Получаем размеры графической части.
    let CanvasSize = GetDivSizeContent(DivC);
    //2. Создаем CANVAS      
    let canvas = document.createElement("CANVAS");
    canvas.width = CanvasSize.w;
    canvas.height = CanvasSize.h;
    //canvas.width = CanvasSize.w*2;
    //canvas.height = CanvasSize.h*2;

    //вставляем в inDiv
    DivC.appendChild(canvas);
    //Присваиваем элементу контекст
    G.C.Сontext = canvas.getContext("2d");
    //G.C.Сontext.translate(0.5, 0.5);//Смещает все пикселы на 0,5 для контраста

    //G.C.Сontext.scale(0.5, 0.5);

    //console.log("canvas.width = " + canvas.width);
    // console.log("canvas.height= " +  canvas.height);
    //console.log("window.devicePixelRatio= " + window.devicePixelRatio);

    //3. Верификация.   
    G.C.S.Display = UniqueValuesArray(G.C.S.Display); //Удаляем дубликаты из G.C.S.Display

    let DrawChartElement = false; //Проверяем, есть ли что отображать
    for (let i = 0; i < G.C.S.Display.length; i++) {
        Name = G.C.S.Display[i];
        if (Name in G.C.N) {
            let GCNName = G.C.N[Name];//объект отрисовываемого графика
            if (GCNName.Data.length > 0) {
                DrawChartElement = true;
                break
            }
        }
    }
    if (!DrawChartElement) {
        return;
    }

    //4. Абсолютное наибольшее и наименьшее значение по X.  
    let AbsoluteMax = -Infinity;
    let AbsoluteMin = Infinity;
    //for (let Name in G.C.N) {
    for (let Name of G.C.S.Display) {
        if (Name in G.C.N) {
            let GCNName = G.C.N[Name];//объект отрисовываемого графика
            let Max = GCNName.Data[GCNName.Data.length - 1][0];
            if (AbsoluteMax < Max) { //В перебираемых графиках, текущие данные больше, ранее найденных.
                AbsoluteMax = Max;
            }
            let Min = GCNName.Data[0][0];
            if (AbsoluteMin > Min) {//В перебираемых графиках, текущие данные больше, ранее найденных
                AbsoluteMin = Min;
            }
        }
    }
    //console.log("AbsoluteMax = " + AbsoluteMax + "; X.AbsoluteMax = " + AbsoluteMin);


    //Сдвиг графика по оси X
    //Применяется, если - Увеличилось абсолютное наибольшее значение по X (слева добавились данные), и включено автообновление X.AutoScale=true
    //При условии:
    //1. До этого события, график уже отображался, т.е. были.X.DisplayMax и X.DisplayMin
    //2. Нет других графиков с большим абсолютным значением по X
    let Shift = 0; // величина сдвига графика по оси X.
    for (let Name of G.C.S.Display) {
        if (Name in G.C.N) {
            let GCNName = G.C.N[Name];//объект отрисовываемого графика
            if (AbsoluteMax == GCNName.Data[GCNName.Data.length - 1][0]) {//Графики с текущим наибольшим AbsoluteMax
                if ("AbsoluteMax" in GCNName.X) {//До этого события, график уже отображался
                    if (GCNName.X.AutoScale) {//X.AutoScale=true                        
                        if (Shift < AbsoluteMax - GCNName.X.AbsoluteMax) {
                            Shift = AbsoluteMax - GCNName.X.AbsoluteMax;
                        }
                    }
                }
            }
        }
    }
    //console.log("Shift = " + Shift);

    //Применяем св-во ко всем графикам. Т.к. для всех отображаемых графиков единица оси Х - одна.
    for (let Name of G.C.S.Display) {
        if (Name in G.C.N) {
            let GCNName = G.C.N[Name];//объект отрисовываемого графика
            GCNName.X.AbsoluteMin = AbsoluteMin;
            GCNName.X.AbsoluteMax = AbsoluteMax;
        }
    }

    //5. Извлекаем X.DisplayMax и X.DisplayMin из ранее обрисовываемых графиков, если такие были.
    //По завершению этой функции X.DisplayMax и X.DisplayMin будут одинаковы для всех графиков.
    //В большинстве случаев, ожидается, что достаточно найти хотя бы в одном графики определенные X.DisplayMax и X.DisplayMin, и использовать их для всех остальных
    //Но мы будем учитывать, и то, что отображаемые два графика ранее могли состоять в двух разных группах, с разными X.DisplayMax и X.DisplayMin
    let XDisplayMax = -Infinity;
    let XDisplayMin = Infinity;
    for (let Name of G.C.S.Display) {//отслеживаем рассинхронизацию
        if (Name in G.C.N) {
            let GCNName = G.C.N[Name];//объект отрисовываемого графика
            if (("DisplayMin" in GCNName.X) && ("DisplayMax" in GCNName.X)) {//этот график ранее отрисовывался
                if (XDisplayMax < GCNName.X.DisplayMax) { //В перебираемых графиках, текущие данные больше, ранее найденных
                    XDisplayMax = GCNName.X.DisplayMax;
                }
                if (XDisplayMin > GCNName.X.DisplayMin) {//В перебираемых графиках, текущие данные больше, ранее найденных
                    XDisplayMin = GCNName.X.DisplayMin;
                }
            }
        }
    }
    //console.log("XDisplayMax = " + XDisplayMax + "; XDisplayMin = " + XDisplayMin);

    //Применяем св-во ко всем графикам. Т.к. для всех отображаемых графиков единица оси Х - одна.
    //Анализируем X.DisplayMax и X.DisplayMin. 
    if ((XDisplayMax == -Infinity || XDisplayMin == Infinity) || !MinNewDataOk(XDisplayMin, XDisplayMax)) {
        //ИЛИ: X.DisplayMax и X.DisplayMin не для одного графика, ранее не были определены. Это первая отрисовка, всех графиков.  
        //ИЛИ: Отображаемое количество точек ни у одного графика не больше или рано минимальному G.C.S.MinData  
        for (let Name of G.C.S.Display) {
            if (Name in G.C.N) {
                let GCNName = G.C.N[Name];//объект отрисовываемого графика
                //В область отображения войдут все данные: 
                GCNName.X.DisplayMin = GCNName.X.AbsoluteMin;
                GCNName.X.DisplayMax = DisplayMaxAutoScale(GCNName.X.DisplayMin);//График будет иметь зазор с права как указоно в G.C.S.WAutoScale
                //console.log("График = " + Name + ": X.DisplayMax = " + GCNName.X.DisplayMax + "; X.DisplayMin = " + GCNName.X.DisplayMin);
            }
        }
    } else {
        //И: Хотя бы для одного графика, ранее были определены X.DisplayMax и X.DisplayMin. Это не первая отрисовка, хотя бы для одного из графиков списка G.C.S.Display.  
        //И: Отображаемое количество точек ходя бы у одного графика больше минимального G.C.S.MinData. 
        if (Shift > 0) {//Применяеться X.AutoScale
            //console.log("Shift > 0, Shift=" + Shift);
            XDisplayMax = XDisplayMax + Shift;
            XDisplayMin = XDisplayMin + Shift;
            if (!MinNewDataOk(XDisplayMin, XDisplayMax)) {//Отображаемое количество точек ходя бы у одного графика больше минимального G.C.S.MinData. Нет:
                //console.log("!MinNewDataOk");
                XDisplayMin = XDisplayMin - Shift; //отменим сдвиг, получим расширение.
            }
            //console.log("XDisplayMax = " + XDisplayMax + "; XDisplayMin = " + XDisplayMin);
        }
        for (let Name of G.C.S.Display) {
            if (Name in G.C.N) {
                let GCNName = G.C.N[Name];//объект отрисовываемого графика
                GCNName.X.DisplayMax = XDisplayMax;
                GCNName.X.DisplayMin = XDisplayMin;
                //console.log("График = " + Name + ": X.DisplayMax = " + GCNName.X.DisplayMax + "; X.DisplayMin = " + GCNName.X.DisplayMin);
            }
        }
    }

    //6. Для новых графиков, вычисляем недостающие свойства.
    let DMin = false;
    for (let Name of G.C.S.Display) {//отслеживаем рассинхронизацию
        if (Name in G.C.N) {
            let GCNName = G.C.N[Name];//объект отрисовываемого графика
            if (DMin) {
                if (DMin != GCNName.X.DisplayMin) {
                    console.log("***********Рассинхронизация GCNName.X.DisplayMin");
                    break;
                }
            } else {
                DMin = GCNName.X.DisplayMin;
            }
        }
    }

    //7. Перерисовываем, включаем обработчик событий, отображаем окно настроек.
    //let StartTimer = Date.now();
    ReDrawChart();
    //console.log("Длительность ReDrawChart();= " + (Date.now() - StartTimer) / 1000 + " [c]");    
    ChartEvent(CanvasSize);//События графика
    //ChartStandardSet();//отображено окно настроек
}


//Перерисовка.
//Вызов при: перемещение, масштабирование, изменения цвета, типа, прозрачности. 
//Обновление ETHUSDT (2.9M свеч) 61-63ms. Быстрее старой версии, но алгоритм не доработан, есть баги, иногда не отображается график.
function ReDrawChart() {
    //Шапка
    ChartStandardTop();
    //1. Оптимизация. Убираем неотображаемые точки.
    //3. Синхронизация осей
    //4. Карта, соответствия координатам [пиксель] и элементам данных, для событий и построения.
    //5. Прорисовка.
    let DivC = G.C.DivC;
    let CanvasSize = GetDivSizeContent(DivC);
    let context = G.C.Сontext;



    //Очистка
    context.clearRect(0, 0, CanvasSize.w, CanvasSize.h);
    context.beginPath(); //canvas line clear
    //console.log("CanvasSize.w = " + CanvasSize.w);
    //console.log("CanvasSize.h= " + CanvasSize.h);
    //console.log("window.devicePixelRatio= " + window.devicePixelRatio);


    //Вычисляем коэффициент, на который будем умножать значение, и получать пикселы. (сколько в 1 X единице - пикселей.)
    //1/Kpx= сколько в 1 пикселе - X единиц
    let f01 = function () {
        for (let Name of G.C.S.Display) {
            if (Name in G.C.N) {
                let GCNName = G.C.N[Name];//объект отрисовываемого графика
                GCNName.X.Kpx = CanvasSize.w / (GCNName.X.DisplayMax - GCNName.X.DisplayMin);
                //if (GCNName.X.DisplayMax - GCNName.X.DisplayMin != 0) {
                //    GCNName.X.Kpx = CanvasSize.w / (GCNName.X.DisplayMax - GCNName.X.DisplayMin);
                //} else {
                //    GCNName.X.Kpx = 0;
                //}

            }
        }
    }
    f01();//Обновление ETHUSDT (2.9M свеч) 0ms 




    //Оптимизация.
    //Пропуск неотображаемых точек. Когда между точками расстояние меньше 1 пикселя.
    //Алгоритм.
    //Создаем временную карту GCNName.Data, которая будет иметь промежуток от GCNName.X.DisplayMin -1 элемент до GCNName.X.DisplayMax +1 элемент
    //Сжатие. Вся ширина видимой области разбиваться на пары пикселей. 
    //Каждая пара пикселей — это результат сжатия множества элементов, которые входят в этот промежуток 2 пикселя.
    //В одном из пикселей будет минимальное значение по Y в другом максимальное. Порядок такой же, как и в оригинальном GCNName.Data.
    let DisplayDataCompressedX = {};//для каждого графика
    let DisplayDataCompressedY = {};
    let f02 = function () {
        for (let Name of G.C.S.Display) {
            if (Name in G.C.N) {
                let GCNName = G.C.N[Name];//объект отрисовываемого графика

                //if (Name == "OutputData0test") {//инфо блок
                //   console.log(" Данные для графика " + Name + ": Количество точек =" + GCNName.Data.length);
                //    console.log(" Данные для графика " + Name + ": GCNName.X.DisplayMin =" + GCNName.X.DisplayMin);
                //    console.log(" Данные для графика " + Name + ":  GCNName.Data[0][0] =" + GCNName.Data[0][0]);
                //}

                DisplayDataCompressedX[Name] = [];
                DisplayDataCompressedY[Name] = [];

                let DoublePixel = 2.0 / GCNName.X.Kpx;//Размер промежутка выраженный в единицах графика по Х, занимающий ширину 2 пикселя.
                //console.log("DoublePixel = " + DoublePixel + "(" + DurationMsToDate(DoublePixel) + ")");
                //console.log("X.DisplayMax-X.DisplayMin = " + (GCNName.X.DisplayMax - GCNName.X.DisplayMin) + "(" + DurationMsToDate(GCNName.X.DisplayMax - GCNName.X.DisplayMin) + ")");
                //console.log("X.DisplayMin = " + GCNName.X.DisplayMin + "; X.DisplayMax = " + GCNName.X.DisplayMax);

                let DoublePixelLimit = 0; //Точка окончания промежутка двойного пикселя, выраженный в единицах графика по Х
                //*Промежуто двойного пикселя это интервал от DoublePixelLimit-DoublePixel до DoublePixelLimit
                let Ymin = Infinity;
                let Ymax = -Infinity;
                let Imin, Xmin, Imax, Xmax;
                let NPoint = 0;

                for (let i = 0; i < GCNName.Data.length; i++) {//перебор всех данных
                    let X = GCNName.Data[i][0];
                    let Y = GCNName.Data[i][1];
                    let Stop = i == (GCNName.Data.length - 1);//Это последняя точка графика. Нужна для исключения ошибки в записи GCNName.Data[i + 1]
                    //Ищем первую точку и вычисляем первый DoublePixelLimit.
                    //Исключаем из карты все X меньше X.DisplayMin, но включаем 1 элемент за пределом X.DisplayMin если он есть
                    if (!Stop) {//не последняя точка
                        //Случай когда первая отображаемая точка за пределами видимой области. 
                        if (X < GCNName.X.DisplayMin) {//Текущий X не отображен на графике
                            if (GCNName.Data[i + 1][0] > GCNName.X.DisplayMin) {//Следующий X будет отображен на графике
                                //Первая точка компрессированных данных. Она не участвует в поиске мин и макс, а записывается как есть.
                                DisplayDataCompressedX[Name].push(X);
                                DisplayDataCompressedY[Name].push(Y);
                                DoublePixelLimit = GCNName.Data[i + 1][0] + DoublePixel;
                                //console.log("DoublePixelLimit = " + UnixToDate(DoublePixelLimit).date +" "+ UnixToDate(DoublePixelLimit).time);  
                            }
                            continue;
                        } else if (i == 0 && X >= GCNName.X.DisplayMin) { //Случай когда первая отображаемая точка есть первая в данных. 
                            //Первая точка компрессированных данных
                            //DoublePixelLimit = GCNName.Data[i + 1][0] + DoublePixel;
                            DoublePixelLimit = GCNName.Data[i][0] + DoublePixel;
                            //console.log("DoublePixelLimit = "  + UnixToDate(DoublePixelLimit).date +" "+ UnixToDate(DoublePixelLimit).time);
                            //if (Name == "OutputData0test") {//инфо блок
                            //    console.log("Промежуток двойного пикселя от " + (DoublePixelLimit - DoublePixel) + " до " + DoublePixelLimit);
                            //}
                        }
                    }
                    //Следующие точки находятся в диапазоне от X.DisplayMin, но могут быть больше X.DisplayMax

                    //Ищем два значения мин и макс, в текущем промежутке двойного пикселя (от (DoublePixelLimit - DoublePixel) до DoublePixelLimit]
                    //Когда промежуток двойного пикселя окончен, то Ymin и Ymax сбрасывается до начальных значений
                    //Т.к. начальные значения Ymin = Infinity и  Ymax = -Infinity, то первая  точка промежуток двойного пикселя запишется и в min и в max
                    if (Ymin > Y) {
                        Xmin = X;
                        Ymin = Y;
                        Imin = i;
                    }
                    if (Ymax < Y) {
                        Xmax = X;
                        Ymax = Y;
                        Imax = i;
                    }
                    NPoint++;
                    /*
                    if (Ymin == Infinity || Ymax == -Infinity) {
                        console.log("i = " + i);
                        console.log("Stop = " + Stop);
                        console.log("Ymin = " + Ymin + "; Ymax = " + Ymax);
                        console.log("X = " + X + "; GCNName.X.DisplayMax = " + GCNName.X.DisplayMax);
                        console.log("DoublePixel = " + DurationMsToDate(DoublePixel));
                        console.log("DoublePixelLimit = " + DoublePixelLimit);
                        console.log("DoublePixelLimit = " + UnixToDate(DoublePixelLimit).date + " " + UnixToDate(DoublePixelLimit).time);
                        console.log("GCNName.Data.length = " + GCNName.Data.length);
                        console.log("DisplayDataCompressedX[Name].length = " + DisplayDataCompressedX[Name].length);
                        console.log("DisplayDataCompressedY[Name].length = " + DisplayDataCompressedY[Name].length);
                    }
                    */

                    //Случай, когда последняя отображаемая точка вне видимой области. 
                    //Случай, когда последняя отображаемая точка в видимой области (авто обновления). 
                    if ((X > GCNName.X.DisplayMax) || (Stop)) {//точка X уже не отображен на графике ИЛИ это последняя точка
                        //Запись сжатой точки
                        if (Imin < Imax) {
                            DisplayDataCompressedX[Name].push(Xmin, X);
                            DisplayDataCompressedY[Name].push(Ymin, Y);
                        } else if (Imin > Imax) {
                            DisplayDataCompressedX[Name].push(Xmax, X);
                            DisplayDataCompressedY[Name].push(Ymax, Y);
                        } else {//Imin == Imax. т.е. в этом промежутке всего одна точка, или все точки лежат на горизонтальной лиеии
                            if (NPoint > 1) {
                                DisplayDataCompressedX[Name].push(Xmin, X);
                                DisplayDataCompressedY[Name].push(Ymin, Y);

                                if (Xmin == X) {//инфо блок
                                    console.log(" Xmin " + Xmin + " X=" + X);
                                }
                                /**/
                            } else {
                                DisplayDataCompressedX[Name].push(X);
                                DisplayDataCompressedY[Name].push(Y);
                            }
                            /*
                           DisplayDataCompressedX[Name].push(X);
                           DisplayDataCompressedY[Name].push(Y);
                           */

                        }
                        break;
                    }
                    //console.log("i = " + i);
                    if (!Stop) {//не последняя точка
                        if (GCNName.Data[i + 1][0] > DoublePixelLimit) {//Следующая точка уже не попадает в промежуток двойного пикселя
                            //Запись сжатой точки
                            if (Imin < Imax) {
                                DisplayDataCompressedX[Name].push(Xmin, Xmax);
                                DisplayDataCompressedY[Name].push(Ymin, Ymax);
                                /*
                                if (Xmin == Xmax) {//инфо блок
                                    console.log(" Xmin " + Xmin + " Xmax=" + Xmax);
                                }
                                */
                            } else if (Imin > Imax) {
                                DisplayDataCompressedX[Name].push(Xmax, Xmin);
                                DisplayDataCompressedY[Name].push(Ymax, Ymin);
                                /*
                                if (Xmin == Xmax) {//инфо блок
                                    console.log(" Xmin " + Xmin + " Xmax=" + Xmax);
                                }
                                */
                            } else {//Imin == Imax. т.е. в этом промежутке всего одна точка, или все точки лежат на горизонтальной лиеии
                                if (NPoint > 1) {
                                    DisplayDataCompressedX[Name].push(Xmin, X);
                                    DisplayDataCompressedY[Name].push(Ymin, Y);
                                    /*
                                    if (Xmin == X) {//инфо блок
                                        console.log(" Xmin " + Xmin + " X=" + X);
                                    }
                                    */
                                } else {
                                    DisplayDataCompressedX[Name].push(X);
                                    DisplayDataCompressedY[Name].push(Y);
                                }
                                /*
                               DisplayDataCompressedX[Name].push(X);
                               DisplayDataCompressedY[Name].push(Y);
                               */

                            }
                            DoublePixelLimit += DoublePixel;
                            Ymin = Infinity;
                            Ymax = -Infinity;
                            NPoint = 0;
                            //console.log("Запись сжатой точки i = " + i);
                        }
                    }
                }
                /*
                if (Name == "OutputData0test") {//инфо блок
                    console.log(" Оптимизация для графика " + Name + ": Количество точек X=" + DisplayDataCompressedX[Name].length);
                    console.log(" Оптимизация для графика " + Name + ": Количество точек Y=" + DisplayDataCompressedY[Name].length);
                }
                 if (Name.includes("NNOutTrade")) {//возвращает true, если в строке  есть подстрока 
                    if (0 =  Xmin- X) {
                        console.log(" Xmin " + Xmin + " X=" + X);
                    }
                }

                */



            }
        }
    }
    f02();//Обновление ETHUSDT (2.9M свеч) 55ms 

    //3. Синхронизация осей
    //5. Находим максимум и минимум для всех единиц на оси Y, одна единица может принадлежать 2 графикам. 
    let f03 = function () {
        for (let Name of G.C.S.Display) {
            if (Name in G.C.N) {
                let GCNName = G.C.N[Name];//объект отрисовываемого графика
                if (GCNName.Y.AutoScale) {
                    //Автомаштабирование включено
                    //Начальные значения
                    GCNName.Y.DisplayMin = Infinity;
                    GCNName.Y.DisplayMax = -Infinity;
                    for (let i = 0; i < DisplayDataCompressedY[Name].length; i++) {//- 1
                        if (GCNName.Y.DisplayMin > DisplayDataCompressedY[Name][i]) {
                            GCNName.Y.DisplayMin = DisplayDataCompressedY[Name][i];
                        }
                        if (GCNName.Y.DisplayMax < DisplayDataCompressedY[Name][i]) {
                            GCNName.Y.DisplayMax = DisplayDataCompressedY[Name][i];
                        }
                    }
                }
                //console.log("Минимум  Y: Name = " + Name + "  GCNName.Y.DisplayMin = " + GCNName.Y.DisplayMin);
                //console.log("Максимум Y: Name = " + Name + "  GCNName.Y.DisplayMax = " + GCNName.Y.DisplayMax);
            }
        }
    }
    f03();//Обновление ETHUSDT (2.9M свеч) 0.3ms 


    //синхронизация Y.
    let f04 = function () {
        for (let NameA of G.C.S.Display) {
            if (NameA in G.C.N) {
                let GCNNameA = G.C.N[NameA];//объект отрисовываемого графика
                for (let NameB of G.C.S.Display) {
                    if (NameB in G.C.N) {
                        let GCNNameB = G.C.N[NameB];//объект отрисовываемого графика
                        if (GCNNameA.Yunit == GCNNameB.Yunit) {
                            if (GCNNameA.Y.DisplayMin > GCNNameB.Y.DisplayMin) {
                                GCNNameA.Y.DisplayMin = GCNNameB.Y.DisplayMin;
                            }
                            if (GCNNameA.Y.DisplayMax < GCNNameB.Y.DisplayMax) {
                                GCNNameA.Y.DisplayMax = GCNNameB.Y.DisplayMax;
                            }
                        }
                    }
                }
                //console.log("Name = " + Name +"  GCNName.Y.DisplayMin = " + GCNNameA.Y.DisplayMin);
                //console.log("Name = " + Name +"  GCNName.Y.DisplayMax = " + GCNNameA.Y.DisplayMax);
            }
        }
    }
    f04();//Обновление ETHUSDT (2.9M свеч) 0ms 

    //Проверка Y.DisplayMax - Y.DisplayMin = 0 ?
    for (let Name of G.C.S.Display) {
        if (Name in G.C.N) {
            let GCNName = G.C.N[Name];//объект отрисовываемого графика
            if (GCNName.Y.DisplayMax == GCNName.Y.DisplayMin) {
                //Скорее всего одна точка, данных. Или все выстроились в горизонтальный ряд.
                //Чтобы в дальнейшем не было ошибок с мат вычислениями, раздиним диапазон на минимальное значение
                GCNName.Y.DisplayMin -= GCNName.Y.DisplayMin * Number.EPSILON;
                GCNName.Y.DisplayMax += GCNName.Y.DisplayMax * Number.EPSILON;
            }
        }
    }

    //6. Корректировка минимального Y, чтобы столбик имел определенную минимальную высоту, при минимальном значении, вместо того чтобы исчезнут.
    let f05 = function () {
        for (let Name of G.C.S.Display) {
            if (Name in G.C.N) {
                let GCNName = G.C.N[Name];//объект отрисовываемого графика
                if (GCNName.Y.AutoScale) {
                    //Автомаштабирование включено
                    //Соотношение (DisplayYMax - DisplayYMin) / (DisplayYMax - YminNew) = (CanvasSize.h - MinH)/CanvasSize.h; YminNew=? ;
                    GCNName.Y.DisplayMin = GCNName.Y.DisplayMax - ((GCNName.Y.DisplayMax - GCNName.Y.DisplayMin) * CanvasSize.h / (CanvasSize.h - G.C.S.HMin));
                }
                //console.log("Name = " + Name +"  GCNName.Y.DisplayMin = " + GCNName.Y.DisplayMin);
            }
        }
    }
    f05();//Обновление ETHUSDT (2.9M свеч) 0ms 

    //7. Вычисляем коэффициент, на который будем умножать значение, и получать пикселы. (сколько в 1 X/Y единице - пикселей.)
    //1/Kpx= сколько в 1 пикселе - X/Y единице
    let f06 = function () {
        for (let Name of G.C.S.Display) {
            if (Name in G.C.N) {
                let GCNName = G.C.N[Name];//объект отрисовываемого графика
                GCNName.Y.Kpx = CanvasSize.h / (GCNName.Y.DisplayMax - GCNName.Y.DisplayMin);
            }
        }
    }
    f06();//Обновление ETHUSDT (2.9M свеч) 0ms 

    //console.log("01");

    //4. Карта, соответствия координатам [пиксель] и элементам данных, для событий и построения.
    //Создадим карту элементов, чтобы потом по координатам клика мыши - можно определить на какой свече находиться мышь.
    //Структура двумерный массив: MapDisplayData[[X[px], Y[px]],... ] 
    //X[px], Y[px] - это точка данных на графике (от левого верхнего угла)
    //Для каждого графика своя карта
    //let StartTimer = Date.now();
    let f07 = function () {
        for (let Name of G.C.S.Display) {
            if (Name in G.C.N) {
                let GCNName = G.C.N[Name];//объект отрисовываемого графика
                GCNName.MapDisplayData = [];
                for (let i = 0; i < DisplayDataCompressedX[Name].length; i++) {//перебор всех данных
                    //let X = Math.round(GCNName.X.Kpx * (DisplayDataCompressedX[Name][i] - GCNName.X.DisplayMin));
                    //let Y = CanvasSize.h - Math.round(GCNName.Y.Kpx * (DisplayDataCompressedY[Name][i] - GCNName.Y.DisplayMin));
                    let X = GCNName.X.Kpx * (DisplayDataCompressedX[Name][i] - GCNName.X.DisplayMin);
                    let Y = CanvasSize.h - (GCNName.Y.Kpx * (DisplayDataCompressedY[Name][i] - GCNName.Y.DisplayMin));
                    let add = [X, Y];
                    GCNName.MapDisplayData.push(add);
                }
                //console.log(" Карта, соответствия координатам для графика " + Name + ": Количество точек =" + G.C.N[Name].MapDisplayData.length);
                //console.log("G.C.N[Name].MapDisplayData.length = " + G.C.N[Name].MapDisplayData.length);
            }
        }
    }
    f07();//Обновление ETHUSDT (2.9M свеч) 0.7-1.3ms 






    //console.log("Длительность MapDisplayData= " + (Date.now() - StartTimer) / 1000 + " [c]");
    //let StartTimer = Date.now();
    //console.log("02");
    //5. Прорисовка графиков.
    for (let Name of G.C.S.Display) {
        if (Name in G.C.N) {
            let GCNName = G.C.N[Name];//объект отрисовываемого графика
            //console.log("GCNName.X.AutoScale = " + GCNName.X.AutoScale);
            switch (GCNName.Type) {
                case "Dot":
                    ChartDot(Name, context);
                    break;
                case "Box":
                    ChartBox(Name, CanvasSize, context);
                    break;
                case "Line":
                    ChartLine(Name, context);
                    break;
                case "LineSeparated":
                    ChartLineSeparated(Name, context)
                    break;
                case "Interval":
                    ChartInterval(Name, CanvasSize, context);
                    break;
            }
        }
    }
    //console.log("Длительность отрисовки= " + (Date.now() - StartTimer) / 1000 + " [c]");


    //5. Осей и подписи.

    AxisDraw();


    //console.log("G.C.S.Xstep=" + G.C.S.Xstep);


    //Вышел из фокуса
    //document.onmouseup = StopDragnDropChart;
    //document.oncontextmenu = StopDragnDropChart;

}

//Тип графика прямоугольники
function ChartBox(Name, CanvasSize, context) {



    //Используем MapDisplayData.
    let GCNName = G.C.N[Name];//объект отрисовываемого графика

    if (GCNName.MapDisplayData.length < 2) {
        console.log("**************************************************");
        console.log("GCNName.MapDisplayData.length=" + GCNName.MapDisplayData.length);//GCNName.MapDisplayData.length=1
        console.log("GCNName.MapDisplayData=" + GCNName.MapDisplayData);//GCNName.MapDisplayData=NaN,NaN
        console.log("GCNName.Data.length = " + GCNName.Data.length);//GCNName.Data.length=1
        console.log("GCNName.X.Kpx = " + GCNName.X.Kpx);//GCNName.X.Kpx = Infinity
        console.log("GCNName.Y.Kpx = " + GCNName.Y.Kpx);//GCNName.X.Kpx = Infinity        
        console.log("GCNName.X.DisplayMax = " + GCNName.X.DisplayMax);//
        console.log("GCNName.X.DisplayMin = " + GCNName.X.DisplayMin);//
        console.log("GCNName.Y.DisplayMax = " + GCNName.Y.DisplayMax);//
        console.log("GCNName.Y.DisplayMin = " + GCNName.Y.DisplayMin);//
        return;
    }

    //Вычисляем зазор
    let MinW = Infinity;
    for (let i = 0; i < GCNName.MapDisplayData.length - 1; i++) {
        if (MinW > GCNName.MapDisplayData[i + 1][0] - GCNName.MapDisplayData[i][0]) {
            MinW = GCNName.MapDisplayData[i + 1][0] - GCNName.MapDisplayData[i][0]
        }
    }
    let gap = 0;
    if (MinW > G.C.S.GapMinW) {
        gap = 1;
    }
    // console.log("MinW=" + MinW);

    //Ошибка let L0 = Math.round(GCNName.MapDisplayData[0][0] - (GCNName.MapDisplayData[1][0] - GCNName.MapDisplayData[0][0]) / 2);
    //Uncaught (in promise) TypeError: Cannot read properties of undefined (reading "0")
    //Ошибка происходит когда обновляться браузер во время работы приложения, приходит одна точка графика
    if (GCNName.MapDisplayData[0] === undefined || GCNName.MapDisplayData[1] === undefined) {
        console.log("GCNName.MapDisplayData[0][0]=" + GCNName.MapDisplayData[0][0]);//GCNName.MapDisplayData[0][0]=NaN
        console.log("GCNName.MapDisplayData.length=" + GCNName.MapDisplayData.length);//GCNName.MapDisplayData.length=1
        console.log("GCNName.MapDisplayData=" + GCNName.MapDisplayData);//GCNName.MapDisplayData=NaN,NaN
        console.log("GCNName.Data.length = " + GCNName.Data.length);//GCNName.Data.length=1
        console.log("GCNName.X.Kpx = " + GCNName.X.Kpx);//GCNName.X.Kpx = Infinity
    }
    //Левая точка прямоугольника
    //*Uncaught (in promise) TypeError: Cannot read properties of undefined (reading "0")
    let L0 = Math.round(GCNName.MapDisplayData[0][0] - (GCNName.MapDisplayData[1][0] - GCNName.MapDisplayData[0][0]) / 2);

    for (let i = 0; i < GCNName.MapDisplayData.length; i++) {
        //цвет
        //context.fillStyle = GCNName.Color;
        context.fillStyle = "rgba(" + GCNName.ColorR + "," + GCNName.ColorG + "," + GCNName.ColorB + "," + GCNName.ColorA + ")";

        let L1;//Правая точка прямоугольника
        if (i < GCNName.MapDisplayData.length - 1) {
            L1 = Math.round(GCNName.MapDisplayData[i][0] + (GCNName.MapDisplayData[i + 1][0] - GCNName.MapDisplayData[i][0]) / 2);
        } else {//крайняя точка
            L1 = Math.round(GCNName.MapDisplayData[i][0] + (GCNName.MapDisplayData[i][0] - GCNName.MapDisplayData[i - 1][0]) / 2);
        }
        //Ширина
        let w = L1 - L0 - gap; //ширина скачет +-1 пиксел, даже при равных интервалах
        //Рисование заполненного прямоугольника.fillRect(x, y, width, height). X и Y положение верхнего левого угла 
        context.fillRect(L0, GCNName.MapDisplayData[i][1], w, CanvasSize.h - GCNName.MapDisplayData[i][1]);
        //console.log("L0=" + L0 + "\nL1=" + L1);

        L0 = L1;
    }
    //Проверяем, есть ли в GCName.Data достаточно элементов чтобы наполнить экран. Если нет, то надо делать запрос на дополнительные данные (свечи)
}
function ChartLine(Name, context) {
    //console.log("ChartLine");
    G.C.Сontext.translate(0.5, 0.5);//Смещает все пикселы на 0,5 для контраста
    //Используем MapDisplayData.
    let GCNName = G.C.N[Name];//объект отрисовываемого графика
    context.lineWidth = 1;//толщина линии
    //Цвет линии
    context.strokeStyle = "rgba(" + GCNName.ColorR + "," + GCNName.ColorG + "," + GCNName.ColorB + "," + GCNName.ColorA + ")";
    context.lineCap = "round";//тип конца линии
    context.beginPath();//начинает новый, отдельный путь
    context.moveTo(GCNName.MapDisplayData[0][0], GCNName.MapDisplayData[0][1]);//Стартовая точка
    //context.moveTo(Math.round(GCNName.MapDisplayData[0][0]), Math.round(GCNName.MapDisplayData[0][1]));//Стартовая точка
    for (let i = 1; i < GCNName.MapDisplayData.length; i++) {
        context.lineTo(GCNName.MapDisplayData[i][0], GCNName.MapDisplayData[i][1]);
        //context.lineTo(Math.round(GCNName.MapDisplayData[i][0]), Math.round(GCNName.MapDisplayData[i][1]));

    }
    //if (Name == "OutputData0test") {//инфо блок
    //    console.log(" Карта, соответствия координатам для графика " + Name + ": Количество точек =" + G.C.N[Name].MapDisplayData.length);
    //}


    //отрисовка
    context.stroke();//
    G.C.Сontext.translate(-0.5, -0.5);//Вочтанавливает смещение 
}
//Тип графика прерывистая линия
function ChartLineSeparated(Name, context) {
    //console.log("ChartLine");
    G.C.Сontext.translate(0.5, 0.5);//Смещает все пикселы на 0,5 для контраста

    //Используем MapDisplayData.
    let GCNName = G.C.N[Name];//объект отрисовываемого графика



    let NormDistance = GCNName.X.Kpx * 60000.0 * 2.0;//
    //console.log("NormDistance = " + NormDistance);

    if (NormDistance < 2.1) {
        NormDistance = 2.1;
    }
    context.lineWidth = 1;//толщина линии
    context.strokeStyle = "rgba(" + GCNName.ColorR + "," + GCNName.ColorG + "," + GCNName.ColorB + "," + GCNName.ColorA + ")";
    context.lineCap = "round";//тип конца линии
    context.beginPath();//начинает новый, отдельный путь
    //let MinDistance = Infinity;
    let Last = false;
    for (let i = 0; i < GCNName.MapDisplayData.length - 1; i++) {
        /*
        if (MinDistance > GCNName.MapDisplayData[i + 1][0] - GCNName.MapDisplayData[i][0]) {
            MinDistance = GCNName.MapDisplayData[i + 1][0] - GCNName.MapDisplayData[i][0];
            //console.log("[i + 1][0] = " + GCNName.MapDisplayData[i + 1][0] + " [i][0]=" + GCNName.MapDisplayData[i][0]);
        }
        */
        if (NormDistance < GCNName.MapDisplayData[i + 1][0] - GCNName.MapDisplayData[i][0]) {
            //Следующая точка не соеденяеться с текущей
            if (Last) {
                //C предыдущей точкой  была соеденина
                //context.lineTo(GCNName.MapDisplayData[i][0], GCNName.MapDisplayData[i][1]);
                context.lineTo(Math.round(GCNName.MapDisplayData[i][0]), Math.round(GCNName.MapDisplayData[i][1]));
                context.stroke();
                //context.beginPath();//начинает новый, отдельный путь
                //console.log("Прерывание [i + 1][0] = " + GCNName.MapDisplayData[i + 1][0] + " [i][0]=" + GCNName.MapDisplayData[i][0]);
            }////
            //console.log("NormDistance = " + NormDistance + " [i + 1][0] - [i][0]=" + (GCNName.MapDisplayData[i + 1][0] - GCNName.MapDisplayData[i][0]));
            //console.log("[i + 1][0] = " + GCNName.MapDisplayData[i + 1][0] + " [i][0]=" + GCNName.MapDisplayData[i][0]);
            Last = false;
        } else {
            //Следующая точка соеденяеться с текущей
            if (Last) {
                //C предыдущей точкой  была соеденина
                //context.lineTo(GCNName.MapDisplayData[i][0], GCNName.MapDisplayData[i][1]);
                context.lineTo(Math.round(GCNName.MapDisplayData[i][0]), Math.round(GCNName.MapDisplayData[i][1]));
            } else {
                //C предыдущей точкой  не была соеденина
                //context.moveTo(GCNName.MapDisplayData[i][0], GCNName.MapDisplayData[i][1]);//Стартовая точка
                context.moveTo(Math.round(GCNName.MapDisplayData[i][0]), Math.round(GCNName.MapDisplayData[i][1]));//Стартовая точка
            }
            Last = true;
        }

        if (i == GCNName.MapDisplayData.length - 2) {
            //context.lineTo(GCNName.MapDisplayData[i + 1][0], GCNName.MapDisplayData[i + 1][1]);
            context.lineTo(Math.round(GCNName.MapDisplayData[i + 1][0]), Math.round(GCNName.MapDisplayData[i + 1][1]));
            context.stroke();

        }

    }
    //console.log("MinDistance = " + MinDistance);

    G.C.Сontext.translate(-0.5, -0.5);//Вочтанавливает смещение 

}
function ChartLineSeparated_Медленно(Name, context) {
    //console.log("ChartLine");
    //Используем MapDisplayData.
    let GCNName = G.C.N[Name];//объект отрисовываемого графика

    let NormDistance = GCNName.X.Kpx * 60000 * 2;//
    //console.log("NormDistance = " + NormDistance);

    if (NormDistance < 2) {
        NormDistance = 2;
    }
    //NormDistance = 2;
    context.lineWidth = 0.5;//толщина линии
    context.strokeStyle = "rgba(" + GCNName.ColorR + "," + GCNName.ColorG + "," + GCNName.ColorB + "," + GCNName.ColorA + ")";
    context.lineCap = "round";//тип конца линии
    context.beginPath();//начинает новый, отдельный путь
    let MinDistance = Infinity;
    for (let i = 0; i < GCNName.MapDisplayData.length - 1; i++) {
        /*
        if (MinDistance > GCNName.MapDisplayData[i + 1][0] - GCNName.MapDisplayData[i][0]) {
            MinDistance = GCNName.MapDisplayData[i + 1][0] - GCNName.MapDisplayData[i][0];
            //console.log("[i + 1][0] = " + GCNName.MapDisplayData[i + 1][0] + " [i][0]=" + GCNName.MapDisplayData[i][0]);
        }
        */
        if (NormDistance > GCNName.MapDisplayData[i + 1][0] - GCNName.MapDisplayData[i][0]) {
            context.moveTo(Math.round(GCNName.MapDisplayData[i][0]), Math.round(GCNName.MapDisplayData[i][1]));//Стартовая точка
            context.lineTo(Math.round(GCNName.MapDisplayData[i + 1][0]), Math.round(GCNName.MapDisplayData[i + 1][1]));
            //context.moveTo(GCNName.MapDisplayData[i][0], GCNName.MapDisplayData[i][1]);//Стартовая точка
            //context.lineTo(GCNName.MapDisplayData[i + 1][0], GCNName.MapDisplayData[i + 1][1]);
            context.stroke();
        }


    }
    console.log("MinDistance = " + MinDistance);





}
function ChartDot(Name, context) {
    //console.log("ChartLine");
    //Используем MapDisplayData.
    let GCNName = G.C.N[Name];//объект отрисовываемого графика
    // Толщина и цвет дуги
    context.lineWidth = 1;//толщина линии
    //context.strokeStyle = GCNName.Color;//Цвет линии
    context.strokeStyle = "rgba(" + GCNName.ColorR + "," + GCNName.ColorG + "," + GCNName.ColorB + "," + GCNName.ColorA + ")";
    let radius = G.C.S.DotRadius;
    let startingAngle = 0;
    let endingAngle = 2 * Math.PI;
    for (let i = 0; i < GCNName.MapDisplayData.length; i++) {
        let centerX = GCNName.MapDisplayData[i][0];
        let centerY = GCNName.MapDisplayData[i][1];
        context.beginPath(); //Стартовая точка
        context.arc(centerX, centerY, radius, startingAngle, endingAngle);
        context.stroke(); //отрисовка
    }
}
function ChartInterval(Name, CanvasSize, context) {
    //Полупрозрачный прямоугольник
    //console.log("ChartLine");
    //Используем MapDisplayData.
    let GCNName = G.C.N[Name];//объект отрисовываемого графика
    // Толщина и цвет дуги
    context.fillStyle = "rgba(" + GCNName.ColorR + "," + GCNName.ColorG + "," + GCNName.ColorB + "," + GCNName.ColorA + ")";
    //console.log(" GCNName.MapDisplayData=" + GCNName.MapDisplayData);
    if (GCNName.MapDisplayData.length < 2) {//если график за пределами области видимости
        return;
    }

    let x0 = GCNName.MapDisplayData[0][0];
    let x1 = GCNName.MapDisplayData[1][0];//часто ошибка Uncaught TypeError: Cannot read properties of undefined (reading "0") 
    //console.log("GCNName.MapDisplayData = " + GCNName.MapDisplayData);

    let w = x1 - x0;
    //Рисование заполненного прямоугольника fillRect(x, y, width, height). X и Y положение верхнего левого угла 
    context.fillRect(x0, 0, w, CanvasSize.h);
}

//Подписывает оси.
function AxisDraw() {
    let Name = GetDisplayAnyName();//можно взять один любой график
    let GCNName = G.C.N[Name];//объект отрисовываемого графика
    //X ось
    //Количество строк
    let MaxNstr = 1;

    if (GCNName.Xunit == "time") {
        MaxNstr++;//time занимает 2 строки
    }
    //Размер шрифта
    let DivX = G.C.DivX;
    //0.Очишаем
    DivX.innerHTML = "";
    //Отступ
    let tgap = 3;
    //Получаем размеры.
    let CanvasSize = GetDivSizeContent(DivX);
    let fontSize = (CanvasSize.h - tgap) / MaxNstr;
    if (fontSize > G.D.S.FontSizeNormal) {
        fontSize = G.D.S.FontSizeNormal;
    }
    //console.log("GCNName.Xunit=" + GCNName.Xunit);
    let DisplayMax, DisplayMin;
    switch (GCNName.Xunit) {
        case "time": //Подпись оси х для единицы измерения "time"
            //Перевод из Unix [ms] в 
            DisplayMax = UnixToDate(GCNName.X.DisplayMax);
            DisplayMin = UnixToDate(GCNName.X.DisplayMin);
            TextSimple([tgap, "", "", 1], ["", fontSize], G.D.C.TWin, fontSize, "normal", DisplayMax.time, DivX);
            TextSimple([tgap, "", 1, ""], ["", fontSize], G.D.C.TWin, fontSize, "normal", DisplayMin.time, DivX);
            //2 строка
            TextSimple([fontSize + tgap, "", "", 1], ["", fontSize], G.D.C.TWin, fontSize, "normal", DisplayMax.date, DivX);
            TextSimple([fontSize + tgap, "", 1, ""], ["", fontSize], G.D.C.TWin, fontSize, "normal", DisplayMin.date, DivX);
            break;
        case "iteration"://Подпись оси х для единицы измерения "iteration"
            DisplayMax = GCNName.X.DisplayMax.toFixed(0);
            DisplayMin = GCNName.X.DisplayMin.toFixed(0);
            TextSimple([tgap, "", "", 1], ["", fontSize], G.D.C.TWin, fontSize, "normal", DisplayMax, DivX);
            TextSimple([tgap, "", 1, ""], ["", fontSize], G.D.C.TWin, fontSize, "normal", DisplayMin, DivX);
            break;

    }

    //Y ось
    let DivY = G.C.DivY;
    //0. Очишаем
    DivY.innerHTML = "";
    fontSize = G.D.S.FontSizeNormal;
    let Nstr = 0;
    let uniqueness = new Set(); //Set множество. Вмещает только уникальные значения
    for (let Name of G.C.S.Display) {
        if (Name in G.C.N) {
            let GCNName = G.C.N[Name];//объект отрисовываемого графика
            if (uniqueness.has(GCNName.Yunit)) {
                continue;//Значение не уникальное
            }
            uniqueness.add(GCNName.Yunit);
            let n;// выбор округления значений, в зависимости от названия единицы
            switch (GCNName.Yunit) {
                case 1:
                    n = 2;
                    break;
                case 100:
                    n = 1;
                    break;
                case "ConvergenceAverage":
                case "ConvergenceNoSignal":
                case "ConvergenceBuy":
                case "ConvergenceSale":
                    n = 5;
                    break;
                case "Interval":
                    continue;//Не отображается
                    break;
                default:
                    n = 2;
                    break;
            }
            let Ymaxtext = GCNName.Y.DisplayMax.toFixed(n);
            let Ymintext = GCNName.Y.DisplayMin.toFixed(n);
            let DivTmax = TextSimple([Nstr * fontSize + 1, "", 0, ""], ["", fontSize], G.D.C.TWin, fontSize, "normal", Ymaxtext, DivY);
            let DivTmin = TextSimple(["", Nstr * fontSize + 1, 0, ""], ["", fontSize], G.D.C.TWin, fontSize, "normal", Ymintext, DivY);
            //Проверим поместиться ли значение в ширину контейнера оси Y
            if (GetDivSizeContent(DivTmax).w > GetDivSizeContent(DivY).w || GetDivSizeContent(DivTmin).w > GetDivSizeContent(DivY).w) { //Текст не поместился
                DivTmax.style.fontSize = G.D.S.ContFontSizeMin + "px";
                DivTmin.style.fontSize = G.D.S.ContFontSizeMin + "px";

            }

            Nstr++;
        }
    }
}

//Проверит и если проверку пройдут, то применит значения GCNName.X.DisplayMin,GCNName.X.DisplayMax + вычислит GCNName.X.AutoScale
//Обновление ETHUSDT (2.9M свеч) 20ms 
function ChartCheckDisplay(NewXDisplayMin, NewXDisplayMax) {
    //Проверка выхода за границы
    //console.log("0 NewXDisplayMin=" + UnixToDate(NewXDisplayMin).date + " : " + UnixToDate(NewXDisplayMin).time + " NewXDisplayMax=" + UnixToDate(NewXDisplayMax).date + " : " +  UnixToDate(NewXDisplayMax).time);
    //console.log("1 NewXDisplayMin=" + UnixToDate(NewXDisplayMin).date + " : " +  UnixToDate(NewXDisplayMin).time + " NewXDisplayMax=" + UnixToDate(NewXDisplayMax).date + " : " +  UnixToDate(NewXDisplayMax).time);
    //console.log("1  NewXDisplayMax=" + UnixToDate(NewXDisplayMax).date + " : " + UnixToDate(NewXDisplayMax).time);
    XAutoScale = {};//запоминаем статус авто масштабирования для каждого графика
    //*Для каждого графика свой статус авто масштабирования, если график короче, то для него авто масштабирование выключено.
    for (let Name of G.C.S.Display) {
        if (Name in G.C.N) {
            let GCNName = G.C.N[Name];//объект отрисовываемого графика
            //console.log("0 GCNName.X.DisplayMax=" + UnixToDate(GCNName.X.DisplayMax).date + " : " + UnixToDate(GCNName.X.DisplayMax).time);
            if (NewXDisplayMin < GCNName.X.AbsoluteMin) {//Упор смещения графика за минимальную границу
                NewXDisplayMin = GCNName.X.AbsoluteMin;
            }
            let LimitDisplayMax = DisplayMaxAutoScale(NewXDisplayMin);
            //let LimitDisplayMax = DisplayMaxAutoScale(GCNName);
            //console.log("LimitDisplayMax=" + LimitDisplayMax);
            //console.log("LimitDisplayMax=" + UnixToDate(LimitDisplayMax).date + " : " + UnixToDate(LimitDisplayMax).time);
            XAutoScale[Name] = false;
            if (NewXDisplayMax > LimitDisplayMax) {//Упор смещения графика за максимальную границу (граница авто обновления)
                NewXDisplayMax = LimitDisplayMax;
                XAutoScale[Name] = true;
            }
        }
    }
    //console.log("2 NewXDisplayMin=" + UnixToDate(NewXDisplayMin).date + " : " +  UnixToDate(NewXDisplayMin).time + " NewXDisplayMax=" + UnixToDate(NewXDisplayMax).date + " : " +  UnixToDate(NewXDisplayMax).time);
    //console.log("2 NewXDisplayMax=" + UnixToDate(NewXDisplayMax).date + " : " + UnixToDate(NewXDisplayMax).time);

    let AnyoneMinDataOk = MinNewDataOk(NewXDisplayMin, NewXDisplayMax);//Отображаемое количество точек хотя бы у одного графика больше минимального G.C.S.MinData

    //console.log(" AnyoneMinDataOk=" + AnyoneMinDataOk);
    //Подведение итогов
    if (AnyoneMinDataOk) {//Применяем новые параметры
        for (let Name of G.C.S.Display) {
            if (Name in G.C.N) {
                let GCNName = G.C.N[Name];//объект отрисовываемого графика
                GCNName.X.DisplayMin = NewXDisplayMin;
                GCNName.X.DisplayMax = NewXDisplayMax;
                GCNName.X.AutoScale = XAutoScale[Name];
            }
        }
        return true;
    } else {
        return false;
    }

}


//События графика
function ChartEvent(CanvasSize) {
    //let DivC = G.C.DivC;
    let DivEvent = G.C.DivEvent;

    //Перемещение. Левая кнопка мыши + движение.
    //DivEvent.onmousedown = function (event) {//Клик на контейнере графика
    let Onmousedown1 = function (event) {//Клик на контейнере графика
        if (event.button != 0) {
            //нажата НЕ левая кнопка мыши. Срабатывание не происходит
            return;
        }
        //Начальные координаты клика.
        let Start = {};
        Start.MousePositionX = event.pageX;
        //Движение за курсором
        document.onmousemove = function (event) {
            // DragnDropChart(event, Start);

            //Позиция курсора относительно начального значения (клика)
            let DX = event.pageX - Start.MousePositionX;
            //console.log("DX=" + DX);

            //Произошел сдвиг
            let Name = GetDisplayAnyName();//любое значение
            let GCNName = G.C.N[Name];
            //Сдвиг мыши выраженое в единицах графика
            let DXunit = DX / GCNName.X.Kpx;
            //Сдвигаем Xmax
            let NewXDisplayMin = GCNName.X.DisplayMin - DXunit;
            let NewXDisplayMax = GCNName.X.DisplayMax - DXunit;
            //Проверка и применение вычисленных значений
            if (ChartCheckDisplay(NewXDisplayMin, NewXDisplayMax)) {
                //Перерисовываем все имеющиеся графики
                ReDrawChart();
            }

            Start.MousePositionX = event.pageX;  //запомним новое стартовое положение

            /*
            for (let Name of G.C.S.Display) {
                if (Name in G.C.N) {
                    let GCNName = G.C.N[Name];//объект отрисовываемого графика
                    GCNName.X.AutoScale = false;
                    //Сдвиг мыши выраженное в единицах графика
                    let DXunit = DX / GCNName.X.Kpx;
                    //Сдвигаем Xmax
                    GCNName.X.DisplayMax -= DXunit;
                    GCNName.X.DisplayMin -= DXunit;
                }
            }           
            Start.MousePositionX = event.pageX;
            let DivEvent = G.C.DivEvent;
            let CanvasSize = GetDivSizeContent(DivEvent);
            //Проверка вышли ли значения за предельные.
            ChartCheckDisplay(CanvasSize);
            //Перерисовываем все имеющиеся графики
            ReDrawChart();
            */
        };
        //Прекращение движения
        document.onmouseup = StopDragnDropChart;
        document.oncontextmenu = StopDragnDropChart;
    };

    //Масштаб. Колесико мыши
    DivEvent.onwheel = function (event) { //Фокус на контейнере графика + колесико мыши
        let Name = GetDisplayAnyName();//можно взять один любой график
        let GCNName = G.C.N[Name];//объект отрисовываемого графика

        //*Значения event.deltaY: вниз (от 100 до более чем 2000 с шагом 100 ) вверх (от -100 до более чем -2000 с шагом 100) где 100-400 -нормальная 800 - быстро, а 2000 - удар щелбаном
        //console.log("event.deltaY=" + event.deltaY);
        let DeltaMouse = event.deltaY / 275;//знаменатель-это обратная скорость масштаба. 100-быстро, 500-норма, 1000 медленно.
        DeltaMouse = DeltaMouse / (1 + Math.abs(DeltaMouse));      //Нормализация выходные значения от -1 до +1 (не включительно) где 0 это бездействие
        //console.log("1. DeltaMouse=" + DeltaMouse);
        if (DeltaMouse <= 0) {// Значения (от 0 до -1) преобразуем в (от 1 до 0);  
            DeltaMouse = 1 + DeltaMouse;
        } else {// Значения (от 0 до 1) преобразуем в (от 1 до +Infinity). 
            DeltaMouse = 1 / (1 - DeltaMouse);
        }
        //console.log("2. DeltaMouse=" + DeltaMouse);

        //Центр масштабирования в пикселях. event.clientX - относительно вьюпорта. GetDivPS_Viewport(DivEvent).l - относительно вью порта
        //*В местоположении курсора мыши будет центр масштабирования осей.
        let MousePositionX = event.clientX - GetDivPS_Viewport(DivEvent).l;
        //console.log("MousePositionX=" + MousePositionX);
        //Центр масштабирования в значениях
        //Формула: DivSize.w/MousePositionX=(GCNName.X.DisplayMax - GCNName.X.DisplayMin)/CenterX
        let CenterX = GCNName.X.DisplayMin + MousePositionX * (GCNName.X.DisplayMax - GCNName.X.DisplayMin) / GetDivSizeContent(DivEvent).w;
        //console.log("GGetDivSizeContent(DivEvent).w=" + GetDivSizeContent(DivEvent).w);

        //Изменяем мин и макс значения осей. Т.е. Пропорционально масштабируем размеры от центра к границам, оставляя центр неподвижным.        
        let NewXDisplayMin = CenterX - DeltaMouse * (CenterX - GCNName.X.DisplayMin);
        let NewXDisplayMax = CenterX + DeltaMouse * (GCNName.X.DisplayMax - CenterX);
        //Проверка и применение вычисленных значений
        if (ChartCheckDisplay(NewXDisplayMin, NewXDisplayMax)) {
            //Перерисовываем все имеющиеся графики
            ReDrawChart();
        }
        //console.log("DeltaMouse  ReDrawChart");
    }

    //Для активного курсора и линейки. Из всех видимых графиков, оставляет только уникальные по параметру GCNName.Yunit
    let ActiveСursorFilter = function () {

        let Unique = {}; //Проверка уникальности
        let Filter = {}; //Возвращаемый объект

        Filter.NameC = []; //Имя графика для G.C.N[Name]
        Filter.NameY = [];
        Filter.RoundingY = [];// выбор округления значений, в зависимости от названия единицы
        Filter.NameX = "";
        Filter.NumberLines = 0; //Количество строк.  Если Х = время, то + 1 строка.

        for (let Name of G.C.S.Display) {
            if (Name in G.C.N) {
                let GCNName = G.C.N[Name];//объект отрисовываемого графика
                if (GCNName.Name1 == "Interval") {//Не отображается
                    continue;//Не отображаеться
                }
                if (GCNName.Yunit in Unique) {
                    continue;//Уже есть ключ
                }
                Unique[GCNName.Yunit] = true;
                Filter.NameC.push(Name)


                //Надпись на против значения X
                if (Filter.NumberLines == 0) {
                    switch (GCNName.Xunit) {
                        case "time":
                            Filter.NameX = "";
                            Filter.NumberLines += 2;//+2 строки
                            break;
                        case "iteration":
                            Filter.NameX = "эпоха";
                            Filter.NumberLines += 1;//+1 строка
                            break;
                        default:
                            console.log("ОШИБКА!!! Неизвестный график " + GCNName.Xunit + " Name " + Name);
                            break;
                    }
                }
                Filter.NumberLines++;//+ строки

                //Надпись на против значения Y
                switch (GCNName.Name1) {
                    case "ConvergenceAverage":
                    case "ConvergenceNoSignal":
                    case "ConvergenceBuy":
                    case "ConvergenceSale":
                        Filter.NameY.push("сходимость");
                        Filter.RoundingY.push(5);
                        break;
                    case "Price":
                    case "Compression":
                    case "Smooth":
                        Filter.NameY.push(GCNName.Yunit);//Символ
                        Filter.RoundingY.push(2);
                        break;
                    case "OutputData"://выходящие данные для обучения НС в окне настройки данных
                    case "OutputTest"://выходящие данные для обучения НС в тесте
                    case "NNOutTrade"://Ответ НС в торговле
                    case "NNOutTest"://Ответ НС в тесте
                    case "NNOutSum":
                    case "OrderTest"://Сделки в тесте
                        Filter.NameY.push("сигнал");
                        Filter.RoundingY.push(1);
                        break;
                    default:
                        console.log("ОШИБКА!!! Неизвестный график " + GCNName.Name1 + " Name " + Name);
                        break;
                }
            }
        }
        return Filter;
    }
    let Filter = ActiveСursorFilter();
    //console.log(" Filter = " + JSON.stringify(Filter));

    //Активный курсор.    
    //Случай №1.
    //Курсор над графиком. График обновился.
    //Случай №2.
    //Курсор не над графиком. График обновился. (первый запуск, переход на другую страницу).
    //Курсор не исчезает при обновлении графика, но и не обновляется
    let DivHelpTextContainer = G.C.ActiveСursor.Div;
    DivHelpTextContainer.innerHTML = "";


    //Главный контейнер информации рядом с курсором
    // (P позиция [t,b,l,r]; S размеры [w,h];)
    let wText = 0;
    let hText = Filter.NumberLines * G.D.S.FontSizeNormal + 2 * G.D.S.GapIn;
    let gap = 10;//отступ от курсора
    let RFrame = 6;//отступ от курсора

    ModDivSize([wText, hText], DivHelpTextContainer);
    ModDivBackground(G.D.C.WinFon, DivHelpTextContainer);
    DivHelpTextContainer.style.borderRadius = RFrame + "px";

    //Div Строки
    let DivHelpText = [];
    for (let i = 0; i < Filter.NumberLines; i++) {
        let DivHT = TextSimple([i * G.D.S.FontSizeNormal + G.D.S.GapIn, "", G.D.S.GapIn, ""], ["", ""], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", "", DivHelpTextContainer);
        DivHelpText.push(DivHT);
    }
    //console.log(" F = " + JSON.stringify(Filter));

    //Фокус на графике. Активный курсор. Инфо по координате курсора.
    DivEvent.onmousemove = function (event) {
        //Позиция курсора относительно левого верхнего угла графика
        //Центр масштабирования в пикселях. event.clientX - относительно вью порта. GetDivPS_Viewport(DivEvent).l - относительно вью порта
        //*В местоположении курсора мыши будет центр масштабирования осей.
        //console.log("event.clientX=" + event.clientX + " event.clientY=" + event.clientY);

        if (event) {
            G.C.ActiveСursor.clientX = event.clientX;
            G.C.ActiveСursor.clientY = event.clientY;
        }


        let MousePositionX = G.C.ActiveСursor.clientX - GetDivPS_Viewport(DivEvent).l;
        let MousePositionY = G.C.ActiveСursor.clientY - GetDivPS_Viewport(DivEvent).t;
        //console.log("event.clientX=" + event.clientX + " event.clientY=" + event.clientY);
        //console.log("MousePositionX=" + MousePositionX + " MousePositionY=" + MousePositionY);
        let DivSize = GetDivSizeContent(DivEvent);
        //console.log("Xpx=" + Xpx + " Ypx=" + Ypx);
        //console.log("G.C.S.Display= " + G.C.S.Display);
        for (let i = 0; i < Filter.NameC.length; i++) {
            let Name = Filter.NameC[i];
            let GCNName = G.C.N[Name];//объект отрисовываемого графика
            //Вычисленные по позиции - значения 
            let Xcalc = GCNName.X.DisplayMin + MousePositionX * (GCNName.X.DisplayMax - GCNName.X.DisplayMin) / DivSize.w;
            let Ycalc = GCNName.Y.DisplayMin + (DivSize.h - MousePositionY) * (GCNName.Y.DisplayMax - GCNName.Y.DisplayMin) / DivSize.h;
            //console.log("Xcalc=" + Xcalc + " Ycalc=" + Ycalc);
            //Вычисленные значения могут быть не точными. Уточняем.
            let x = Xcalc;
            let y = Ycalc;
            //Надпись Y значения
            DivHelpText[i].innerHTML = Filter.NameY[i] + " " + y.toFixed(Filter.RoundingY[i]);
            if (wText < GetDivSizeContent(DivHelpText[i]).w) {
                wText = GetDivSizeContent(DivHelpText[i]).w;
            }
            //Надпись X значение. Одно и внизу.
            if (i == Filter.NameC.length - 1) {
                switch (GCNName.Xunit) {
                    case "time":
                        x = UnixToDate(x);
                        DivHelpText[i + 1].innerHTML = x.date;
                        DivHelpText[i + 2].innerHTML = x.time;
                        break;
                    case "iteration":
                        DivHelpText[i + 1].innerHTML = Filter.NameX + " " + x.toFixed(2);

                        break;
                }
            }
        }


        DivHelpTextContainer.style.display = "inline";
        DivEvent.style.cursor = "crosshair";

        if (MousePositionX + wText + gap + 2 * G.D.S.GapIn > CanvasSize.w) {
            MousePositionX = MousePositionX - wText - gap - 2 * G.D.S.GapIn;
        } else {
            MousePositionX = MousePositionX + gap;
        }
        if (MousePositionY + hText + gap > CanvasSize.h) {
            MousePositionY = MousePositionY - hText - gap;
        } else {
            MousePositionY = MousePositionY + gap;
        }

        ModDivPosition("A", [MousePositionY, "", MousePositionX, ""], DivHelpTextContainer);

        ModDivSize([wText + 2 * G.D.S.GapIn, hText], DivHelpTextContainer);

    };


    if (DivHelpTextContainer.style.display == "inline") {
        DivEvent.onmousemove(false); // имитируем событие
    }


    //Потеря фокуса на графике
    DivEvent.onmouseout = function () {
        DivHelpTextContainer.style.display = "none";
        DivEvent.style.cursor = "default";
    };



    //Функция получения значения по клику на графике.
    //Пример использования.
    //G.C.DivEvent.onclick = function (event) {
    //   let ProbeX =  G.C.DivEvent.ProbeX(event);
    //   G.C.DivEvent.onclick = null;
    //};
    DivEvent.ProbeX = function (event) {
        //Позиция курсора относительно левого верхнего угла графика
        let DivSize = GetDivPS_Viewport(DivEvent);
        let MousePositionX = event.pageX - DivSize.l;
        let Name = GetDisplayAnyName();
        let GCNName = G.C.N[Name];//объект отрисовываемого графика
        //Вычесленные по позиции - значения 
        let Xcalc = GCNName.X.DisplayMin + MousePositionX * (GCNName.X.DisplayMax - GCNName.X.DisplayMin) / DivSize.w;
        //console.log("Xcalc=" + Xcalc);
        return Xcalc;
    };


    //Правая кнопка мыши. Зажали и тянем - появляеться линейка с дельтой по двум осям.
    //DivC.onmousedown = function (event) {//Клик на контейнере графика
    let Onmousedown2 = function (event) {//Клик на контейнере графика
        if (event.button != 2) {
            //нажата НЕ правая кнопка мыши. Срабатывание не происходит
            return;
        }

        //Прямоугольник
        //0.Не Очишаем
        //Div.Chart.innerHTML = "";
        //1. Получаем размеры графической части.
        let CanvasSize = GetDivSizeContent(DivEvent);
        //2. Создаем CANVAS      
        let canvas = document.createElement("CANVAS");
        canvas.width = CanvasSize.w;
        canvas.height = CanvasSize.h;
        //Позиционирование
        let Ds = canvas.style;
        Ds.position = "absolute";
        Ds.top = "0px";
        Ds.left = "0px";
        //вставляем в Div.Chart
        G.C.DivMeasure.appendChild(canvas);
        //Присваиваем элементу контекст
        let Сontext = canvas.getContext("2d");

        let ColorR = 0;
        let ColorG = 255;
        let ColorB = 0;
        let ColorA_Line = 0.99;
        let ColorA_Fill = 0.1;



        //let Name = GetDisplayAnyName();
        //let GCNName = G.C.N[Name];//объект отрисовываемого графика
        let DivSize = GetDivPS_Viewport(DivEvent);

        //Начальные координаты клика.
        //Позиция курсора относительно левого верхнего угла графика
        let StartMousePositionX = event.pageX - DivSize.l;
        let StartMousePositionY = event.pageY - DivSize.t;

        //console.log(" Filter = " + JSON.stringify(Filter));//
        let DivContainerY_h = Filter.NameY.length * G.D.S.FontSizeNormal + 2 * G.D.S.GapIn;
        let DivContainerY_w = 0;

        let DivContainerY = Container([0, "", 0, ""], [DivContainerY_w, DivContainerY_h], G.C.DivMeasure);
        ModDivBackground(G.D.C.WinFon, DivContainerY);
        DivContainerY.style.borderRadius = RFrame + "px";

        //Div Строки
        let DivMeasureTextY = [];
        for (let i = 0; i < Filter.NameY.length; i++) {
            let DivHT = TextSimple([i * G.D.S.FontSizeNormal + G.D.S.GapIn, "", G.D.S.GapIn, ""], ["", ""], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", "", DivContainerY);
            DivMeasureTextY.push(DivHT);
            //console.log("i=" + i);
        }

        let DivContainerX_h = G.D.S.FontSizeNormal + 2 * G.D.S.GapIn;
        let DivContainerX = Container([0, "", 0, ""], [0, DivContainerX_h], G.C.DivMeasure);
        ModDivBackground(G.D.C.WinFon, DivContainerX);
        DivContainerX.style.borderRadius = RFrame + "px";
        let DivContainerTextX = TextSimple([G.D.S.GapIn, "", G.D.S.GapIn, ""], ["", ""], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", "", DivContainerX);






        //console.log("StartXcalc=" + StartXcalc);
        //console.log("StartYcalc=" + StartYcalc);

        //Движение за курсором
        document.onmousemove = function (event) {
            //Текущие координаты.
            //Позиция курсора относительно левого верхнего угла графика
            let CurrentMousePositionX = event.pageX - DivSize.l;
            let CurrentMousePositionY = event.pageY - DivSize.t;

            if (CurrentMousePositionX < 0) {
                CurrentMousePositionX = 0;
            }
            if (CurrentMousePositionY < 0) {
                CurrentMousePositionY = 0;
            }
            if (CurrentMousePositionX > DivSize.w) {
                CurrentMousePositionX = DivSize.w;
            }
            if (CurrentMousePositionY > DivSize.h) {
                CurrentMousePositionY = DivSize.h;
            }


            //Прямоугольник
            //Очистка предыдущего прямоугольника
            Сontext.clearRect(0, 0, canvas.width, canvas.height);
            let width = CurrentMousePositionX - StartMousePositionX;
            let height = CurrentMousePositionY - StartMousePositionY;
            Сontext.fillStyle = "rgba(" + ColorR + "," + ColorG + "," + ColorB + "," + ColorA_Fill + ")";
            //Рисование заполненного прямоугольника.fillRect(x, y, width, height). X и Y положение верхнего левого угла 
            Сontext.fillRect(StartMousePositionX, StartMousePositionY, width, height);
            Сontext.fillStyle = "rgba(" + ColorR + "," + ColorG + "," + ColorB + "," + ColorA_Line + ")";
            //Рисование прямоугольного контура.                 
            Сontext.strokeRect(StartMousePositionX, StartMousePositionY, width, height)





            //Надписи
            for (let i = 0; i < Filter.NameC.length; i++) {
                let Name = Filter.NameC[i];
                let GCNName = G.C.N[Name];//объект отрисовываемого графика
                //Вычесленные по позиции - значения 
                let StartXcalc = GCNName.X.DisplayMin + StartMousePositionX * (GCNName.X.DisplayMax - GCNName.X.DisplayMin) / DivSize.w;
                let StartYcalc = GCNName.Y.DisplayMin + (DivSize.h - StartMousePositionY) * (GCNName.Y.DisplayMax - GCNName.Y.DisplayMin) / DivSize.h;

                //Вычесленные по позиции - значения 
                let CurrentXcalc = GCNName.X.DisplayMin + CurrentMousePositionX * (GCNName.X.DisplayMax - GCNName.X.DisplayMin) / DivSize.w;
                let CurrentYcalc = GCNName.Y.DisplayMin + (DivSize.h - CurrentMousePositionY) * (GCNName.Y.DisplayMax - GCNName.Y.DisplayMin) / DivSize.h;
                //console.log("CurrentXcalc=" + CurrentXcalc);
                //console.log("CurrentYcalc=" + CurrentYcalc);

                //Вычисленные значения могут быть не точными. Уточняем.
                let x = CurrentXcalc - StartXcalc;
                let y = CurrentYcalc - StartYcalc;
                let y_pr = 100 * CurrentYcalc / StartYcalc - 100;

                //Надпись Y значения
                DivMeasureTextY[i].innerHTML = Filter.NameY[i] + " " + y.toFixed(Filter.RoundingY[i]) + " (" + y_pr.toFixed(Filter.RoundingY[i]) + "%)";
                if (DivContainerY_w < GetDivSizeContent(DivMeasureTextY[i]).w) {
                    DivContainerY_w = GetDivSizeContent(DivMeasureTextY[i]).w
                }
                //ModDivTextShadow(G.D.C.FonSite, 10, DivMeasureTextY[i]);

                //Надпись X значение. Одно и внизу.
                if (i == Filter.NameC.length - 1) {
                    switch (GCNName.Xunit) {
                        case "time":
                            DivContainerTextX.innerHTML = DurationMsToDate(x);
                            break;
                        case "iteration":
                            DivContainerTextX.innerHTML = Filter.NameX + " " + x.toFixed(2);
                            break;
                    }
                    let DivContainerX_w = GetDivSizeContent(DivContainerTextX).w + 2 * G.D.S.GapIn;
                    let DivContainerX_x = (StartMousePositionX + CurrentMousePositionX - DivContainerX_w) / 2;
                    let DivContainerX_y;

                    if (CurrentMousePositionY - StartMousePositionY >= 0) {
                        DivContainerX_y = CurrentMousePositionY + G.D.S.GapIn;
                        if (DivContainerX_y + DivContainerX_h > DivSize.h) {
                            DivContainerX_y = CurrentMousePositionY - DivContainerX_h - G.D.S.GapIn;
                        }
                    } else {
                        DivContainerX_y = StartMousePositionY + G.D.S.GapIn;
                        if (DivContainerX_y + DivContainerX_h > DivSize.h) {
                            DivContainerX_y = StartMousePositionY - DivContainerX_h - G.D.S.GapIn;
                        }
                    }
                    ModDivPosition("A", [DivContainerX_y, "", DivContainerX_x, ""], DivContainerX);
                    ModDivSize([DivContainerX_w, DivContainerX_h], DivContainerX);
                }
            }
            //Коректировка DivContainerY
            let DivContainerY_y = (StartMousePositionY + CurrentMousePositionY - DivContainerY_h) / 2;
            let DivContainerY_x;
            if (CurrentMousePositionX - StartMousePositionX >= 0) {
                DivContainerY_x = StartMousePositionX - DivContainerY_w - 3 * G.D.S.GapIn;
                if (DivContainerY_x < 0) {
                    DivContainerY_x = StartMousePositionX + G.D.S.GapIn;
                }
            } else {
                DivContainerY_x = CurrentMousePositionX - DivContainerY_w - 3 * G.D.S.GapIn;
                if (DivContainerY_x < 0) {
                    DivContainerY_x = CurrentMousePositionX + G.D.S.GapIn;
                }
            }
            ModDivPosition("A", [DivContainerY_y, "", DivContainerY_x, ""], DivContainerY);
            ModDivSize([DivContainerY_w + 2 * G.D.S.GapIn, DivContainerY_h], DivContainerY);


        };
        //Прекращение движения
        document.onmouseup = StopDragnDropChart;
        document.oncontextmenu = StopDragnDropChart;
    };

    //Кнопка (любая) мыши нажата , но не отпущенна.
    DivEvent.onmousedown = function (event) {
        Onmousedown1(event);
        Onmousedown2(event);//
    }


}

function StopDragnDropChart() {
    //console.log("#2 " + event.type + " на " + event.currentTarget);
    //Очищаем обработчики на document
    document.onmousemove = null;
    document.oncontextmenu = null;
    document.onmouseup = null;
    //Очистка линейки
    G.C.DivMeasure.innerHTML = "";
}

//Возвратит DisplayMax, при включенном AutoScale. (Если не передать новый X.DisplayMin то будет использован имеющийся)
//График будет иметь зазор с права как указоно в G.C.S.WAutoScale
function DisplayMaxAutoScale(XDisplayMin) {
    if (XDisplayMin === undefined) {
        return X_DisplayMin() + (X_AbsoluteMax() - X_DisplayMin()) / G.C.S.WAutoScale;
    } else {
        return XDisplayMin + (X_AbsoluteMax() - XDisplayMin) / G.C.S.WAutoScale;
    }
}

//Хоть у кого-нибудь включен X.AutoScale
function AnyoneXAutoScaleOn() {
    for (let Name of G.C.S.Display) {
        if (Name in G.C.N) {
            let GCNName = G.C.N[Name];//объект отрисовываемого графика
            if (GCNName.X.AutoScale) {
                return true;
            }
        }
    }
    return false;
}

//Отображаемое количество точек хотя бы у одного графика больше минимального G.C.S.MinData, при XDisplayMin и XDisplayMax
function MinNewDataOk(XDisplayMin, XDisplayMax) {
    for (let Name of G.C.S.Display) {
        if (Name in G.C.N) {
            let GCNName = G.C.N[Name];//объект отрисовываемого графика
            let counter = 0;//отображаемое количество точек графика   
            for (let i = 0; i < GCNName.Data.length; i++) {
                if (GCNName.Data[i][0] < XDisplayMin) {
                    continue;
                }
                if (GCNName.Data[i][0] > XDisplayMax) {
                    break;
                }
                counter++;
            }
            if (counter >= G.C.S.MinData) {// минимальное отображаемое количество точек графика     
                return true;
            }
        }
    }
    return false;

}

//Отдаст XDisplayMin, из отоброжаемых графикоа
function X_DisplayMin() {
    for (let Name of G.C.S.Display) {
        if (Name in G.C.N) {
            let GCNName = G.C.N[Name];//объект отрисовываемого графика
            if ("DisplayMin" in GCNName.X) {
                return GCNName.X.DisplayMin;
            }
        }
    }
    return undefined;
}

//Отдаст XDisplayMax
function X_DisplayMax() {
    for (let Name of G.C.S.Display) {
        if (Name in G.C.N) {
            let GCNName = G.C.N[Name];//объект отрисовываемого графика
            if ("DisplayMax" in GCNName.X) {
                return GCNName.X.DisplayMax;
            }
        }
    }
    return undefined;
}

//Отдаст XAbsoluteMin
function X_AbsoluteMin() {
    for (let Name of G.C.S.Display) {
        if (Name in G.C.N) {
            let GCNName = G.C.N[Name];//объект отрисовываемого графика
            if ("AbsoluteMin" in GCNName.X) {
                return GCNName.X.AbsoluteMin;
            }
        }
    }
    return undefined;

}
//Отдаст XAbsoluteMax
function X_AbsoluteMax() {
    for (let Name of G.C.S.Display) {
        if (Name in G.C.N) {
            let GCNName = G.C.N[Name];//объект отрисовываемого графика
            if ("AbsoluteMax" in GCNName.X) {
                return GCNName.X.AbsoluteMax;
            }
        }
    }
    return undefined;
}

//Отдаст название единиц измерения по X
function X_unit() {
    for (let Name of G.C.S.Display) {
        if (Name in G.C.N) {
            let GCNName = G.C.N[Name];//объект отрисовываемого графика
            if ("Xunit" in GCNName.X) {
                return GCNName.X.Xunit;
            }
        }
    }
    return undefined;
}

//Отдаст первое попавшееся название графика, которое есть в G.C.S.Display и в G.C.N
function GetDisplayAnyName() {
    for (let Name of G.C.S.Display) {
        if (Name in G.C.N) {
            return Name;
        }
    }
    return undefined;
}

//Отдаст последнее значение (Y) графика
function GetEndY(Name) {
    if (Name in G.C.N) {
        let GCNName = G.C.N[Name];//объект отрисовываемого графика
        let Y = GCNName.Data[GCNName.Data.length - 1][1];
        return Y;
    }
    return undefined;
}


//Управление отображаемыми графиками. В зависимости от местонахождения изменяет состав G.C.S.Display.
//Вызвать при изменении местоположения. Но переменные местоположения, уже должны быть изменены.
function Manager_G_C_S_Display() {
    switch (G.Page.Name) {
        case "Trade": //Торговля. Гостевая страница. 
            switch (G.Page.Trade.SelectedTabL) {//Имя вкладки на странице Trade
                case "Bot"://Робот
                    //console.log("G.Bot.Symbol= " + G.Bot.Symbol);
                    G.C.S.Display = ["Price" + G.Bot.Symbol];
                    break;
                case "Balance"://Баланс
                    G.C.S.Display = ["Price" + G.Bot.Symbol];
                    break;
                case "Order"://Сделки
                    G.C.S.Display = ["Price" + G.S.OrderSymbol, "Order" + G.S.OrderSymbol];
                    break;
            }
            switch (G.Page.Trade.SelectedTabR) {//Имя вкладки окна торговли
                case "AutoTrading"://Авто торговля
                    //console.log("G.Bot.Symbol= " + G.Bot.Symbol);
                    G.C.S.Display.push("Price" + G.Bot.Symbol);
                    //if (G.Bot.NNWeight != null) {
                    if (G.Bot.Out != null) {
                        //if (Object.keys(G.Bot.NNWeight).length > 0) {
                        if (Object.keys(G.Bot.Out).length > 0) {
                            //for (let NameNN in G.Bot.NNWeight) {
                            for (let NameNN in G.Bot.Out) {
                                G.C.S.Display.push("NNOutTrade" + NameNN);
                            }
                            G.C.S.Display.push("NNOutSum");//суммарный сигнал
                        }
                    }
                    // }
                    break;
                case "ManualTrading"://Торговля
                    G.C.S.Display.push("Price" + G.S.ManualTradeSymbol);
                    break;
            }
            break;
        case "NN"://Нейросеть. Настройки НС.
            let NameNN = G.Page.NN.SelectNameNN;
            if (NameNN in G.NN.N) {
                let NNSet = G.NN.N[NameNN].Set;//Uncaught TypeError: Cannot read properties of undefined (reading "Set")
                let Symbol;
                switch (G.Page.NN.SelectedTab) {
                    case "General"://Общее
                        Symbol = NNSet.DataTrain[G.Page.NN.DataSetSelectList[NameNN]].Symbol;
                        G.C.S.Display = ["Price" + Symbol];
                        break;
                    case "Architecture"://Архитектура
                        G.C.S.Display = [];
                        break;
                    case "DataSet"://Данные
                        Symbol = NNSet.DataTrain[G.Page.NN.DataSetSelectList[NameNN]].Symbol;
                        G.C.S.Display = ["Price" + Symbol, "Interval" + NameNN];
                        break;
                    case "InputOutput"://Данные
                        Symbol = NNSet.DataStatisticSymbol;
                        //console.log("NNSet.DataStatisticSymbol= " + NNSet.DataStatisticSymbol);
                        G.C.S.Display = ["Price" + Symbol, "Interval" + NameNN, "Compression" + NameNN, "Smooth" + NameNN, "OutputData" + NameNN];
                        break;
                    case "Convergence"://Сходимость
                        //G.C.S.Display = ["Convergence" + NameNN, "ConvergenceAverage" + NameNN, "ConvergenceNoSignal" + NameNN, "ConvergenceBuy" + NameNN, "ConvergenceSale" + NameNN];
                        G.C.S.Display = ["ConvergenceAverage" + NameNN, "ConvergenceNoSignal" + NameNN, "ConvergenceBuy" + NameNN, "ConvergenceSale" + NameNN];

                        break;
                    case "Trigger"://Триггер
                        G.C.S.Display = [];//Есть вариант переключения графиков
                        //G.C.S.Display = ["Price" + NNSet.Symbol, "Interval" + NameNN];
                        break;
                    case "Training"://Обучение 
                        Symbol = NNSet.DataTrain[G.Page.NN.DataSetSelectList[NameNN]].Symbol;
                        //G.C.S.Display = ["Price" + Symbol, "Interval" + NameNN];
                        G.C.S.Display = ["Price" + Symbol];
                        break;
                    case "Test"://Тест
                        G.C.S.Display = ["Price" + NNSet.TestSymbol, "Interval" + NameNN, "OutputTest" + NameNN, "NNOutTest" + NameNN, "OrderTest" + NameNN];
                        break;
                }
            }
            break;
        case "Settings"://Настройки приложения.
            G.C.S.Display = [];
            break;

    }
    // Добавленные пользователем графики, с помощью меню настройки графиков.
    if (!(G.Page.Name == "NN" && G.Page.NN.SelectedTab == "Convergence")) {//кроме вкладки "Сходимость"
        G.C.S.Display.push(...G.Page.AddPriceChart);
    }
    G.C.S.Display = UniqueValuesArray(G.C.S.Display); //Удаляем дубликаты из G.C.S.Display


    //console.log("G.C.S.Display= " + G.C.S.Display);
    Price_Unsubscribe();//Отписка от неиспользуемых графиков цен

}
//Отписка от неиспользуемых графиков цен
function Price_Unsubscribe() {
    //Если график цены пользователь не отображал более tmin минут, то график удаляется, и Golang отписывается от потока авто обновления.
    let tmin = 12;//[мин]
    for (let Name of G.C.S.Display) {
        if (Name in G.C.N) {
            let GCNName = G.C.N[Name];//объект отрисовываемого графика
            if (GCNName.Name1 == "Price") {
                let Symbol = GCNName.Name2;
                if (Symbol in G.TimerIdPriceSubscribe) {
                    clearInterval(G.TimerIdPriceSubscribe[Symbol]);// остановить повторы
                }
                G.TimerIdPriceSubscribe[Symbol] = setInterval(function (Symbol, Name) { // функция будет запускаться через каждые мс.
                    if (!(G.C.S.Display.includes(Name))) { //График не отображаться.
                        if (G.BotStatusWork) {//Статус робота - работает
                            if (G.Bot.Symbol == Symbol) {//пара робота совпала
                                return;
                            }
                        }

                        console.log("График не отображаться более " + tmin + "мин. Отписка " + Symbol);
                        delete G.C.N[Name];//Удаляем данные графика
                        //Отписка
                        DeletePrice(Symbol)

                        clearInterval(G.TimerIdPriceSubscribe[Symbol]);// остановить повторы
                        delete G.TimerIdPriceSubscribe[Symbol];//Удаляем таймер
                    }
                    //Если график отображается, то ждем следующего запуска ф-ции.
                }, tmin * 60 * 1000, Symbol, Name);
            }
        }
    }
}






