//Матричный график. Для триггеров.
//Type =  "Income" по доходу (основной график) /"NOrder" по количеству сделок
//Type =  "Income" | "Accuracy"
//MinLimit ,MaxLimit Предельные значения цвета
function DrawMatrixPlot(NameNN, Type) {//, Data
    //0. Очищаем
    //1. Получаем размеры графической части.
    //2. Создаем CANVAS    
    //4. Создаем упрощенный формат данных 
    //5. Создаем пиксельную карту для отрисовки.
    //5. Определяем минимумы и максимумы данных.
    //5. Определяем размеры шага и количество шагов.
    //4. Карта, соответствия координатам [пиксель] и элементам данных, для событий и построения.
    //5. Прорисовка.
    console.log("DrawMatrixPlot. NameNN=" + NameNN + " Type=" + Type);

    Manager_G_C_S_Display();

    if (G.C.ChartType != "Trigger") {//После графиков другого типа ( Architecture, Standard)
        ChartWin("Trigger");
    }
    //console.log("MinLimit = " +MinLimit+"  MaxLimit = " +MaxLimit);


    let DivC = G.C.DivC;
    //0. Очишаем
    DivC.innerHTML = "";
    DivC.onmousedown = null;
    DivC.onwheel = null;

    let NNSet = G.NN.N[NameNN].Set;


    //1. Получаем размеры графической части.
    let CanvasSize = GetDivSizeContent(DivC);

    //2. Создаем CANVAS      
    let canvas = document.createElement("CANVAS");
    canvas.width = CanvasSize.w;
    canvas.height = CanvasSize.h;
    //вставляем в inDiv
    DivC.appendChild(canvas);
    //Присваиваем элементу контекст
    let context = canvas.getContext("2d");

    //Описание входящих данных для построения графика.
    //Формат входящих данных, это массив объектов с полями:
    //Data[iBuy][iSale].* Структура для конкретного значение пары триггеров
    //.TriggerBuy  float64 //Триггер покупки. от -100 до 0(не включительно) Y.
    //.TriggerSale float64 //Триггер продажи. от 100 до 0(не включительно) X.
    //.Income      float64 //Доход в %
    //.NOrder      int     //Количество сделок. Сделка начинается с продажи. Не Четное число сделок, указывает на то, что последняя сделка была продажа базовой валюты
    //Ось X: Триггер продажи TriggerSale
    //Ось Y: Триггер покупки TriggerBuy
    //console.log("Data =" + JSON.stringify(Data));

    //console.log("Data.length =" + Data.length);
    //Основные переменные:
    let X = {};
    let Y = {};
    let V = {};
    //Предельные значения
    Y.MinAbsolute = NNSet.OutRangeFrom;//-100
    X.MaxAbsolute = NNSet.OutRangeTo;//100
    Y.MaxAbsolute = (Y.MinAbsolute + X.MaxAbsolute) / 2;//0
    X.MinAbsolute = (Y.MinAbsolute + X.MaxAbsolute) / 2;//0
    console.log("Y.MinAbsolute =" + Y.MinAbsolute + "   X.MaxAbsolute  =" + X.MaxAbsolute);

    //В завмсимости от типа данные храняться в разных переменных
    let Matrix;
    //Извлечение данных
    switch (Type) {
        case "Income":
            Matrix = NNSet.TriggerIncomeMatrix;
            break;
        case "Accuracy":
            Matrix = NNSet.TriggerAccuracyMatrix;
            break;
        case "Manual":
            Matrix = false;
            break;
    }

    if (!Matrix) {
        console.log("ОШИБКА!!!. Нет данных. Matrix=" + Matrix);
        return;
    }

    let nStep = Matrix.length

    //4. Создаем упрощенный формат данных 
    X.A = []; //X.A[порядковый номер X] = значение триггера 0 до 100
    Y.A = []; //Y.A[порядковый номер Y] = значение триггера -100 до 0
    V.A = []; //V.A[порядковый номер X][порядковый номер Y] = значение V (доход/количество сделок)

    // Инициализация двумерного массива нулями
    for (let x = 0; x < nStep; x++) {
        V.A[x] = [];
    }

    //Извлечение данных
    switch (Type) {
        case "Income":
            //{+модуль, чтобы let не ругалась
            //Легенда:
            /*
            NNSet.TriggerIncomeMatrix [][]IncomeStruct //Триггера и доход по каждому (TriggerTrade)
            type IncomeStruct struct { //TradeStruct
                TriggerBuy  float64 //Триггер покупки. Значения: -100-0
                TriggerSale float64 //Триггер продажи. Значения: 0-100
                Income      float64 //Доход в %. (во сколько раз увеличился баланс)
                NOrder      int     //Количество сделок. Сделка начинается с продажи. Не Четное число сделок, указывает на то что последняя сделка была продажа базовой валюты
            }
            */
            for (let iTB = 0; iTB < nStep; iTB++) { //Y. покупка от -100 до 0(не включительно)
                for (let iTS = 0; iTS < nStep; iTS++) { //X. продажа от 100 до 0(не включительно)
                    let Income = Matrix[iTB][iTS].Income
                    let TriggerBuy = Matrix[iTB][iTS].TriggerBuy;//Триггер покупки. Значения: -100-0
                    let TriggerSale = Matrix[iTB][iTS].TriggerSale;//Триггер продажи. Значения: 0-100        
                    let Xindex = iTS;
                    let Yindex = iTB;
                    X.A[Xindex] = TriggerSale;
                    Y.A[Yindex] = TriggerBuy;
                    V.A[Xindex][Yindex] = Income;
                }
            }
            //}

            break;
        case "Accuracy":
            //{+модуль, чтобы let не ругалась
            //Легенда:
            /*
            NNSet.TriggerAccuracyMatrix [][]AccuracyStruct //Триггера и точность по каждому
            type AccuracyStruct struct {
                TriggerBuy  float64 //Триггер покупки. Значения: -100-0
                TriggerSale float64 //Триггер продажи. Значения: 0-100
                Accuracy    float64 //Точность в %.
                NCorrect    int     //Количество правельных облостей сделок.
                NSkipped    int     //Количество пропущенных облостей сделок.
                NWrong      int     //Количество неправельных облостей сделок.
            }
            */
            for (let iTB = 0; iTB < nStep; iTB++) { //Y. покупка от -100 до 0(не включительно)
                for (let iTS = 0; iTS < nStep; iTS++) { //X. продажа от 100 до 0(не включительно)
                    let Accuracy = Matrix[iTB][iTS].Accuracy
                    let TriggerBuy = Matrix[iTB][iTS].TriggerBuy;//Триггер покупки. Значения: -100-0
                    let TriggerSale = Matrix[iTB][iTS].TriggerSale;//Триггер продажи. Значения: 0-100        
                    let Xindex = iTS;
                    let Yindex = iTB;
                    X.A[Xindex] = TriggerSale;
                    Y.A[Yindex] = TriggerBuy;
                    V.A[Xindex][Yindex] = Accuracy;
                }
            }
            //}

            break;
    }






    //console.log("Y.A=" + Y.A);
    //console.log("X.A=" + X.A);
    //console.log("V.A=" + V.A);

    //console.log("X.A.length =" + X.A.length + "  Y.A.length  =" + Y.A.length);
    //console.log(" X.A[X.A.length - 1] =" + X.A[X.A.length - 1]);

    //X.A = ArrNumSort(X.A);//0 индекс = минимальное значение 
    //Y.A = ArrNumSort(Y.A);//0 индекс = минимальное значение 



    //5. Создаем пиксельную карту для отрисовки.
    //Первая точка - начало прямоугольника, вторая точка - конец первого и начало второго прямоугольника... последняя точка - конец последнего прямоугольника.
    //В результате в центре этого прямоугольника будет значение пары триггеров.
    //Количество точек в этих массивах на одну больше чем самих точек.   
    X.box = []; //X.A[порядковый номер] = значение триггера 0 до 100
    Y.box = []; //Y.A[порядковый номер] = значение триггера -100 до 0
    //X. Координаты.  0 до 100
    //let vertex = X.A[0] - Math.abs(X.A[1] - X.A[0]) / 2;// Первая. 10-|20-10|/2=5 ; 
    let vertex = X.A[0] - (X.A[1] - X.A[0]) / 2;// Первая. 10-|20-10|/2=5 ; 
    //if (vertex < X.MinAbsolute) {
    //    vertex = X.MinAbsolute;
    //}
    //let vertex = X.A[0];// Первая. 
    X.box.push(vertex);
    for (let i = 0; i < X.A.length - 1; i++) {// Остальные 
        vertex = (X.A[i] + X.A[i + 1]) / 2;
        X.box.push(vertex);
    }
    //vertex = X.A[X.A.length - 1] + Math.abs(X.A[X.A.length - 2] - X.A[X.A.length - 1]) / 2; //Крайняя. 80+|70-80|/2=85; 
    vertex = X.A[X.A.length - 1] - (X.A[X.A.length - 2] - X.A[X.A.length - 1]) / 2; //Крайняя. 80+|70-80|/2=85; 
    //if (vertex > X.MaxAbsolute) {
    //    vertex = X.MaxAbsolute;
    //}
    //vertex = X.A[X.A.length - 1]; //Крайняя.; 
    X.box.push(vertex);
    //Y. Координаты. -100 до 0
    //vertex = Y.A[0] - Math.abs(Y.A[1] - Y.A[0]) / 2;// Первая. -70-|-60--70|/2=-75 
    vertex = Y.A[0] - (Y.A[1] - Y.A[0]) / 2;// Первая. -70-|-60--70|/2=-75 
    //if (vertex < Y.MinAbsolute) {//-100
    //    vertex = Y.MinAbsolute;
    //}
    //vertex = Y.A[0];// Первая.
    Y.box.push(vertex);
    for (let i = 0; i < Y.A.length - 1; i++) {// Остальные 
        vertex = (Y.A[i] + Y.A[i + 1]) / 2;
        Y.box.push(vertex);
    }
    //vertex = Y.A[Y.A.length - 1] + Math.abs(Y.A[Y.A.length - 2] - Y.A[Y.A.length - 1]) / 2;// Крайняя. -20+|-30--20|/2=-15 
    vertex = Y.A[Y.A.length - 1] - (Y.A[Y.A.length - 2] - Y.A[Y.A.length - 1]) / 2;// Крайняя. -20+|-30--20|/2=-15 
    //if (vertex > Y.MaxAbsolute) {//0
    //    vertex = Y.MaxAbsolute;
    //}
    //vertex = Y.A[Y.A.length - 1];// Крайняя. 
    Y.box.push(vertex);
    //console.log("X.box =" + X.box);
    //console.log("Y.box =" + Y.box);

    //console.log("X.box.length =" + X.box.length + " Y.box.length  =" + Y.box.length);

    //5. Определяем минимумы и максимумы данных V (доход/ количество сделок).
    V.MaxData = -Infinity;
    V.MinData = Infinity;
    for (let iTB = 0; iTB < nStep; iTB++) { //Y. покупка от -100 до 0(не включительно)
        for (let iTS = 0; iTS < nStep; iTS++) { //X. продажа от 100 до 0(не включительно)
            //let Income = NNSet.TriggerTrade[iTB][iTS].Income
            //let NOrder = NNSet.TriggerTrade[iTB][iTS].NOrder
            //let TriggerBuy = NNSet.TriggerTrade[iTB][iTS].TriggerBuy;//Триггер покупки. Значения: -100-0
            //let TriggerSale =NNSet.TriggerTrade[iTB][iTS].TriggerSale;//Триггер продажи. Значения: 0-100        
            let Xindex = iTS;
            let Yindex = iTB;
            let v = V.A[Xindex][Yindex];
            if (V.MaxData < v) {
                V.MaxData = v;
            }
            if (V.MinData > v) {
                V.MinData = v;
            }

        }
    }

    console.log("V.MinData =" + V.MinData + " V.MaxData =" + V.MaxData);

    //Стартовый масштаб. Маштаб определяется минмальными и максимальными значениями осей.
    X.MaxDisplay = X.MaxAbsolute;//100
    X.MinDisplay = X.MinAbsolute;//0
    Y.MaxDisplay = Y.MaxAbsolute;//0
    Y.MinDisplay = Y.MinAbsolute;//-100
    //console.log("X.MaxDisplay =" + X.MaxDisplay + " X.MinDisplay  =" + X.MinDisplay + " Y.MaxDisplay =" + Y.MaxDisplay + " Y.MinDisplay =" + Y.MinDisplay);


    //Цвета постоянны, зависят от всех данных, а не от видимой области
    //"rgb(0,255,0)" - Цвет минимального значения
    //"rgb(255,0,0)" - Цвет максимального значения
    //Коэфициент цвета. Умнажая значение v на этот коэффициент, получим компонент цвета Color.kh*(vMax-vMin) = 255; 
    let kColor = 255 / (V.MaxData - V.MinData);


    //Определение цвета: Color =kh*(v-vMin)
    let MinLimit = V.MinData;
    let MaxLimit = V.MaxData;

    let XYV = { X: X, Y: Y, V: V, kColor: kColor, CanvasSize: CanvasSize, context: context, Type: Type, MinLimit: MinLimit, MaxLimit: MaxLimit };
    GlobalVarXYV = XYV;
    //Сразу первая прорисовка.
    ReDrawMatrixPlot(XYV);
    MatrixPlotEvent(XYV);


}

let GlobalVarXYV;
function ReDrawMatrixPlotLimit(MinLimit, MaxLimit) {
    let V = GlobalVarXYV.V;
    if (MinLimit == undefined) {
        MinLimit = V.MinData;
    }
    if (MaxLimit == undefined) {
        MaxLimit = V.MaxData;
    }
    GlobalVarXYV.MinLimit = MinLimit;
    GlobalVarXYV.MaxLimit = MaxLimit;

    GlobalVarXYV.kColor = 255 / (MaxLimit - MinLimit);
    ReDrawMatrixPlot(GlobalVarXYV);
}



//Перерисовывает
function ReDrawMatrixPlot(XYV) {
    let Y = XYV.Y;
    let X = XYV.X;
    let V = XYV.V;
    let MinLimit = XYV.MinLimit;
    let MaxLimit = XYV.MaxLimit;
    //console.log("MinLimit =" + MinLimit + " MaxLimit  =" + MaxLimit);

    let context = XYV.context;
    let CanvasSize = XYV.CanvasSize;
    let kColor = XYV.kColor;
    //по умолчанию:
    //X.MinDisplay = 0
    //X.MaxDisplay = 100
    //Y.MinDisplay = -100
    //Y.MaxDisplay = 0


    //Заполняем весь холст цветом нулевого значения
    context.fillStyle = "rgb(0,255,0)";
    context.fillRect(0, 0, CanvasSize.w, CanvasSize.h);
    //Сколько в одной еденице триггера - пикселей
    Y.k = CanvasSize.h / (Y.MaxDisplay - Y.MinDisplay);
    X.k = CanvasSize.w / (X.MaxDisplay - X.MinDisplay);
    //console.log("Y.k =" + Y.k + " X.k =" + X.k);

    //Для построения графического элемента, понадобиться соседние точки.
    for (let ix = 0; ix < X.box.length - 1; ix++) {//Значения: 0 до 100
        let l = X.box[ix]; //начало прямоугольника
        let lnext = X.box[ix + 1];//конец прямоугольника
        if (lnext < X.MinDisplay || l > X.MaxDisplay) {//проверка границ. Прямоугольник полностью в не области видимости.
            continue;
        }
        for (let iy = 0; iy < Y.box.length - 1; iy++) {//Значения: -100 до 0
            let t = Y.box[iy];//начало прямоугольника
            let tnext = Y.box[iy + 1];//конец прямоугольника
            if (tnext < Y.MinDisplay || t > Y.MaxDisplay) {//проверка границ. Прямоугольник полностью в не области видимости. 
                continue;
            }
            let v = V.A[ix][iy];
            if (v == 0) {
                continue;
            }
            //Вычисление цвета
            if (v < MinLimit) {
                v = MinLimit;
            }
            if (v > MaxLimit) {
                v = MaxLimit;
            }
            //let rColor = Math.round(kColor * (v - V.MinData));
            if (v < MinLimit) {
                v = MinLimit;
            }
            let rColor = Math.round(kColor * (v - MinLimit));
            let gColor = 255 - rColor;
            context.fillStyle = "rgb(" + rColor + "," + gColor + ",0)";
            //context.fillStyle = "rgb(" + Math.round(Math.random() * 255) + "," + Math.round(Math.random() * 255) + "," + Math.round(Math.random() * 225) + ")";
            //context.fillStyle = "rgb(0,0,0)";

            //Преобразование значений триггеров в пиксели
            let lpx = Math.round(X.k * (l - X.MinDisplay));//X.k*(50-0)
            let lnextpx = Math.round(X.k * (lnext - X.MinDisplay));//X.k*(60-0)
            let wpx = lnextpx - lpx;//60-50
            let tpx = Math.round(CanvasSize.h - Y.k * (t - Y.MinDisplay));//|600-X.k*(-50--100)=X.k*50|
            let tnextpx = Math.round(CanvasSize.h - Y.k * (tnext - Y.MinDisplay));//|600-X.k*(-40--100)=X.k*60|
            let hpx = tnextpx - tpx;//540-550            
            //Отрисовка. Рисование заполненного прямоугольника fillRect(x, y, width, height). X и Y положение верхнего левого угла 
            context.fillRect(lpx, tpx, wpx, hpx);

            if (((ix + 10) % 50 == 0) && ((iy + 10) % 50 == 0)) {
                //console.log("l =" + l + "; lnext =" + lnext + "; t =" + t + "; tnext =" + tnext);
                //console.log("lpx =" + lpx + "; tpx =" + tpx + "; wpx =" + wpx + "; hpx =" + hpx);
                //console.log("rColor =" + rColor + " gColor =" + gColor);
                //console.log("v =" + v);
                //console.log("V.MinData =" + V.MinData + " V.MaxData =" + V.MaxData);
            }
        }
    }

    //Подписи Осей.
    let DivX = G.C.DivX;
    let DivY = G.C.DivY;
    //0.Очишаем
    DivX.innerHTML = "";
    DivY.innerHTML = "";
    let tgap = 3;//Отступ   
    let tf = 1; //Округление
    let YMin = Y.MinDisplay.toFixed(tf);//ось Y.
    let YMax = Y.MaxDisplay.toFixed(tf);//ось Y.
    let XMin = X.MinDisplay.toFixed(tf);//ось X.
    let XMax = X.MaxDisplay.toFixed(tf);//ось X.
    //Позиции только макс значений, т.к. мин значения в 0 всегда

    TextSimple([tgap, "", "", 1], ["", ""], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", XMax, DivX);//ось X.
    TextSimple([tgap, "", 1, ""], ["", ""], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", XMin, DivX);//ось X.
    TextSimple([1, "", 0, ""], ["", ""], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", YMax, DivY);//ось Y.
    TextSimple(["", 1, 0, ""], ["", ""], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", YMin, DivY);//ось Y.
}


//Проверка вышли ли значения за предельные.
function CheckDisplay(XYV) {
    let Y = XYV.Y;
    let X = XYV.X;

    if (Y.MinDisplay < Y.MinAbsolute) {
        Y.MinDisplay = Y.MinAbsolute;
    }
    if (Y.MinDisplay > Y.MaxAbsolute) {
        Y.MinDisplay = Y.MaxAbsolute;
    }
    if (Y.MaxDisplay > Y.MaxAbsolute) {
        Y.MaxDisplay = Y.MaxAbsolute;
    }
    if (Y.MaxDisplay < Y.MinAbsolute) {
        Y.MaxDisplay = Y.MinAbsolute;
    }
    if (X.MinDisplay < X.MinAbsolute) {
        X.MinDisplay = X.MinAbsolute;
    }
    if (X.MinDisplay > X.MaxAbsolute) {
        X.MinDisplay = X.MaxAbsolute;
    }
    if (X.MaxDisplay > X.MaxAbsolute) {
        X.MaxDisplay = X.MaxAbsolute;
    }
    if (X.MaxDisplay < X.MinAbsolute) {
        X.MaxDisplay = X.MinAbsolute;
    }
};



//События графика
function MatrixPlotEvent(XYV) {
    let Y = XYV.Y;
    let X = XYV.X;
    let V = XYV.V;
    let CanvasSize = XYV.CanvasSize;
    let Type = XYV.Type;
    let DivC = G.C.DivC;


    //Масштабирование
    DivC.onwheel = function (event) {  //Колесико мыши+ фокус на контейнере графика 
        //*В местоположении курсора мыши будет центр масштабирования осей.
        //let DeltaMouse = 1 + event.deltaY / 500;//знаменатель-это скорость масштаба. event.deltaY возвращает от отрицательных до положительных значений.

        //*Значения event.deltaY: вниз (от 100 до более чем 2000 с шагом 100 ) вверх (от -100 до более чем -2000 с шагом 100) где 100-400 -нормальная 800 - быстро, а 2000 - удар шалбаном
        //console.log("event.deltaY=" + event.deltaY);
        let DeltaMouse = event.deltaY / 275;//знаменатель-это обратная скорость масштаба. 100-быстро, 500-норма, 1000 медленно.
        DeltaMouse = DeltaMouse / (1 + Math.abs(DeltaMouse));      //Нормализация выходные значения от -1 до +1 (не включительно) где 0 это бездействие
        //console.log("1. DeltaMouse=" + DeltaMouse);
        if (DeltaMouse <= 0) {// Значения (от 0 до -1) преобразуем в (от 1 до 0);  
            DeltaMouse = 1 + DeltaMouse;
        } else {// Значения (от 0 до 1) преобразуем в (от 1 до +Infinity). 
            DeltaMouse = 1 / (1 - DeltaMouse);
        }
        //Проверкка минимального масштаба
        let XDsize = DeltaMouse * (X.MaxDisplay - X.MinDisplay);
        let YDsize = DeltaMouse * (Y.MaxDisplay - Y.MinDisplay);
        let minD = 100; // минимальный масштаб, чем больше тем сильнее можно увеличить
        if (XDsize < (X.MaxAbsolute - X.MinAbsolute) / minD) {
            if (DeltaMouse < 1) {
                return;
            }
        }
        if (YDsize < (Y.MaxAbsolute - Y.MinAbsolute) / minD) {
            if (DeltaMouse < 1) {
                return;
            }
        }

        //Центр масштабирования в пикселях. event.clientX - относительно вью порта. GetDivPS_Viewport(DivC).l - относительно вью порта
        //*В местоположении курсора мыши будет центр масштабирования осей.
        let MousePositionX = event.clientX - GetDivPS_Viewport(DivC).l;
        let MousePositionY = event.clientY - GetDivPS_Viewport(DivC).t;
        //console.log("MousePositionX=" + MousePositionX+"  MousePositionY=" + MousePositionY);

        //Центр масштабирования в значениях триггера
        //Формула: DivSize.h/MousePositionY=(TriggerBuyMax-TriggerBuyMin)/CenterY
        let CenterX = X.MinDisplay + MousePositionX * (X.MaxDisplay - X.MinDisplay) / GetDivSizeContent(DivC).w;
        let CenterY = Y.MaxDisplay - MousePositionY * (Y.MaxDisplay - Y.MinDisplay) / GetDivSizeContent(DivC).h;
        //console.log("CenterX=" + CenterX+"  CenterY=" + CenterY);

        //Изменяем мин и макс значения осей.
        Y.MinDisplay = CenterY - DeltaMouse * (CenterY - Y.MinDisplay);
        Y.MaxDisplay = CenterY + DeltaMouse * (Y.MaxDisplay - CenterY);
        X.MinDisplay = CenterX - DeltaMouse * (CenterX - X.MinDisplay);
        X.MaxDisplay = CenterX + DeltaMouse * (X.MaxDisplay - CenterX);
        //Проверка вышли ли значения за предельные.
        CheckDisplay(XYV);
        //Перерисовываем все имеющиеся графики
        ReDrawMatrixPlot(XYV);
    }

    //Перетаскивание
    DivC.onmousedown = function (event) {//Клик на контейнере графика
        if (event.button != 0) {
            //нажата НЕ левая кнопка мыши. Срабатывание не происходит
            return;
        }
        let Start = {};
        Start.MousePositionX = event.pageX;
        Start.MousePositionY = event.pageY;
        //Движение за курсором
        document.onmousemove = function (event) {

            //Позиция курсора относительно начального значения (клика)
            let DX = event.pageX - Start.MousePositionX;
            let DY = event.pageY - Start.MousePositionY;
            //Сдвиг мыши выраженое в единицах графика
            let DXunit = DX / X.k;
            let DYunit = DY / Y.k;
            //console.log("DX=" + DX);
            //Если на какой-либо границе
            if (Y.MinDisplay <= Y.MinAbsolute && DYunit < 0) {
                DYunit = 0;
            }
            if (Y.MaxDisplay >= Y.MaxAbsolute && DYunit > 0) {
                DYunit = 0;
            }
            if (X.MinDisplay <= X.MinAbsolute && DXunit > 0) {
                DXunit = 0;
            }
            if (X.MaxDisplay >= X.MaxAbsolute && DXunit < 0) {
                DXunit = 0;
            }

            Y.MinDisplay += DYunit;
            Y.MaxDisplay += DYunit;
            X.MinDisplay -= DXunit;
            X.MaxDisplay -= DXunit;

            CheckDisplay(XYV);

            Start.MousePositionX = event.pageX;
            Start.MousePositionY = event.pageY;

            //let StartTimer = Date.now();
            //Перерисовываем все имеющиеся графики
            ReDrawMatrixPlot(XYV);
            //console.log("Длительность = " + (Date.now() - StartTimer) / 1000 + " [c]");

        };
        //Прекращение движения
        document.onmouseup = StopDragnDropChart;
        document.oncontextmenu = StopDragnDropChart;
    };


    //Активный курсор.
    // (P позиция [t,b,l,r]; S размеры [w,h];)
    let wText = 140;
    let hText = 3 * G.D.S.FontSizeNormal + 4;
    let gap = 10;//отступ от курсора
    //let DivHelpText = FrameContainer(["", "", "", ""], [wText, hText], G.D.C.WinFon, DivC);
    let DivHelpText = Container(["", "", "", ""], [wText, hText], DivC);
    let DivHelpTextV = TextSimple([0, "", "", ""], ["", ""], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", "", DivHelpText);
    let DivHelpTextX = TextSimple([G.D.S.FontSizeNormal, "", "", ""], ["", ""], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", "", DivHelpText);
    let DivHelpTextY = TextSimple([2 * G.D.S.FontSizeNormal, "", "", ""], ["", ""], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", "", DivHelpText);
    DivHelpText.style.display = "none";
    //Фокус на графике
    DivC.onmousemove = function (event) {
        //Позиция курсора относительно левого верхнего угла графика
        //Центр масштабирования в пикселях. event.clientX - относительно вью порта. GetDivPS_Viewport(DivC).l - относительно вью порта
        //*В местоположении курсора мыши будет центр масштабирования осей.
        let MousePositionX = event.clientX - GetDivPS_Viewport(DivC).l;
        let MousePositionY = event.clientY - GetDivPS_Viewport(DivC).t;
        //console.log("MousePositionX=" + MousePositionX+"  MousePositionY=" + MousePositionY);

        //console.log("X.box =" + X.box);
        //console.log("Y.box =" + Y.box);

        //Вычисленные по позиции значения триггеров
        let Xcalc = MousePositionX / X.k + X.MinDisplay;
        let Ycalc = (CanvasSize.h - MousePositionY) / Y.k + Y.MinDisplay;
        //console.log("Xcalc=" + Xcalc + " Ycalc=" + Ycalc);
        //Вычисленные значения могут быть не точными. Уточняем.
        let Xi, Yi;
        let x = Xcalc;
        let y = Ycalc;

        for (let ix = 0; ix < X.box.length - 1; ix++) {//Значения: 0,5 - 1
            let l = X.box[ix];
            let lnext = X.box[ix + 1];
            if ((Xcalc > l && Xcalc < lnext) || (Xcalc > l && Xcalc > lnext)) {
                Xi = ix;
                x = X.A[ix];
                break;
            }
        }

        if (Xi !== undefined) {
            for (let iy = 0; iy < Y.box.length - 1; iy++) {//Значения: 0-0,5
                let t = Y.box[iy];
                let tnext = Y.box[iy + 1];
                if ((Ycalc > t && Ycalc < tnext) || (Ycalc < t && Ycalc < tnext)) {
                    Yi = iy;
                    y = Y.A[iy];
                    break;
                }
            }
        }
        let v = 0;
        //console.log("Xi=" + Xi + " Yi=" + Yi);

        if (Xi !== undefined && Yi !== undefined) {
            v = V.A[Xi][Yi];
        }


        DivHelpText.style.display = "inline";
        DivC.style.cursor = "crosshair";

        if (MousePositionX + wText + gap > CanvasSize.w) {
            MousePositionX = MousePositionX - wText - gap;
        } else {
            MousePositionX = MousePositionX + gap;
        }
        if (MousePositionY + hText + gap > CanvasSize.h) {
            MousePositionY = MousePositionY - hText - gap;
        } else {
            MousePositionY = MousePositionY + gap;
        }
        DivHelpText.style.left = MousePositionX + "px";
        DivHelpText.style.top = MousePositionY + "px";

        switch (Type) {
            case "Income":
                DivHelpTextV.innerHTML = "Доход " + NumToFormatK(v) + " %";
                break;
            case "Accuracy":
                DivHelpTextV.innerHTML = "Точность " + v.toFixed(3);
                break;
        }
        let tf = 1;
        DivHelpTextX.innerHTML = "X Продажа " + x.toFixed(tf);
        DivHelpTextY.innerHTML = "Y Покупка  " + y.toFixed(tf);
    };
    DivC.onmouseout = function () {
        DivHelpText.style.display = "none";
        DivC.style.cursor = "default";
    };
}

