//-------------Настройки по умолчанию----------------
//console.log("StyleColor ");



function UpdateTheme() {
    DrawApplication();
}


//----------------------------------------------------------------------------------------------------------------------
//Датчики

// Получение размера окна приложения
function GetViewSize() {
    //Получение размера окна приложения
    //Размер области просмотра (вьюпорта) без полос прокрутки:
    let w = document.documentElement.clientWidth;
    let h = document.documentElement.clientHeight;
    //console.log("w=" + w + " h=" + h);
    return { w: w, h: h }
};

//Получение размера элемента Div. Внешние размеры. Относительно родителя
function GetDivPS_Parent(Div) {
    //Получение размера элемента Div, вместе с border
    let t = Div.offsetTop;//
    let l = Div.offsetLeft;
    let w = Div.offsetWidth;
    let h = Div.offsetHeight;
    //console.log("Divw=" + w + " Divh=" + h);
    return { t: t, l: l, w: w, h: h }
};

//Получение размера элемента Div. Контент
function GetDivSizeContent(Div) {
    //Получение размера элемента Div, вместе с border
    let w = Div.clientWidth;
    let h = Div.clientHeight;
    //console.log("Divw=" + w + " Divh=" + h);
    return { w: w, h: h }
};

//Получение координаты элемента Div относительно вью порта(не документа). 
function GetDivPS_Viewport(Div) {
    let element = Div.getBoundingClientRect(); //координаты относительно вью порта
    let t = element.top; //относительно вью порта
    let l = element.left;
    let w = element.width;
    let h = element.height;
    return { t: t, l: l, w: w, h: h }
};



//----------------------------------------------------------------------------------------------------------------------
//Элементарные элементы дизайна.

//Создаёт элемент и вставляет его в другой элемент.
//(тип("div","textarea","input","img","a"); куда вставляем: (inDiv/"body"))
function DivCeate(Type, inDiv) {
    //Содаем элемент
    let Div = document.createElement(Type);
    //вставляем новый Div в body
    if (inDiv == "body") {
        //вставляем новый Div в inDiv
        document.body.appendChild(Div)
    } else {
        //вставляем новый Div в inDiv
        inDiv.appendChild(Div);
    }
    return Div
};


//Модификатор контейнера. Добавляет позицию.
//(Тип позиционирования (""/"A"/"R"), Позиция [t,b,l,r]; inDiv)
function ModDivPosition(TP, P, ModDiv) {
    let Ds = ModDiv.style;
    //Позиционирование (""/"A"/"R") (static/absolute/relative)
    switch (TP) {
        case "A":
            Ds.position = "absolute";
            break;
        case "R":
            Ds.position = "relative";
            break;
    };
    //Координаты: (""/число).
    Ds.top = (P[0] == "") ? "" : Math.round(P[0]) + "px";
    Ds.bottom = (P[1] == "") ? "" : Math.round(P[1]) + "px";
    Ds.left = (P[2] == "") ? "" : Math.round(P[2]) + "px";
    //if (P[2] != ""){
    // Ds.left =  Math.round(P[2]) + "px";
    //}
    Ds.right = (P[3] == "") ? "" : Math.round(P[3]) + "px";
};

//Модификатор контейнера. Добавляет размеры.
//(Размеры [w,h] (число/"auto"/"100%"); inDiv)
function ModDivSize(S, ModDiv) {
    let Ds = ModDiv.style;
    //Размеры: (число/"auto"/"100%")    
    Ds.width = (typeof S[0] == "number") ? Math.round(S[0]) + "px" : S[0];
    Ds.height = (typeof S[1] == "number") ? Math.round(S[1]) + "px" : S[1];
}

//Модификатор контейнера.  Добавляет внешние отступы.
//(Внешние отступы(t,b,l,r)(""/число); inDiv)
function ModDivMargin(M, ModDiv) {
    let Ds = ModDiv.style;
    //Внешнии отступы(""/число).
    Ds.marginTop = (M[0] == "") ? "" : Math.round(M[0]) + "px";
    Ds.marginBottom = (M[1] == "") ? "" : Math.round(M[1]) + "px";
    Ds.marginLeft = (M[2] == "") ? "" : Math.round(M[2]) + "px";
    Ds.marginRight = (M[3] == "") ? "" : Math.round(M[3]) + "px";
}

//Модификатор контейнера.  Добавляет внутренние отступы.
//(Внутренние отступы(t,b,l,r)(""/число); inDiv)
function ModDivPadding(Pd, ModDiv) {
    let Ds = ModDiv.style;
    //Внутренние отступы(""/число).
    Ds.paddingTop = (Pd[0] == "") ? "" : Math.round(Pd[0]) + "px";
    Ds.paddingBottom = (Pd[1] == "") ? "" : Math.round(Pd[1]) + "px";
    Ds.paddingLeft = (Pd[2] == "") ? "" : Math.round(Pd[2]) + "px";
    Ds.paddingRight = (Pd[3] == "") ? "" : Math.round(Pd[3]) + "px";
}
/*
//Модификатор контейнера.  Добавляет рамку с радиусом и цвет фона.
// цвет фона(цвет/"transparent") 
function DivFrame(ColorBackground, ModDiv) {
    let Ds = ModDiv.style;
    Ds.border = G.D.S.FrameSize + "px solid " + G.D.C.Frame;
    //По очереди устанавливает радиус для верхнего левого, верхнего правого, нижнего правого и нижнего левого уголка.
    Ds.borderRadius = G.D.S.Radius + "px ";
    Ds.background = ColorBackground;
}
*/
//Модификатор контейнера.  Добавляет рамку с радиусом и цвет фона.
// цвет фона(цвет/"transparent") 
function ModDivFrame(ModDiv) {
    let Ds = ModDiv.style;
    Ds.border = G.D.S.FrameSize + "px solid " + G.D.C.Frame;
    Ds.borderRadius = G.D.S.Radius + "px ";
}

//Модификатор контейнера.  Добавляет цвет фона.
// цвет фона(цвет/"transparent") 
function ModDivBackground(ColorBackground, ModDiv) {
    let Ds = ModDiv.style;
    Ds.background = ColorBackground;
}

//Обводка/тень для текста  
function ModDivTextShadow(Color, R, ModDiv) {
    //смещение-x | смещение-y | радиус-размытия | цвет 
    let Ds = ModDiv.style;
    Ds.textShadow = "0px 0px " + R + "px " + Color;
    // return ModDiv;

}

//Обводка/тень для текста  
function ModDivReadableText1(Color, ModDiv) {
    //смещение-x | смещение-y | радиус-размытия | цвет 
    let Ds = ModDiv.style;
    Ds.textShadow = "1px 0px 0 " + Color +
        ", 0px 1px 0 " + Color +
        ", 0px -1px 0 " + Color +
        ", -1px 0px 0 " + Color +
        ", 1px 1px 0 " + Color +
        ", 1px -1px 0 " + Color +
        ", -1px 1px 0 " + Color +
        ", -1px -1px 0 " + Color;


    // return ModDiv;

}
//Обводка/тень для текста  
function ModDivReadableText2(Color, ModDiv) {
    //смещение-x | смещение-y | радиус-размытия | цвет 
    let Ds = ModDiv.style;

    let R = 8;
    Ds.textShadow = "0px 0px " + R + "px " + Color +
        ", 0px 0px " + R + "px " + Color +
        ", 0px 0px " + R + "px " + Color +
        ", 0px 0px " + R + "px " + Color +
        ", 0px 0px " + R + "px " + Color +
        ", 0px 0px " + R + "px " + Color;
    // return ModDiv;

}


//Наложения исходного цвета на фоновый цвет. Для читабельности текста
function ModDivBlend(ModDiv) {
    let Ds = ModDiv.style;
    Ds.mixBlendMode = "multiply";


    /*
   normal	нормальный
   multiply	умножить
   screen	экран
   overlay		наложение
   darken		затемнить
   lighten		осветлить
   color-dodge	цветной уклон
   color-burn	цветной огонь
   difference	разница +
   exclusion	исключение +
   hue	оттенок
   saturation	насыщенность
   color	цвет
   luminosity	яркость
   
   hard-light
   soft-light
   plus-darker
   plus-lighter


difference Разница.
 В этом режиме вычитается либо совмещённый цвет из основного цвета, либо основной цвет из совмещённого цвета в зависимости от того, какой цвет имеет большее значение яркости.
 Смешивание с белым цветом приводит к инвертированию значений основного цвета, смешивание с чёрным цветом не влечёт за собой каких-либо изменений.

exclusion Исключение. 
В этом режиме создается эффект, аналогичный создаваемому в режиме «Разница», но характеризующийся более низким контрастом. 
Смешивание с белым цветом приводит к инвертированию значений основного цвета. Смешивание с чёрным цветом не приводит к появлению каких-либо изменений.



   */

}



//Прозрачность 0-1
function ModDivOpacity(Opacity, ModDiv) {
    //смещение-x | смещение-y | радиус-размытия | цвет 
    let Ds = ModDiv.style;
    Ds.opacity = Opacity;
}

//перенос строки автоматический
function ModDivWhiteSpace(ModDiv) {
    //смещение-x | смещение-y | радиус-размытия | цвет 
    let Ds = ModDiv.style;
    Ds.whiteSpace = "normal"; //Устанавливаем перенос строки автоматический
    Ds.wordWrap = "break-word";
}


//Модификатор контейнера. Текст однострочный поместит в контейнер ModDiv. Изменит Div контейнера.
//(Height, цвет текста, размер шрифта, стиль, выравнивание, Высота Строки, содержимое, inDiv)
//Style: "normal" "italic"; Align выравнивание - горизонтальное "left" "center" "right"
//Если текст в рамке то его высота будет меньше контейнера на 2 толщины рамки. Height = Высота контейнер (с рамкой) - 2 * G.D.S.FrameSize 
function DivText(Height, TextColor, FontSize, Style, Align, Content, ModDiv) {
    let Ds = ModDiv.style;
    //Св-ва текста
    Ds.color = TextColor;
    Ds.fontFamily = G.D.S.Name; //шрифт
    Ds.fontSize = FontSize + "px";
    Ds.fontStyle = Style;
    Ds.textAlign = Align;
    //Высота текса/строки. (""/число). Текст в строке выровнен по середине. Учитывается рамка.
    //Для border-box Свойства height включают в себя значения border. (Контент меньше на 2 ширины border)
    //Ds.lineHeight = (Height == "") ? "" : (Height - 2 * G.D.S.FrameSize) + "px";
    Ds.lineHeight = (Height == "") ? "" : Height + "px";

    //Множественные пробелы не учитываются, переносы строк в коде HTML игнорируются, весь текст отображается одной строкой; вместе с тем, добавление тега <br> переносит текст на новую строку.
    Ds.whiteSpace = "nowrap";
    ModDiv.innerHTML = Content;
}

//Модификатор контейнера. По умолчанию ширина и высота задаются для контента. border-box изменяет это свойство и размеры задаются для border.
/*function BorderBox(ModDiv) {
    ModDiv.style.boxSizing = "border-box";
}*/


//----------------------------------------------------------------------------------------------------------------------
//Специальные элементы дизайна.
//----------------------------------------------------------------------------------------------------------------------
//Стиль для всех элементов  box-sizing: border-box
//border-box Свойства width и height включают в себя значения padding и border, но не margin. (Контент меньше на 2 ширины border)
//Аргументы
//P - Позиция. Массив  [t,b,l,r]
//S - Размеры. Массив  [w,h]
//inDiv - куда помещается элемент создаваемый ф-цией


//Создает главный контейнер приложения.
//(Высота экрана, Ширина экрана)
function Background(SizeViewW, SizeViewH) {
    //Содаем элемент
    let Div = DivCeate("div", "body");
    ModDivPosition("A", [0, "", 0, ""], Div);
    ModDivSize([SizeViewW, SizeViewH], Div);
    //Задаем стиль
    let Ds = Div.style;
    Ds.background = G.D.C.FonSite;

    return Div
};

//Контейнер.
//(P позиция [t,b,l,r]; S размеры [w,h]; inDiv)
function Container(P, S, inDiv) {
    let Div = DivCeate("div", inDiv);
    ModDivPosition("A", P, Div);
    ModDivSize(S, Div);
    return Div
};


//Контейнер с рамкой и фоном.
//(P позиция [t,b,l,r]; S размеры [w,h]; цвет фона(/"transparent") , inDiv)
function FrameContainer(P, S, ColorFon, inDiv) {
    //учитываем толщину рамки.
    //let h = S[0] - 2 * G.D.S.FrameSize;
    //let w = S[1] - 2 * G.D.S.FrameSize;
    let Div = DivCeate("div", inDiv);
    ModDivPosition("A", P, Div);
    ModDivSize(S, Div);
    ModDivFrame(Div)
    ModDivBackground(ColorFon, Div)
    return Div
};


//Пустое стандартное окно.
//(P позиция [t,b,l,r]; S размеры [w,h]; inDiv)
function WindowContainer(P, S, inDiv) {
    let Div = FrameContainer(P, S, G.D.C.WinFon, inDiv);
    return Div
};

//Простой текст
// (P позиция [t,b,l,r]; S размеры [w,h];)
function TextSimple(P, S, TextColor, FontSize, Style, Content, inDiv) {
    //Содаем контейнер для текста
    let Div = DivCeate("div", inDiv);
    ModDivPosition("A", P, Div);
    ModDivSize(S, Div);
    let h = S[1];
    DivText(h, TextColor, FontSize, Style, "", Content, Div);
    return Div
}

//Простой текст с выравниванием
// (P позиция [t,b,l,r]; S размеры [w,h];)Align выравнивание - горизонтальное "left" "center" "right"
function TextSimpleA(P, S, TextColor, FontSize, Style, Align, Content, inDiv) {
    //Содаем контейнер для текста
    let Div = DivCeate("div", inDiv);
    ModDivPosition("A", P, Div);
    ModDivSize(S, Div);
    let h = S[1];
    DivText(h, TextColor, FontSize, Style, Align, Content, Div);
    return Div
}
//Простой текст - кнопка
// (P позиция [t,b,l,r]; S размеры [w,h];)
function TextSimpleClick(P, S, TextColor, FontSize, Style, Content, inDiv) {
    //Содаем контейнер для текста
    let Div = TextSimple(P, S, TextColor, FontSize, Style, Content, inDiv)
    let Ds = Div.style;
    Ds.cursor = "pointer";
    return Div;
}


//Изображение jpg. Возвратит элемент "img"
//(P позиция [t,b,l,r]; S размеры [w,h]; inDiv)
function ImageContainer(P, S, src, inDiv) {
    let Div = DivCeate("img", inDiv);
    Div.src = "Web/Media/Images/" + src;//"/Media/Images/board.jpg"
    //Div.src = "Web/Media/"+src;//"/Media/Images/board.jpg"

    ModDivPosition("A", P, Div);
    ModDivSize(S, Div);
    return Div
};

//Текст - пункты меню. Возвратит Div контейнера.
//(Размеры {t:, l:, h:, w:,}, цвет текста, размер шрифта, стиль, выравнивание, Высота Строки, содержимое, inDiv)
//Размеры: {верх, низ, высота, ширина}; стиль: "normal" "italic"; выравнивание - горизонтальное "left" "center" "right"
function MenuItem(Gap, Height, TextColor, FontSize, Content, inDiv) {
    //Содаем контейнер для текста
    let Div = DivCeate("div", inDiv);
    ModDivMargin(["", "", Gap, ""], Div);
    DivText(Height, TextColor, FontSize, "normal", "", Content, Div)
    //Корректируем стиль контейнера
    let Ds = Div.style;
    //Элемент будет отображаться как строчный, 
    Ds.display = "inline";
    Ds.cursor = "pointer";
    return Div
};


//Модификатор события onmouseover (фокус) и onmouseout (не фокус). Для фона ( Div.style.background) 
function ModEventBackground(ColorBackgroundFocus, ColorBackground, inDiv) {
    inDiv.style.background = ColorBackground;//по умолчанию
    inDiv.onmouseover = function () {//фокус
        inDiv.style.background = ColorBackgroundFocus;
    };
    inDiv.onmouseout = function () {//не фокус
        inDiv.style.background = ColorBackground;
    };
}
//Модификатор события onmouseover (фокус) и onmouseout (не фокус). Для текста ( Div.style.color) 
function ModEventText(ColorTextFocus, ColorText, inDiv) {
    inDiv.style.color = ColorText;//по умочанию
    inDiv.onmouseover = function () {//фокус
        inDiv.style.color = ColorTextFocus;
    };
    inDiv.onmouseout = function () {//не фокус
        inDiv.style.color = ColorText;
    };
}
//Кнопка с текстом. 
//(P позиция [t,b,l,r]; S размеры [w,h]; inDiv)
function ButtonText(P, S, Content, inDiv) {
    //Контейнер
    let Div = DivCeate("div", inDiv);
    ModDivPosition("A", P, Div);
    ModDivSize(S, Div);
    ModDivFrame(Div)
    ModDivBackground(G.D.C.ButtonFon, Div)
    //Текст
    let h = S[1];
    //Если текст в рамке то его высота будет меньше контейнера на 2 толщины рамки. Height = Высота контейнер (с рамкой) - 2 * G.D.S.FrameSize 
    h = h - 2 * G.D.S.FrameSize;
    DivText(h, G.D.C.ButtonText, G.D.S.FontSizeNormal, "normal", "center", Content, Div);
    //особенности
    Div.style.cursor = "pointer";
    //Событие    
    ModEventBackground(G.D.C.ButtonFonFocus, G.D.C.ButtonFon, Div);//фокус
    ModEventText(G.D.C.ButtonTextFocus, G.D.C.ButtonText, Div); //НЕ фокус
    /*
        Div.onmouseover = function () {
            Div.style.background = G.D.C.ButtonFonFocus;
            Div.style.color = G.D.C.ButtonTextFocus;
        };
       
        Div.onmouseout = function () {
            Div.style.background = G.D.C.ButtonFon;
            Div.style.color = G.D.C.ButtonText;
        };
        */
    return Div;
}


//Редактируемые текстовые поля. Обертка для InputText.ID назначено самому редактируемому тексту. Возвратит его Div редактируемого текста
//(APosition[], высота(int/"auto"/"100%"), ширина, тип("text", "password", "email", "textarea"(не исп), "number"), макс. число символов, ID, inDiv/"body")
// Где APosition[]=[верх(int/""), низ, лево, право](absolute) / [Обтекание("left"/"right"/""), Внеш. отступ: верх(int), низ, лево, право](static)
//Input.oninput = function () {};   //событие изменение содержания поля ввода текста
//Input.onchange = function () {};   //событие окончание изменение содержания поля ввода текста (потеря фокуса)
function TextFrameInput(P, S, MaxLength, Content, inDiv) {

    //Контейнер типа <input>
    //однострочное текстовое поле
    let Input = DivCeate("input", inDiv);
    ModDivPosition("A", P, Input);
    ModDivSize(S, Input);

    //Предположительное содержание, для авто верификации. "text", "password", "email", "number"
    //Input.type = type;
    //макс. число символов
    Input.maxLength = MaxLength;
    let Is = Input.style;
    //Убираем оформления поля по умолчанию
    Is.margin = "0px";
    Is.border = "0px solid";
    Is.padding = "0px";
    Is.background = "transparent";
    //текст
    let h = S[1];
    //Если текст в рамке, то его высота будет меньше контейнера на 2 толщины рамки. Height = Высота контейнер (с рамкой) - 2 * G.D.S.FrameSize 
    h = h - 2 * G.D.S.FrameSize;
    DivText(h, G.D.C.TWin, G.D.S.FontSizeNormal, "normal", "right", "", Input);
    Input.value = Content;

    ModDivFrame(Input)
    ModDivBackground(G.D.C.FonTextBox, Input) //было G.D.C.ButtonFon
    return Input;
}


//Редактируемый многострочный текст
// (APosition[], высота(int/"auto"/"100%"), ширина, тип("text", "password", "email", "textarea", "number"), макс. число символов, ID, inDiv/"body")
// Где APosition[]=[верх(int/""), низ, лево, право](absolute) / [Обтекание("left"/"right"/""), Внеш. отступ: верх(int), низ, лево, право](static)
function InputText(APosition, h, w, MaxLength, ID, inDiv) {
    let Input, Is;


    //многострочное текстовое поле
    Input = EmptyContainer(APosition, h, w, "textarea", ID, inDiv);
    Input.rows = Math.round(h / hm); //количество строк кратно hm
    Is = Input.style;
    //многострочное текстовое поле
    Is.resize = "none"; // Запрещаем изменять размер
    Is.background = Pf[MyID].Cs.FonTextBox;
    Is.lineHeight = hm + "px";


    Input.maxLength = MaxLength;
    Is.margin = "0px";
    Is.border = "0px solid";
    Is.padding = "0px";
    Is.background = "transparent";
    //текст
    Is.color = Pf[MyID].Cs.TFonTextBox;
    Is.fontFamily = FName;
    Is.fontSize = FSizeN + "px";
    Is.fontStyle = "normal";

    return Input
}


function TextFrameArea(P, S, MaxLength, Content, inDiv) {

    //Контейнер типа <input>
    //однострочное текстовое поле
    let Div = DivCeate("textarea", inDiv);
    ModDivPosition("A", P, Div);
    ModDivSize(S, Div);
    let Ds = Div.style;

    let hText = G.D.S.FontSizeNormal;
    let hTextCont = G.D.S.ContFontSizeNormal;

    let hFrame = S[1];
    Div.rows = Math.round(hFrame / hTextCont); //количество строк кратно hm
    Ds.resize = "none"; // Запрещаем изменять размер
    Div.maxLength = MaxLength;//макс. число символов


    //Предположительное содержание, для авто верификации. "text", "password", "email", "number"
    //Input.type = type;


    //Убираем оформления поля по умолчанию
    Ds.margin = "0px";
    Ds.border = "0px solid";
    Ds.padding = "0px";
    Ds.background = "transparent";
    //текст
    let h = S[1];
    //Если текст в рамке то его высота будет меньше контейнера на 2 толщины рамки. Height = Высота контейнер (с рамкой) - 2 * G.D.S.FrameSize 
    DivText(hText, G.D.C.TWin, G.D.S.FontSizeNormal, "normal", "left", "", Div);
    Div.value = Content;

    ModDivFrame(Div)
    ModDivBackground(G.D.C.ButtonFon, Div)
    return Div;
}

//Ползунок. (Вспомогательная функция для ModDivScrollV, и в качестве самостоятельного элемента)
//При изменении положения скрола в функцию ScrollMove(value) будут отправляется измененное значение ползунка (0-1)
//Возвращаемая функция SetValue(value) установит положения ползунка. Когда из внешней функции необходимо будет изменить положение ползунка,
//в возвращаемую функцию необходимо отправят значение ползунка (0-1), и в соответствии с этими значениями переместиться ползун.
//(P позиция [t,b,l,r]; Длина, Direction("vertical"/"horizontal"), ScrollMove(value), inDiv). return: SetValue(value)
function ScrollBar(P, Length, Direction, ScrollMove, inDiv) {
    //Толщина линии скольжения.Он принимает все события.
    let Thickness = G.D.S.ScrollThickness;
    //Длина ползунка
    let LengthSlider = G.D.S.ScrollLengthSlider;

    let WLine, HLine; //Размеры линии скольжения
    let WSlider, HSlider; //Размеры ползунок

    if (Direction == "horizontal") {
        //Размеры линии скольжения
        WLine = Length;
        HLine = Thickness;
        //Размеры ползунок
        WSlider = LengthSlider;
        HSlider = Thickness - 2 * G.D.S.FrameSize;
    }
    if (Direction == "vertical") {
        //Размеры линии скольжения
        WLine = Thickness;
        HLine = Length;
        //Размеры ползунок
        WSlider = Thickness - 2 * G.D.S.FrameSize;
        HSlider = LengthSlider;
    }

    //Линия скольжения-----------------------------------
    let DivScrollBar = FrameContainer(P, [WLine, HLine], G.D.C.FonSite, inDiv);

    //Ползунок-------------------------------------------------
    let DivSlider = FrameContainer([0, "", 0, ""], [WSlider, HSlider], G.D.C.ButtonFon, DivScrollBar);


    //Ф-ция принимает значение (0-1), и в соответствии со значениями перемещает ползунки.
    let SetValue = function (value) {
        //console.log("SetValue: value=" + value);
        //Проверяем границы
        if (value < 0) {
            value = 0;
        }
        if (value > 1) {
            value = 1;
        }
        if (Direction == "horizontal") {
            //позции ползунков----------------------------------------------
            let LSlider = value * (Length - LengthSlider);
            DivSlider.style.left = Math.round(LSlider) + "px";
        }
        if (Direction == "vertical") {
            //позции ползунков-----------------------------------------------
            let TSlider = value * (Length - LengthSlider);
            DivSlider.style.top = Math.round(TSlider) + "px";
        }
    };

    //События------------------------------------------
    //Клик на контейнере слайдера
    DivScrollBar.onmousedown = function (event) {
        if (event.button != 0) {
            //нажата НЕ левая кнопка мыши. Срабатывание не происходит
            return;
        }
        //элемент на котором произошло событие
        let Div = event.currentTarget;
        DragnDropSlider(event, Div, Length, Direction, ScrollMove, LengthSlider);

        //Движение за курсором
        document.onmousemove = function (event) {
            DragnDropSlider(event, Div, Length, Direction, ScrollMove, LengthSlider);
        };
        //Прекращение движения
        document.onmouseup = stop;
        document.oncontextmenu = stop;
    };


    //Движение за курсором
    function DragnDropSlider(event, Div, Length, Direction, ScrollMove, LengthSlider) {


        //Позиция курсора относительно левого верхнего угла Div
        // event.clientX - относительно вью порта. GetDivPS_Viewport(DivC).l - относительно вью порта
        //let MousePositionX = event.clientX - GetDivPS_Viewport(Div).l;
        //let MousePositionY = event.clientY - GetDivPS_Viewport(Div).t;
        //console.log("MousePositionX=" + MousePositionX + " MousePositionY=" + MousePositionY);
        //let DivSize = GetDivSizeContent(Div);




        //координаты элемента относительно вью порта
        //console.log("mouseX=" + event.pageX + " mouseY=" + event.pageY);
        //Горизонтальное положение-------------------
        if (Direction == "horizontal") {
            //Позиция курсора относительно родителя
            let P = event.clientX - GetDivPS_Viewport(Div).l - LengthSlider / 2;
            //Проверяем границы
            if (P < 0) {
                P = 0;
            }
            if (P > (Length - LengthSlider)) {
                P = (Length - LengthSlider);
            }
            //Позиция курсора в значении от 0 до 1
            let pct = P / (Length - LengthSlider);
            DivSlider.style.left = P + "px";
            ScrollMove(pct);
        }

        //Вертикальное положение-------------------
        if (Direction == "vertical") {
            //Позиция курсора относительно родителя
            let P = event.clientY - GetDivPS_Viewport(Div).t - LengthSlider / 2;
            //Проверяем границы
            if (P < 0) {
                P = 0;
            }
            if (P > (Length - LengthSlider)) {
                P = (Length - LengthSlider);
            }
            //Позиция курсора в значении от 0 до 1
            let pct = P / (Length - LengthSlider);
            DivSlider.style.top = P + "px";
            ScrollMove(pct);
        }
    }


    function stop() {
        //console.log("#2 " + event.type + " на " + event.currentTarget);
        //Очищаем обработчики на document
        document.onmousemove = null;
        document.oncontextmenu = null;
        document.onmouseup = null;
    }

    return SetValue;
}

//Модификатор. Добавляет вертикальный скрол в внутрь контейнера inDiv.
//1. В имеющийся inDiv добавляет 2 новых контейнера: для контента DivContent и для скрола DivScroll.
//2. Когда DivContent изменился, и стал больше (по высоте) чем inDiv, то появляется DivScroll
//3. DivScroll управляет положением DivContent относительно inDiv. Всё что за пределами inDiv - будет скрыто.
//4. Возвратит DivContent контейнера для контента,его ширина меньше на G.D.S.ScrollThickness.
//* Место под DivScroll зарезервировано, даже при отсутствии скрола.
//* Два новых контейнера займут всё имеющееся пространство inDiv
//* функция DivContent.UpdateScroll() - нужно вызывать после обновления контента 
//Если указать ID [string] то ползунок будет помнить своё положение при переходе между страницами.
let ModDivScrollVID = {};
function ModDivScrollV(inDiv, ID) {



    //Размеры окна
    let Size_inDiv = GetDivPS_Parent(inDiv);//GetDivSizeContent
    //Толщина линии скольжения.
    let ScrollThickness = G.D.S.ScrollThickness;

    //1. В имеющийся inDiv добавляет 2 новых контейнера: для контента DivContent и для скрола DivScroll.
    let w = Size_inDiv.w - ScrollThickness;
    let h = Size_inDiv.h;
    let DivContent = Container([0, "", 0, ""], [w, h], inDiv);
    let DivScroll = Container([0, "", w, ""], [ScrollThickness, h], inDiv);


    //Скрываем всё что не помещается в контейнер
    inDiv.style.overflow = "hidden";



    //При перемещении ползунка, в эту функцию отправляется значение (0-1)
    let ScrollMove = function (value) {
        //Пришло значение value, после сдвига ползунка
        let Size_DivContent = GetDivPS_Parent(DivContent);//GetDivSizeContent
        let Dh = Size_inDiv.h - Size_DivContent.h;
        let top = Dh * value;
        DivContent.style.top = top + "px";
        if (ID) {
            ModDivScrollVID[ID] = value;
        }
    };

    //Ф - ция принимает значение (0 - 1), и в соответствии со значениями перемещает ползунки.
    let FncSetValueScroll = ScrollBar([0, "", 0, ""], Size_inDiv.h, "vertical", ScrollMove, DivScroll);

    //Обновление скрола. Вызывается, когда размер DivContent изменился в следствии изменения контента. 
    //Эту ф-цию необходимо вызывать вручную, каждый раз, когда меняется размер контента.
    DivContent.UpdateScroll = function () {
        //let tDivContent = GetDivPS_Parent(DivContent).t;
        //Обновляем высоту DivContent
        let h = 0;//Высота контейнера
        for (let i = 0; i < DivContent.childNodes.length; i++) { //Перебор детей, ищем самый нижний элемент
            let ChildDiv = GetDivPS_Parent(DivContent.childNodes[i]);
            //let ChildDiv = GetDivPS_Viewport(DivContent.childNodes[i]) ;
            //console.log("ChildDiv.t=" + ChildDiv.t + " ChildDiv.h=" + ChildDiv.h);
            let ih = ChildDiv.t + ChildDiv.h + G.D.S.GapIn;//-Size_inDiv.t-tDivContent
            //console.log("ih=" + ih);
            if (h < ih) {
                h = ih;
            }
        }
        //console.log("GetDivPS_Viewport(DivContent).t=" + GetDivPS_Viewport(DivContent).t + " GetDivPS_Parent(DivContent).t=" + GetDivPS_Parent(DivContent).t);


        //Задаем высоту
        DivContent.style.height = Math.round(h) + "px";
        //Проверяем. Вышел ли DivContent за пределы inDiv
        let Size_DivContent = GetDivPS_Parent(DivContent)
        let Size_inDiv = GetDivPS_Parent(inDiv);

        if (Size_DivContent.h > Size_inDiv.h) { // Контент больше чем вмещается в контейнер, добавляем скролл.(Size_DivContent.h > Size_inDiv.h) 
            DivScroll.style.visibility = "visible"; //Отображаем скролл            
            let Dh = Size_inDiv.h - Size_DivContent.h;//Разница высот, или интервал в котором будет находиться top позиция DivContent
            let value = Size_DivContent.t / Dh;
            //console.log("ID =" + ID + " ModDivScrollVID[ID]=" + ModDivScrollVID[ID]);

            if (ID in ModDivScrollVID) {
                value = ModDivScrollVID[ID];
                ScrollMove(value);
            }
            FncSetValueScroll(value);//Смещение скрола
            //Событие колесика мыши, над inDiv. Двигаем вверх/вниз DivContent
            inDiv.onwheel = function (event) {
                let delta = Math.round(event.deltaY / 5);
                //delta > 0 - График сжимается; delta < 0 - График расширяется;
                let Size_DivContent = GetDivPS_Parent(DivContent);
                //console.log("delta=" + delta + " Size_DivContent.t=" + Size_DivContent.t);
                let t = Math.round(Size_DivContent.t - delta);
                if (t > 0) {
                    t = 0;
                } else {
                    //console.log("Size_DivContent.t=" + Size_DivContent.t + " Size_DivContent.h=" + Size_DivContent.h + " Size_inDiv.h=" + Size_inDiv.h);
                    if (t < Size_inDiv.h - Size_DivContent.h) {
                        t = Size_inDiv.h - Size_DivContent.h;
                    }
                }

                DivContent.style.top = t + "px";//двигаем вверх/вниз DivContent
                let value = t / Dh;
                FncSetValueScroll(value);//Смещение скрола
                if (ID) {
                    ModDivScrollVID[ID] = value;
                }
            }
        } else {// Контент вмещается в контейнер, убираем скролл.
            DivScroll.style.visibility = "hidden"; //Скрываем скролл
            DivContent.style.top = "0px";//двигаем вверх DivContent
            inDiv.onwheel = null;
        }
    }

    //DivContent.UpdateScroll();
    return DivContent;
};



function ModDivScrollH(inDiv) {
    //Размеры окна
    let Size_inDiv = GetDivPS_Parent(inDiv);//GetDivSizeContent
    //Толщина линии скольжения.
    let ScrollThickness = G.D.S.ScrollThickness;

    //1. В имеющийся inDiv добавляет 2 новых контейнера: для контента DivContent и для скрола DivScroll.
    let w = Size_inDiv.w;
    let h = Size_inDiv.h - ScrollThickness;
    let DivContent = Container([0, "", 0, ""], [w, h], inDiv);
    let DivScroll = Container([h, "", 0, ""], [w, ScrollThickness], inDiv);


    //Скрываем всё что не помещается в контейнер
    inDiv.style.overflow = "hidden";



    //При перемещении ползунка, в эту функцию отправляется значение (0-1)
    let ScrollMove = function (value) {
        //Пришло значение value, после сдвига ползунка
        let Size_DivContent = GetDivPS_Parent(DivContent);//GetDivSizeContent
        let Dw = Size_inDiv.w - Size_DivContent.w;
        let left = Dw * value;
        DivContent.style.left = left + "px";
    };

    //Ф - ция принимает значение (0 - 1), и в соответствии со значениями перемещает ползунки.
    let FncSetValueScroll = ScrollBar([0, "", 0, ""], Size_inDiv.w, "horizontal", ScrollMove, DivScroll);

    //Обновление скрола. Вызывается, когда размер DivContent изменился в следствии изменения контента. 
    //Эту ф-цию необходимо вызывать вручную, каждый раз, когда меняется размер контента.
    DivContent.UpdateScroll = function () {
        //let tDivContent = GetDivPS_Parent(DivContent).t;
        //Обновляем ширину DivContent
        let w = 0;//ширина контейнера
        for (let i = 0; i < DivContent.childNodes.length; i++) { //Перебор детей, ищем самый нижний элемент
            let ChildDiv = GetDivPS_Parent(DivContent.childNodes[i]);
            //let ChildDiv = GetDivPS_Viewport(DivContent.childNodes[i]) ;
            //console.log("ChildDiv.t=" + ChildDiv.t + " ChildDiv.h=" + ChildDiv.h);
            let iw = ChildDiv.l + ChildDiv.w + G.D.S.GapIn;//-Size_inDiv.t-tDivContent
            //console.log("ih=" + ih);
            if (w < iw) {
                w = iw;
            }
        }
        //console.log("GetDivPS_Viewport(DivContent).t=" + GetDivPS_Viewport(DivContent).t + " GetDivPS_Parent(DivContent).t=" + GetDivPS_Parent(DivContent).t);


        //Задаем высоту
        DivContent.style.width = Math.round(w) + "px";
        //Проверяем. Вышел ли DivContent за пределы inDiv
        let Size_DivContent = GetDivPS_Parent(DivContent)
        let Size_inDiv = GetDivPS_Parent(inDiv);

        if (Size_DivContent.w > Size_inDiv.w) { // Контент больше чем вмещается в контейнер, добавляем скролл.(Size_DivContent.h > Size_inDiv.h) 
            DivScroll.style.visibility = "visible"; //Отображаем скролл            
            let Dw = Size_inDiv.w - Size_DivContent.w;
            let value = Size_DivContent.l / Dw;
            FncSetValueScroll(value);//Смещение скрола
            //Событие колесика мыши, над inDiv. Двигаем вверх/вниз DivContent
            inDiv.onwheel = function (event) {
                let delta = Math.round(event.deltaY / 5);
                //delta > 0 - График сжимается; delta < 0 - График расширяется;
                let Size_DivContent = GetDivPS_Parent(DivContent);
                //console.log("delta=" + delta + " Size_DivContent.t=" + Size_DivContent.t);
                let l = Math.round(Size_DivContent.l - delta);
                if (l > 0) {
                    l = 0;
                } else {
                    //console.log("Size_DivContent.t=" + Size_DivContent.t + " Size_DivContent.h=" + Size_DivContent.h + " Size_inDiv.h=" + Size_inDiv.h);
                    if (l < Size_inDiv.w - Size_DivContent.w) {
                        l = Size_inDiv.w - Size_DivContent.w;
                    }
                }

                DivContent.style.left = l + "px";//двигаем вверх/вниз DivContent
                let value = l / Dw;
                FncSetValueScroll(value);//Смещение скрола
            }
        } else {// Контент вмещается в контейнер, убираем скролл.
            DivScroll.style.visibility = "hidden"; //Скрываем скролл
            DivContent.style.left = "0px";//двигаем вверх DivContent
            inDiv.onwheel = null;
        }
    }

    //DivContent.UpdateScroll();
    return DivContent;
};

function ModDivScrollH2(inDiv, DivScroll, onwheel) {
    //Размеры окна
    let Size_inDiv = GetDivPS_Parent(inDiv);//GetDivSizeContent
    //Толщина линии скольжения.
    let ScrollThickness = G.D.S.ScrollThickness;

    //1. В имеющийся inDiv добавляет 2 новых контейнера: для контента DivContent и для скрола DivScroll.
    let w = Size_inDiv.w;
    let h = Size_inDiv.h; //- ScrollThickness
    let DivContent = Container([0, "", 0, ""], [w, h], inDiv);



    //Скрываем всё что не помещается в контейнер
    inDiv.style.overflow = "hidden";



    //При перемещении ползунка, в эту функцию отправляется значение (0-1)
    let ScrollMove = function (value) {
        //Пришло значение value, после сдвига ползунка
        let Size_DivContent = GetDivPS_Parent(DivContent);//GetDivSizeContent
        let Dw = Size_inDiv.w - Size_DivContent.w;
        let left = Dw * value;
        DivContent.style.left = left + "px";
    };

    //Ф - ция принимает значение (0 - 1), и в соответствии со значениями перемещает ползунки.
    let FncSetValueScroll = ScrollBar([0, "", 0, ""], Size_inDiv.w, "horizontal", ScrollMove, DivScroll);

    //Обновление скрола. Вызывается, когда размер DivContent изменился в следствии изменения контента. 
    //Эту ф-цию необходимо вызывать вручную, каждый раз, когда меняется размер контента.
    DivContent.UpdateScroll = function () {
        //let tDivContent = GetDivPS_Parent(DivContent).t;
        //Обновляем ширину DivContent
        let w = 0;//ширина контейнера
        for (let i = 0; i < DivContent.childNodes.length; i++) { //Перебор детей, ищем самый нижний элемент
            let ChildDiv = GetDivPS_Parent(DivContent.childNodes[i]);
            //let ChildDiv = GetDivPS_Viewport(DivContent.childNodes[i]) ;
            //console.log("ChildDiv.t=" + ChildDiv.t + " ChildDiv.h=" + ChildDiv.h);
            let iw = ChildDiv.l + ChildDiv.w + G.D.S.GapIn;//-Size_inDiv.t-tDivContent
            //console.log("ih=" + ih);
            if (w < iw) {
                w = iw;
            }
        }
        //console.log("GetDivPS_Viewport(DivContent).t=" + GetDivPS_Viewport(DivContent).t + " GetDivPS_Parent(DivContent).t=" + GetDivPS_Parent(DivContent).t);


        //Задаем высоту
        DivContent.style.width = Math.round(w) + "px";
        //Проверяем. Вышел ли DivContent за пределы inDiv
        let Size_DivContent = GetDivPS_Parent(DivContent)
        let Size_inDiv = GetDivPS_Parent(inDiv);

        if (Size_DivContent.w > Size_inDiv.w) { // Контент больше чем вмещается в контейнер, добавляем скролл.(Size_DivContent.h > Size_inDiv.h) 
            DivScroll.style.visibility = "visible"; //Отображаем скролл            
            let Dw = Size_inDiv.w - Size_DivContent.w;
            let value = Size_DivContent.l / Dw;
            FncSetValueScroll(value);//Смещение скрола
            //Событие колесика мыши, над inDiv. Двигаем вверх/вниз DivContent
            if (onwheel) {
                inDiv.onwheel = function (event) {
                    let delta = Math.round(event.deltaY / 5);
                    //delta > 0 - График сжимается; delta < 0 - График расширяется;
                    let Size_DivContent = GetDivPS_Parent(DivContent);
                    //console.log("delta=" + delta + " Size_DivContent.t=" + Size_DivContent.t);
                    let l = Math.round(Size_DivContent.l - delta);
                    if (l > 0) {
                        l = 0;
                    } else {
                        //console.log("Size_DivContent.t=" + Size_DivContent.t + " Size_DivContent.h=" + Size_DivContent.h + " Size_inDiv.h=" + Size_inDiv.h);
                        if (l < Size_inDiv.w - Size_DivContent.w) {
                            l = Size_inDiv.w - Size_DivContent.w;
                        }
                    }

                    DivContent.style.left = l + "px";//двигаем вверх/вниз DivContent
                    let value = l / Dw;
                    FncSetValueScroll(value);//Смещение скрола
                }
            }

        } else {// Контент вмещается в контейнер, убираем скролл.
            DivScroll.style.visibility = "hidden"; //Скрываем скролл
            DivContent.style.left = "0px";//двигаем вверх DivContent
            inDiv.onwheel = null;
        }
    }

    //DivContent.UpdateScroll();
    return DivContent;
};


//Позиция Размер Включен?
function CheckBox_Simple(P, S, On, fnOn, inDiv) {

    let DivFrameContainer = FrameContainer(P, S, G.D.C.WinFon, inDiv);
    //особенности
    DivFrameContainer.style.cursor = "pointer";

    let w = S[0] - 4 * G.D.S.FrameSize;
    let h = S[1] - 4 * G.D.S.FrameSize;

    let DivContainer = Container([G.D.S.FrameSize, "", G.D.S.FrameSize, ""], [w, h], DivFrameContainer);
    if (On) {//включить
        DivContainer.style.background = G.D.C.ButtonFon;
    } else {
        DivContainer.style.background = G.D.C.WinFon;
    }
    DivFrameContainer.onclick = function () {
        if (On) {//было включено. Выключить
            DivContainer.style.background = G.D.C.WinFon;
            On = false;
            fnOn(false);
        } else {
            DivContainer.style.background = G.D.C.ButtonFon;
            On = true;
            fnOn(true);
        }

    }

}
function CheckBox(P, S, On, fnOn, inDiv) {

    let DivFrameContainer = FrameContainer(P, S, G.D.C.ButtonFon, inDiv);

    //особенности
    DivFrameContainer.style.cursor = "pointer";

    let w = S[0] - 2 * G.D.S.FrameSize;
    let h = S[1] - 2 * G.D.S.FrameSize;

    let DivCheckBox = ImageSVG([0, "", 0, ""], [w, h], SVG_CheckBox(), DivFrameContainer);
    if (On) {//включить
        DivCheckBox.style.display = "inline";
    } else {
        DivCheckBox.style.display = "none";
    }
    DivFrameContainer.onclick = function () {
        if (On) {//было включено. Выключить
            DivCheckBox.style.display = "none";
            On = false;
            fnOn(false);
        } else {
            DivCheckBox.style.display = "inline";
            On = true;
            fnOn(true);
        }

    }

}
function CheckBoxInactive(P, S, On, inDiv) {

    let DivFrameContainer = FrameContainer(P, S, G.D.C.ButtonFon, inDiv);

    if (On) {//включить
        let w = S[0] - 2 * G.D.S.FrameSize;
        let h = S[1] - 2 * G.D.S.FrameSize;
        let DivCheckBox = ImageSVG([0, "", 0, ""], [w, h], SVG_CheckBox(), DivFrameContainer);
        DivCheckBox.style.opacity = 0.25;
    }
}


//Кнопка с текстом. ID назначено тексту (названию кнопки). Возвратит Div фона (названию кнопки)
//(APosition[], высота(int/"auto"/"100%"), ширина, скругление "r0r0", ВысотаСтроки, содержимое, ID, inDiv/"body")
// Где APosition[]=[верх(int/""), низ, лево, право](absolute) / [Обтекание("left"/"right"/""), Внеш. отступ: верх(int), низ, лево, право](static)
// Где Rounding: радиус для: верхнего левого, верхнего правого, нижнего правого и нижнего левого уголка.
function ContainerText(P, S, Align, Content, inDiv) {
    //Контейнер
    let Div = Container(P, S, inDiv);
    //Текст
    let h = S[1];
    //Если текст в рамке то его высота будет меньше контейнера на 2 толщины рамки. Height = Высота контейнер (с рамкой) - 2 * G.D.S.FrameSize 
    //h = h - 2 * G.D.S.FrameSize;
    DivText(h, G.D.C.ButtonText, G.D.S.FontSizeNormal, "normal", Align, Content, Div);
    //особености
    Div.style.cursor = "pointer";
    //Событие
    //фокус
    Div.onmouseover = function () {
        Div.style.background = G.D.C.ButtonFonFocus;
        Div.style.color = G.D.C.ButtonTextFocus;
    };
    //НЕ фокус
    Div.onmouseout = function () {
        Div.style.background = G.D.C.ButtonFon;
        Div.style.color = G.D.C.ButtonText;
    };
    return Div;
}

//Выпадающий список.
//Для обработки выбора использовать функцию DivFrameContainer.fnSelectContent = function (SelectContent) {}, в качестве аргумента принимает выбранную строку
//SelectContent- текст который будет отображен по умолчанию
//ListContent - массив текста в выпадающем списке
function ListSelect(P, S, SelectContent, ListContent, inDiv) {
    //Поле----
    //Контейнер
    let DivFrameContainer = FrameContainer(P, S, G.D.C.ButtonFon, inDiv);
    DivFrameContainer.style.overflow = "hidden";    //Скрываем всё что не помещается в контейнер

    //Текст
    let h = S[1];
    //Если текст в рамке то его высота будет меньше контейнера на 2 толщины рамки. Height = Высота контейнер (с рамкой) - 2 * G.D.S.FrameSize 
    h = h - 2 * G.D.S.FrameSize;
    let DivSelectContent = ContainerText([0, "", "", G.D.S.FrameSize], [S[0], h], "right", SelectContent, DivFrameContainer);//первая строка списка
    // Список---- 
    let t = S[1];
    for (let i = 0; i < ListContent.length; i++) {
        //if (ListContent[i] != SelectContent) {
        if (ListContent[i] != DivSelectContent.innerHTML) {

            //console.log("  ListContent[i] "+ListContent[i]+"  SelectContent "+SelectContent);
            let DivTextList = ContainerText([t, "", "", G.D.S.FrameSize], [S[0], h], "right", ListContent[i], DivFrameContainer);
            DivTextList.onclick = function (event) {
                //event.stopPropagation();//Запрет всплытия событий. Чтобы не сработал DivFrameContainer.onclick
                DivFrameContainer.style.height = S[1] + "px";
                DivSelectContent.innerHTML = ListContent[i];
                DivFrameContainer.fnSelectContent(ListContent[i]);
                //console.log("  DivTextList.onclick ");

            }
            t += G.D.S.ContFontSizeNormal;
        }
    }
    //Событие
    let First = true; //Флаг первого срабатывания.
    let hideFn = function () {
        if (First) { //Первый раз функция сработает в следствии "всплытия" событий, по этому выходим. Во второй раз ф-ция полностью сработает.
            First = false;
            return;
        }
        First = true;
        //console.log("  DivFrameContainer.style.height " + DivFrameContainer.style.height);
        DivFrameContainer.style.height = S[1] + "px";//сворачивание окна
        DivFrameContainer.style.zIndex = 0; //возвращаем нормальный слой
        document.removeEventListener("click", hideFn);//удаление события из документа
        //return true;
    }
    DivSelectContent.onclick = function () {
        DivFrameContainer.style.height = (ListContent.length * G.D.S.ContFontSizeNormal) + "px";
        DivFrameContainer.style.zIndex = 1;//поднимаем на слой выше  
        document.addEventListener("click", hideFn);//добавление события в документ. Клик в любом месте        
        //Обновление скрола родительуого div
        if ("UpdateScroll" in inDiv) {//(inDiv.UpdateScroll)
            inDiv.UpdateScroll();
        }

    }

    return DivFrameContainer;

}

//Разделительная линия. Direction("vertical"/"horizontal")
//P позиция [t,b,l,r];
function DemarcationLine(P, Length, Direction, inDiv) {
    let Div;
    //Горизонтальное положение-------------------
    if (Direction == "horizontal") {
        Div = Container(P, [Length, 1], inDiv);
    }

    //Вертикальное положение-------------------
    if (Direction == "vertical") {
        Div = Container(P, [1, Length], inDiv);
    }
    Div.style.background = G.D.C.Frame;
    return Div;
}







//Текстовый блок выбора интервала на графике.
//t Верхняя точка, w ширина контента,  TimeStart, TimeEnd начальные значения, fTimeStartOnchange, fTimeEndOnchange функции которые будут вызваны при изменении значений, inDiv контейнер.
function ModuleTextInterval(t, w, NameChart, TimeStart, TimeEnd, fTimeStartOnchange, fTimeEndOnchange, inDiv) {

    let l0 = G.D.S.GapIn;
    let l1 = l0 + G.D.S.Tab;
    let h = G.D.S.ContFontSizeNormal;

    //Интервал тестирования. "Интервал"
    TextSimple([t, "", l0, ""], ["", ""], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", G.L[G.S.L].Interval, inDiv);
    t += h;

    //"Период от [время]"
    TextSimple([t, "", l1, ""], ["", ""], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", G.L[G.S.L].bsi010, inDiv);
    let TimeStartFormat = UnixToDate(TimeStart).date + " " + UnixToDate(TimeStart).time;
    let Div_TimeStart = TextFrameInput([t, "", "", l0], [w, h], 19, TimeStartFormat, inDiv);
    Div_TimeStart.onchange = function () {   //событие изменение содержания поля ввода текста
        TimeStart = DateToUnix(Div_TimeStart.value);
        //NNSet.TestTimeStart = DateToUnix(Div_TimeStart.value);
        //SaveNNSet(NNSet, NameNN);
        fTimeStartOnchange(TimeStart);
        //обновление графика
        delete G.C.N["Interval" + NameChart];
        UpdateDataChart("Interval", NameChart, [TimeStart, TimeEnd], "time", "Interval");
    };
    t += h;
    //"Указать"
    let Div_TimeStartButton = ButtonText([t, "", "", l0], [w, h], G.L[G.S.L].bsi030, inDiv);
    t += h;


    //"Период до [время]"
    TextSimple([t, "", l1, ""], ["", ""], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", G.L[G.S.L].bsi020, inDiv);
    let TimeEndFormat = UnixToDate(TimeEnd).date + " " + UnixToDate(TimeEnd).time;
    let Div_TimeEnd = TextFrameInput([t, "", "", l0], [w, h], 19, TimeEndFormat, inDiv);
    Div_TimeEnd.onchange = function () {   //событие изменение содержания поля ввода текста
        TimeEnd = DateToUnix(Div_TimeEnd.value);
        //NNSet.TestTimeEnd = DateToUnix(Div_TimeEnd.value);
        //SaveNNSet(NNSet, NameNN);
        fTimeEndOnchange(TimeEnd);
        //обновление графика
        delete G.C.N["Interval" + NameChart];
        UpdateDataChart("Interval", NameChart, [TimeStart, TimeEnd], "time", "Interval");
    };
    t += h;
    // "Указать"
    let Div_TimeEndButton = ButtonText([t, "", "", l0], [w, h], G.L[G.S.L].bsi030, inDiv);
    t += h;

    //"Продолжительность"
    TextSimple([t, "", l1, ""], ["", ""], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", G.L[G.S.L].Duration, inDiv);
    let Div_Duration = TextSimple([t, "", "", l0], ["", ""], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", DurationMsToDate(TimeEnd - TimeStart), inDiv);


    let IntervalProbeX = function (EditTime) {   //событие клик на кнопке  "Указать"
        let Div_Time;//Текстовое поле в зависимости от выбора
        let Time;//TimeStart или TimeEnd в зависимости от выбора
        switch (EditTime) {
            case "Start":
                Div_Time = Div_TimeStart;
                Time = TimeStart;
                break;
            case "End":
                Div_Time = Div_TimeEnd;
                Time = TimeEnd;
                break;
        };

        Div_Time.style.background = G.D.C.ButtonFonFocus;
        G.C.DivEvent.onclick = function (event) {//клик на графике
            let ProbeX = G.C.DivEvent.ProbeX(event);
            Time = Math.round(ProbeX);
            //Верификация
            Time = NumToMultiplicity(Time, 60000, 0);//кратное 1 минуте
            switch (EditTime) {
                case "Start":
                    TimeStart = Time;
                    if (TimeEnd - TimeStart <= 60000) {//минимальный зазор 1 минута
                        TimeStart = TimeEnd - 60000;
                        Time = TimeStart;
                    }
                    break;
                case "End":
                    TimeEnd = Time;
                    if (TimeEnd - TimeStart <= 60000) {//минимальный зазор 1 минута
                        TimeEnd = TimeStart + 60000;
                        Time = TimeEnd;
                    }
                    break;
            };

            Div_Time.value = UnixToDate(Time).date + " " + UnixToDate(Time).time;
            G.C.DivEvent.onclick = null;
            Div_Time.style.background = G.D.C.FonTextBox;
            Div_Duration.innerHTML = DurationMsToDate(TimeEnd - TimeStart);
            //SaveNNSet(NNSet, NameNN);

            switch (EditTime) {
                case "Start":
                    fTimeStartOnchange(TimeStart);
                    break;
                case "End":
                    fTimeEndOnchange(TimeEnd);
                    break;
            };

            //обновление графика
            delete G.C.N["Interval" + NameChart];
            UpdateDataChart("Interval", NameChart, [TimeStart, TimeEnd], "time", "Interval");
            DrawChart();
        };
    };

    Div_TimeEndButton.onclick = function () { IntervalProbeX("End"); }
    Div_TimeStartButton.onclick = function () { IntervalProbeX("Start"); }

    delete G.C.N["Interval" + NameChart];
    UpdateDataChart("Interval", NameChart, [TimeStart, TimeEnd], "time", "Interval");
    return t;
}




//Мини график
//Пример
//let DivContainer= Container([t, "", l, ""], [w, h], inDiv);
//let Div = MiniChartContainer(G.D.S.ContFontSizeNormal, 20, DivContainer);
//MiniChart(Data,  G.D.C.Palette[5],  0, "auto", 0, 1, Div);

function MiniChart(Data, Color, MinX, MaxX, MinY, MaxY, Div) {


    //Data = входящая [X, Y,  ...]; 

    if (Data.length < 2) {
        return;
    }
    //Создаем холст на всю ширину и высрту Div.Chart
    //Масштабируем данные  
    //Отрисовываем



    //0.Не Очишаем
    //Div.Chart.innerHTML = "";
    //1. Получаем размеры графической части.
    let CanvasSize = GetDivSizeContent(Div.Chart);
    //2. Создаем CANVAS      
    let canvas = document.createElement("CANVAS");
    canvas.width = CanvasSize.w;
    canvas.height = CanvasSize.h;
    //Позиционирование
    let Ds = canvas.style;
    Ds.position = "absolute";
    Ds.top = "0px";
    Ds.left = "0px";
    //вставляем в Div.Chart
    Div.Chart.appendChild(canvas);
    //Присваиваем элементу контекст
    Сontext = canvas.getContext("2d");

    //Преобразование данных в 
    let DataX = [];
    let DataY = [];

    for (let i = 0; i < Data.length; i = i + 2) {
        DataX.push(Data[i]);
        DataY.push(Data[i + 1]);
    }
    //console.log("DataX " + DataX);
    //console.log("DataY " + DataY);


    //Минимум и Максимум
    if (MinX == "auto") {
        MinX = DataX[0];
    }
    if (MaxX == "auto") {
        MaxX = DataX[DataX.length - 1];
    }
    if (MinY == "auto") {
        MinY = Infinity;
        for (let i = 0; i < DataY.length; i++) {
            if (MinY > DataY[i]) {
                MinY = DataY[i];
            }
        }
    }
    if (MaxY == "auto") {
        MaxY = -Infinity;
        for (let i = 0; i < DataY.length; i++) {
            if (MaxY < DataY[i]) {
                MaxY = DataY[i];
            }

        }
    }

    //console.log("MinX " + MinX);
    //console.log("MaxX " + MaxX);
    //console.log("MinY " + MinY);
    //console.log("MaxY " + MaxY);


    //Вычисляем коэффициент, на который будем умножать значение, и получать пикселы. (сколько в 1 X/Y единице - пикселей.)
    //1/Kpx= сколько в 1 пикселе - X/Y единице
    let X_Kpx = CanvasSize.w / (MaxX - MinX);
    let Y_Kpx = CanvasSize.h / (MaxY - MinY);

    //4. Карта, соответствия координатам [пиксель] и элементам данных, для событий и построения.
    //Создадим карту элементов, чтобы потом по координатам клика мыши - можно определить на какой свече находиться мышь.
    //Структура двумерный массив: MapDisplayData[[X[px], Y[px]],... ] 
    //X[px], Y[px] - это точка данных на графике (от левого верхнего угла)
    MapDisplayData = [];
    for (let i = 0; i < DataX.length; i++) {//перебор всех данных
        if (DataX[i] > MaxX) {
            //break;
        }
        let X = X_Kpx * (DataX[i] - MinX);
        let Y = CanvasSize.h - (Y_Kpx * (DataY[i] - MinY));
        let add = [X, Y];
        MapDisplayData.push(add);
    }

    //отрисовка
    //console.log("ChartLine");
    Сontext.translate(0.5, 0.5);//Смещает все пикселы на 0,5 для контраста
    //Используем MapDisplayData.
    Сontext.lineWidth = 1;//толщина линии
    //Цвет линии
    // Сontext.strokeStyle = Color;
    Сontext.strokeStyle = "rgba(" + Color[0] + "," + Color[1] + "," + Color[2] + ",1)";

    Сontext.lineCap = "round";//тип конца линии
    Сontext.beginPath();//начинает новый, отдельный путь
    Сontext.moveTo(MapDisplayData[0][0], MapDisplayData[0][1]);//Стартовая точка
    //context.moveTo(Math.round(GCNName.MapDisplayData[0][0]), Math.round(GCNName.MapDisplayData[0][1]));//Стартовая точка
    for (let i = 1; i < MapDisplayData.length; i++) {
        Сontext.lineTo(MapDisplayData[i][0], MapDisplayData[i][1]);
        //context.lineTo(Math.round(GCNName.MapDisplayData[i][0]), Math.round(GCNName.MapDisplayData[i][1]));

    }
    //if (Name == "OutputData0test") {//инфо блок
    //    console.log(" Карта, соответствия координатам для графика " + Name + ": Количество точек =" + G.C.N[Name].MapDisplayData.length);
    //}


    //отрисовка
    Сontext.stroke();//
    Сontext.translate(-0.5, -0.5);//Вочтанавливает смещение 

    let Limit = {};
    Limit.MinX = MinX;
    Limit.MaxX = MaxX;
    Limit.MinY = MinY;
    Limit.MaxY = MaxY;

    Div.MinX.innerHTML = MinX.toFixed(2);
    Div.MaxX.innerHTML = MaxX.toFixed(2);
    Div.MinY.innerHTML = MinY.toFixed(0);
    Div.MaxY.innerHTML = MaxY.toFixed(0);

    return Limit;

}

//Контейнер для графика
function MiniChartContainer(AxisXh, AxisYw, inDiv) {


    //Ширина осей
    //AxisYw   Контейнер Y оси  
    //AxisXh   Контейнер X оси

    let Size = GetDivSizeContent(inDiv);

    let h = G.D.S.ContFontSizeNormal;


    //Контейнер графической части
    let tc = 0;
    let lc = AxisXh;
    let wc = Size.w - AxisYw;
    let hc = Size.h - AxisXh;
    //   Контейнер Y оси 
    let tY = 0;
    let lY = 0;
    let wY = AxisYw;
    let hY = Size.h - AxisXh;
    //   Контейнер X оси
    let tX = Size.h - AxisXh;
    let lX = AxisYw;
    let wX = Size.w - AxisYw;
    let hX = AxisXh;


    //-------------------------
    //Размещаем контейнеры.
    //   Контейнер Y оси
    let DivY = Container([tY, "", lY, ""], [wY, hY], inDiv);
    //   Контейнер X оси
    let DivX = Container([tX, "", lX, ""], [wX, hX], inDiv);
    //   Контейнер графической части
    let DivChart = Container([tc, "", lc, ""], [wc, hc], inDiv);

    //console.log("G.C.DivC инициализирован");

    //Прорисовка осей при помощи рамок
    DivY.style.borderRight = "1px solid " + G.D.C.ChartBox;
    DivX.style.borderTop = "1px solid " + G.D.C.ChartBox;
    //Квадратик рисующий продолжение осей
    let DivXY = Container([tX, "", lY, ""], [wY, hX], DivContainer);
    DivXY.style.borderTop = "1px solid " + G.D.C.ChartBox;
    DivXY.style.borderRight = "1px solid " + G.D.C.ChartBox;


    //Подписи осей
    let DivMinX = TextSimple([0, 0, "", ""], ["", ""], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", "", DivX);
    let DivMaxX = TextSimple([0, "", "", 1], ["", ""], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", "", DivX);

    let DivMinY = TextSimple(["", 1, 0, ""], ["", ""], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", "", DivY);
    let DivMaxY = TextSimple([0, "", 0, ""], ["", ""], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", "", DivY);

    let Div = {};
    Div.MinX = DivMinX;
    Div.MaxX = DivMaxX;
    Div.MinY = DivMinY;
    Div.MaxY = DivMaxY;
    Div.Chart = DivChart;
    return Div;
}
