
//let DivLogo = imageSVG(["", 0, 0, 0, 0], 37, 30, SVG_ChessLogo(), Menu1);

let NS_svg = "http://www.w3.org/2000/svg";


//Изображение SVG. Возвратит Div <svg>
//(APosition[], высота(int/"auto"/"100%"), ширина, объект-SVG, inDiv/"body")
// Где APosition[]=[верх(int/""), низ, лево, право](absolute) / [Обтекание("left"/"right"/""), Внеш. отступ: верх(int), низ, лево, право](static)
function ImageSVG(P, S, fSVG, inDiv) {
    //Создаем тег <svg></svg>  ---------------------------
    let Div = document.createElementNS(NS_svg, "svg");
    let Ds = Div.style;
    //Позиционирование (""/"A"/"R") (static/absolute/relative)
    Ds.position = "absolute";
    //Координаты: (""/число).
    Ds.top = (P[0] == "") ? "" : Math.round(P[0]) + "px";
    Ds.bottom = (P[1] == "") ? "" : Math.round(P[1]) + "px";
    Ds.left = (P[2] == "") ? "" : Math.round(P[2]) + "px";
    Ds.right = (P[3] == "") ? "" : Math.round(P[3]) + "px";

    //Размеры: (число/"auto"/"100%")    
    Ds.width = (typeof S[0] == "number") ? Math.round(S[0]) + "px" : S[0];
    Ds.height = (typeof S[1] == "number") ? Math.round(S[1]) + "px" : S[1];
    //вставляем новый Div в inDiv
    inDiv.appendChild(Div);

    //------------------------------------------------------------------------------------------------------------------
    //Подгонка под h, w размеры
    //области просмотра
    Div.setAttribute("viewBox", "0 0 " + fSVG[0] + " " + fSVG[1]);
    //none означает, что изображение должно полностью отобразится в области просмотра даже если придется исказить пропорции изображения.
    //Div.setAttribute("preserveAspectRatio", "none");

    //Вставляем в тег <svg></svg> подобъекты. Начиная с 3 элемента fSVG[0] и fSVG[1] - зарезервированные переменные размеров
    for (let i = 2; i < fSVG.length; i++) {
        Div.appendChild(fSVG[i]);
    }
    return Div
}


//Изображение SVG. Возвратит Div <svg>
//(APosition[], высота(int/"auto"/"100%"), ширина, объект-SVG, inDiv/"body")
// Где APosition[]=[верх(int/""), низ, лево, право](absolute) / [Обтекание("left"/"right"/""), Внеш. отступ: верх(int), низ, лево, право](static)
function ImageFrameSVG(P, S, fSVG, ColorBackground, pointer, inDiv) {
    //Создаем тег <svg></svg>  ---------------------------
    let Div = ImageSVG(P, S, fSVG, inDiv);
    //Учитываем рамки. Переопределим атрибут. Ширина и высота после добавления рамок уменьшается и смещается
    Div.setAttribute("viewBox", (G.D.S.FrameSize) + " " + (G.D.S.FrameSize) + " " + (fSVG[0] - 2 * G.D.S.FrameSize) + " " + (fSVG[1] - 2 * G.D.S.FrameSize));
    Div.style.border = G.D.S.FrameSize + "px solid " + G.D.C.Frame;
    Div.style.borderRadius = G.D.S.Radius + "px ";
    if (ColorBackground != "") {
        Div.style.background = ColorBackground;
    }
    if (pointer) {
        Div.style.cursor = "pointer";
    }



    return Div;
}





//Иконка графика тип Box. С изменением цвета. Рекомендуемый размер ШхВ = 18х18. 
function SVG_ChatBox(Color) {
    let SVG_A = [];
    SVG_A.push(18); //ширина. Габарит при сохранении SVG.
    SVG_A.push(18); //высота. Габарит при сохранении SVG.
    let SVG_1 = document.createElementNS(NS_svg, "polygon");
    SVG_1.style.fill = Color;
    SVG_1.setAttribute("points", "16,2 10,2 10,17 16,17 ");
    SVG_A.push(SVG_1);
    let SVG_2 = document.createElementNS(NS_svg, "polygon");
    SVG_2.style.fill = Color;
    SVG_2.setAttribute("points", "8,17 8,10 2,10 2,17 ");
    SVG_A.push(SVG_2);
    return SVG_A
}

//Иконка графика тип Line. С изменением цвета. Рекомендуемый размер ШхВ = 18х18. 
function SVG_ChatLine(Color) {
    let SVG_A = [];
    SVG_A.push(22.61); //ширина. Габарит при сохранении SVG.
    SVG_A.push(22.61); //высота. Габарит при сохранении SVG.
    let SVG_1 = document.createElementNS(NS_svg, "path");
    SVG_1.style.fill = Color;
    SVG_1.setAttribute("d", "M1.26 22.61l5.77 -7.57 5.61 3.41c1.15,0.7 2.64,0.36 3.39,-0.76l6.58 -9.85 0 -4.99c0,-0.9 -0.48,-1.73 -1.25,-2.18l-8.17 12.23 -5.47 -3.33c-1.1,-0.67 -2.53,-0.4 -3.31,0.62l-4.41 5.78 0 4.47c0,0.9 0.48,1.72 1.26,2.17z");
    SVG_A.push(SVG_1);
    return SVG_A
}

//Иконка графика тип LineSeparated. С изменением цвета. Рекомендуемый размер ШхВ = 18х18. 
function SVG_ChatLineSeparated(Color) {
    let SVG_A = [];
    SVG_A.push(7.17); //ширина. Габарит при сохранении SVG.
    SVG_A.push(7.17); //высота. Габарит при сохранении SVG.
    let SVG_1 = document.createElementNS(NS_svg, "path");
    SVG_1.style.fill = Color;
    SVG_1.setAttribute("d", "M2.81 3.61c0,-0.22 -0.12,-0.43 -0.31,-0.54l-0.05 -0.04c-0.35,-0.21 -0.8,-0.12 -1.05,0.2l-1.4 1.83 0 1.42c0,0.28 0.15,0.55 0.4,0.69l1.83 -2.4 0.27 0.16c0.07,0.04 0.14,0.04 0.21,0.01 0.06,-0.04 0.1,-0.1 0.1,-0.18l0 -1.15z");
    SVG_A.push(SVG_1);
    let SVG_2 = document.createElementNS(NS_svg, "path");
    SVG_2.style.fill = Color;
    SVG_2.setAttribute("d", "M6.77 0.21l-2.59 3.88 -0.27 -0.17c-0.06,-0.04 -0.14,-0.04 -0.2,0 -0.07,0.03 -0.11,0.1 -0.11,0.17l0 1.16c0,0.22 0.12,0.42 0.31,0.54l0.09 0.06c0.37,0.22 0.84,0.11 1.08,-0.24l2.09 -3.12 0 -1.59c0,-0.28 -0.15,-0.54 -0.4,-0.69z");
    SVG_A.push(SVG_2);
    return SVG_A
}



//Иконка графика тип Dot. С изменением цвета. Рекомендуемый размер ШхВ = 18х18. 
function SVG_ChatDot(Color) {
    let SVG_A = [];
    SVG_A.push(101); //ширина. Габарит при сохранении SVG.
    SVG_A.push(101); //высота. Габарит при сохранении SVG.
    let SVG_1 = document.createElementNS(NS_svg, "path");
    SVG_1.style.fill = Color;
    SVG_1.style.fillRule = "evenodd";//Не закрашивает внутреннюю область
    SVG_1.setAttribute("d", "M51 6c25,0 45,20 45,45 0,25 -20,45 -45,45 -25,0 -45,-20 -45,-45 0,-25 20,-45 45,-45zm0 22c12,0 22,10 22,22 0,12 -10,22 -22,22 -12,0 -22,-10 -22,-22 0,-12 10,-22 22,-22z");
    SVG_A.push(SVG_1);
    return SVG_A
}



//Иконка графика тип Interval. С изменением цвета. Рекомендуемый размер ШхВ = 18х18. 
function SVG_ChatInterval(Color) {
    let SVG_A = [];
    SVG_A.push(114); //ширина. Габарит при сохранении SVG.
    SVG_A.push(114); //высота. Габарит при сохранении SVG.
    let SVG_1 = document.createElementNS(NS_svg, "polygon");
    SVG_1.style.fill = Color;
    SVG_1.setAttribute("points", "89,0 25,0 25,114 89,114");
    SVG_A.push(SVG_1);
    return SVG_A
}

//Иконка графика тип Horizontal. С изменением цвета. Рекомендуемый размер ШхВ = 18х18. 
function SVG_ChatHorizontal(Color) {
    let SVG_A = [];
    SVG_A.push(130); //ширина. Габарит при сохранении SVG.
    SVG_A.push(130); //высота. Габарит при сохранении SVG.
    let SVG_1 = document.createElementNS(NS_svg, "polygon");
    SVG_1.style.fill = Color;
    SVG_1.setAttribute("points", "0,51 0,80 130,80 130,51");
    SVG_A.push(SVG_1);
    return SVG_A
}




//Иконка плюс (добавить).  Рекомендуемый размер ШхВ = 18х18. 
function SVG_Plus() {
    let SVG_A = [];
    SVG_A.push(154); //ширина. Габарит при сохранении SVG.
    SVG_A.push(154); //высота. Габарит при сохранении SVG.
    let SVG_1 = document.createElementNS(NS_svg, "path");
    SVG_1.style.fill = G.D.C.Icon;
    SVG_1.setAttribute("d", "M90 56c0,2 1,4 3,6 2,2 4,2 6,2l34 0c7,0 13,6 13,13 0,7 -6,13 -13,13l-34 0c-2,0 -4,1 -6,3 -2,2 -3,4 -3,6l0 34c0,7 -6,13 -13,13 -7,0 -13,-6 -13,-13l0 -34c0,-2 -1,-4 -2,-6 -2,-2 -4,-3 -6,-3l-34 0c-5,0 -9,-2 -11,-6 -2,-4 -2,-9 0,-13 2,-4 7,-6 11,-6l34 0c5,0 9,-4 9,-9l0 -34c0,-5 2,-9 6,-11 4,-2 9,-2 13,0 4,2 6,7 6,11l0 34z");
    SVG_A.push(SVG_1);
    return SVG_A
}


//Иконка X (удалить).  Рекомендуемый размер ШхВ = 18х18. 
function SVG_Cross() {
    let SVG_A = [];
    SVG_A.push(188); //ширина. Габарит при сохранении SVG.
    SVG_A.push(188); //высота. Габарит при сохранении SVG.
    let SVG_1 = document.createElementNS(NS_svg, "path");
    SVG_1.style.fill = G.D.C.Icon;
    SVG_1.setAttribute("d", "M21 177l146 0c3,0 5,-1 7,-3 2,-2 3,-5 3,-7l0 -146c0,-3 -1,-5 -3,-7 -2,-2 -5,-3 -7,-3l-146 0c-3,0 -5,1 -7,3 -2,2 -3,4 -3,7l0 146c0,3 1,5 3,7 2,2 4,3 7,3zm0 10l146 0c11,0 21,-9 21,-21l0 -146c0,-11 -9,-21 -21,-21l-146 0c-11,0 -21,9 -21,21l0 146c0,11 9,21 21,21z");
    SVG_A.push(SVG_1);
    return SVG_A
}


//Иконка глаз (показать).  Рекомендуемый размер ШхВ = 18х18. 
function SVG_Show() {
    let SVG_A = [];
    SVG_A.push(240); //ширина. Габарит при сохранении SVG.
    SVG_A.push(240); //высота. Габарит при сохранении SVG.
    let SVG_1 = document.createElementNS(NS_svg, "path");
    SVG_1.style.fill = G.D.C.Icon;
    SVG_1.setAttribute("d", "M153 120c0,-18 -15,-33 -33,-33 -18,0 -33,15 -33,33 0,18 15,33 33,33 18,0 33,-15 33,-33z");
    SVG_A.push(SVG_1);
    let SVG_2 = document.createElementNS(NS_svg, "path");
    SVG_2.style.fill = G.D.C.Icon;
    SVG_2.style.fillRule = "evenodd";//Не закрашивает внутреннюю область
    SVG_2.setAttribute("d", "M223 106c-22,-36 -61,-58 -103,-58 -42,0 -81,22 -103,58 -5,8 -5,19 0,27 22,36 61,58 103,58 42,0 81,-22 103,-58 5,-8 5,-19 0,-27zm-56 14c0,-26 -21,-47 -47,-47 -26,0 -47,21 -47,47 0,26 21,47 47,47 26,0 47,-21 47,-47z");
    SVG_A.push(SVG_2);

    return SVG_A
}




//Иконка перечеркнутый глаз (скрыть).  Рекомендуемый размер ШхВ = 18х18. 
function SVG_Hide() {
    let SVG_A = [];
    SVG_A.push(340); //ширина. Габарит при сохранении SVG.
    SVG_A.push(340); //высота. Габарит при сохранении SVG.
    let SVG_1 = document.createElementNS(NS_svg, "path");
    SVG_1.style.fill = G.D.C.Icon;
    SVG_1.style.fillRule = "evenodd";//Не закрашивает внутреннюю область
    SVG_1.setAttribute("d", "M315 150c-11,-18 -24,-33 -40,-46l37 -37c11,-11 11,-29 0,-40 -11,-11 -29,-11 -40,0l-49 49c-75,-25 -158,6 -199,74 -7,12 -7,27 0,39 11,18 24,33 40,46l-37 37c-7,7 -10,18 -7,27 3,10 10,17 20,20 10,3 20,0 27,-7l49 -49c75,25 158,-6 199,-74 7,-12 7,-27 0,-39zm-99 13l16 -16c9,24 3,51 -16,69 -18,18 -45,24 -69,16l16 -16c15,2 30,-3 40,-13 10,-11 15,-25 13,-40zm-109 29c-9,-24 -3,-51 16,-69 18,-18 45,-24 69,-16l-16 16c-15,-2 -30,3 -40,13 -10,10 -15,25 -13,40l-16 16z");
    SVG_A.push(SVG_1);
    return SVG_A
}


//Иконка Соединение. Рекомендуемый размер ШхВ = 18х18. 
function SVG_Connection() {
    let SVG_A = [];
    SVG_A.push(56); //ширина. Габарит при сохранении SVG.
    SVG_A.push(56); //высота. Габарит при сохранении SVG.
    let Color = "rgb(100,255,100)";
    let SVG_1 = document.createElementNS(NS_svg, "path");
    SVG_1.style.fill = Color;
    SVG_1.setAttribute("d", "M49 15c-13,-9 -29,-9 -42,0 -1,1 -1,2 -1,3 0,1 1,2 2,2 1,0 2,0 3,0 11,-7 25,-7 36,0 1,1 3,1 4,-1 1,-1 1,-3 -1,-4z");
    SVG_A.push(SVG_1);
    let SVG_2 = document.createElementNS(NS_svg, "path");
    SVG_2.style.fill = Color;
    SVG_2.setAttribute("d", "M43 24c-9,-6 -21,-6 -30,0 -1,1 -1,2 -1,3 0,1 1,2 2,2 1,0 2,0 3,0 7,-5 16,-5 23,0 1,1 3,1 4,-1 1,-1 1,-3 -1,-4z");
    SVG_A.push(SVG_2);
    let SVG_3 = document.createElementNS(NS_svg, "path");
    SVG_3.style.fill = Color;
    SVG_3.setAttribute("d", "M22 38c-1,1 -2,1 -3,0 -1,0 -1,-1 -2,-2 0,-1 0,-2 1,-3 5,-4 12,-4 17,0 1,1 2,3 1,4 -1,1 -3,2 -4,1 -3,-2 -8,-2 -11,0z");
    SVG_A.push(SVG_3);
    let SVG_4 = document.createElementNS(NS_svg, "path");
    SVG_4.style.fill = Color;
    SVG_4.setAttribute("d", "M32 46c0,-2 -2,-4 -4,-4 -2,0 -4,2 -4,4 0,2 2,4 4,4 2,0 4,-2 4,-4z");
    SVG_A.push(SVG_4);
    return SVG_A
}


//Иконка IP.  Рекомендуемый размер ШхВ = 18х18. 
function SVG_IP(Color) {
    let SVG_A = [];
    SVG_A.push(70.65); //ширина. Габарит при сохранении SVG.
    SVG_A.push(70.65); //высота. Габарит при сохранении SVG.
    let SVG_1 = document.createElementNS(NS_svg, "path");
    SVG_1.style.fill = Color;
    SVG_1.style.fillRule = "evenodd";//Не закрашивает внутреннюю область
    SVG_1.setAttribute("d", "M24.73 7.07l0 56.52 10.6 0 0 -17.66 28.26 0 0 -38.86 -38.86 0zm10.6 10.59l0 17.67 17.66 0 0 -17.67 -17.66 0z");
    SVG_A.push(SVG_1);
    let SVG_2 = document.createElementNS(NS_svg, "polygon");
    SVG_2.style.fill = Color;
    SVG_2.setAttribute("points", "10.6,63.59 21.2,63.59 21.2,7.07 10.6,7.07");
    SVG_A.push(SVG_2);

    return SVG_A;
}





//Иконка Разъединение. Рекомендуемый размер ШхВ = 18х18. 
function SVG_DisConnection() {
    let SVG_A = [];
    SVG_A.push(61); //ширина. Габарит при сохранении SVG.
    SVG_A.push(61); //высота. Габарит при сохранении SVG.
    let Color = "rgb(255,100,100)";
    let SVG_1 = document.createElementNS(NS_svg, "path");
    SVG_1.style.fill = Color;
    SVG_1.setAttribute("d", "M32 40c0,0 1,0 1,0 0,0 1,-1 1,-1l3 -22c0,-2 -1,-5 -3,-6 -2,-1 -5,-1 -7,0 -2,1 -3,4 -3,6l3 22c0,0 0,1 1,1 0,0 1,0 1,0 1,0 2,0 3,0z");
    SVG_A.push(SVG_1);
    let SVG_2 = document.createElementNS(NS_svg, "path");
    SVG_2.style.fill = Color;
    SVG_2.setAttribute("d", "M22 16c-4,1 -8,3 -11,5 -1,1 -2,1 -3,0 -1,0 -2,-1 -2,-3 0,-1 0,-2 1,-3 4,-3 9,-5 14,-6 1,0 1,0 2,1 0,0 0,1 0,2 0,1 -1,2 -1,3 0,1 0,1 -1,1z");
    SVG_A.push(SVG_2);
    let SVG_3 = document.createElementNS(NS_svg, "path");
    SVG_3.style.fill = Color;
    SVG_3.setAttribute("d", "M24 27l0 -3c0,0 0,-1 -1,-1 0,0 -1,0 -1,0 -3,1 -5,2 -8,4 -1,1 -1,2 -1,3 0,1 1,2 2,3 1,0 2,0 3,0 2,-1 4,-2 6,-3 1,0 1,-1 1,-2z");
    SVG_A.push(SVG_3);
    let SVG_4 = document.createElementNS(NS_svg, "path");
    SVG_4.style.fill = Color;
    SVG_4.setAttribute("d", "M25 41c0,0 0,0 -1,0 -1,1 -2,1 -3,0 -1,0 -2,-1 -2,-3 0,-1 0,-2 1,-3 1,0 1,-1 2,-1 0,0 1,0 1,0 0,0 1,1 1,1l0 3c0,1 0,1 -1,2z");
    SVG_A.push(SVG_4);
    let SVG_5 = document.createElementNS(NS_svg, "path");
    SVG_5.style.fill = Color;
    SVG_5.setAttribute("d", "M38 35c1,0 1,1 2,1 1,1 2,3 1,4 -1,1 -3,2 -4,1 0,0 0,0 -1,0 -1,0 -1,-1 -1,-2l0 -3c0,0 0,-1 1,-1 0,0 1,0 1,0z");
    SVG_A.push(SVG_5);
    let SVG_6 = document.createElementNS(NS_svg, "path");
    SVG_6.style.fill = Color;
    SVG_6.setAttribute("d", "M39 23c0,0 -1,0 -1,0 0,0 -1,1 -1,1l0 3c0,1 0,1 1,2 2,1 4,2 6,3 1,1 3,1 4,-1 1,-1 1,-3 -1,-4 -2,-2 -5,-3 -8,-4z");
    SVG_A.push(SVG_6);
    let SVG_7 = document.createElementNS(NS_svg, "path");
    SVG_7.style.fill = Color;
    SVG_7.setAttribute("d", "M39 16c4,1 8,3 11,5 1,1 3,1 4,-1 1,-1 1,-3 -1,-4 -4,-3 -9,-5 -14,-6 -1,0 -1,0 -1,1 0,0 0,1 0,2 0,1 1,2 1,3 0,1 0,1 1,1z");
    SVG_A.push(SVG_7);
    let SVG_8 = document.createElementNS(NS_svg, "path");
    SVG_8.style.fill = Color;
    SVG_8.setAttribute("d", "M35 50c0,-3 -2,-5 -5,-5 -3,0 -5,2 -5,5 0,3 2,5 5,5 3,0 5,-2 5,-5z");
    SVG_A.push(SVG_8);

    return SVG_A
}

//Иконка Работа. Рекомендуемый размер ШхВ = 18х18. 
function SVG_Working() {
    let SVG_A = [];
    SVG_A.push(116); //ширина. Габарит при сохранении SVG.
    SVG_A.push(116); //высота. Габарит при сохранении SVG.
    let Color = G.D.C.Icon;
    let SVG_1 = document.createElementNS(NS_svg, "path");
    SVG_1.style.fill = Color;
    SVG_1.setAttribute("d", "M54 102c0,0 0,1 0,1 0,0 1,1 1,1l27 0c0,0 1,0 1,-1 0,0 0,-1 0,-1l-3 -4c0,-1 0,-1 0,-2 14,-9 23,-25 22,-42 -1,-17 -12,-32 -27,-38 -1,-1 -3,0 -4,1l-4 8c-1,1 -1,2 0,2 0,1 1,1 2,2 11,4 18,14 19,26 1,12 -4,23 -14,29 0,0 -1,0 -1,0 0,0 -1,0 -1,-1l-3 -4c0,0 -1,-1 -1,-1 0,0 -1,0 -1,1l-14 23z");
    SVG_A.push(SVG_1);
    let SVG_2 = document.createElementNS(NS_svg, "path");
    SVG_2.style.fill = Color;
    SVG_2.setAttribute("d", "M48 90c1,-1 1,-2 0,-2 0,-1 -1,-1 -2,-2 -11,-4 -18,-14 -19,-26 -1,-11 4,-23 14,-29 0,0 1,0 1,0 0,0 1,0 1,1l3 4c0,0 1,1 1,1 1,0 1,0 1,-1l14 -23c0,0 0,-1 0,-1 0,0 -1,-1 -1,-1l-27 0c0,0 -1,0 -1,1 0,0 0,1 0,1l3 5c0,1 0,1 0,2 -14,9 -23,25 -21,42 1,17 12,32 27,38 1,1 3,0 4,-1l4 -8z");
    SVG_A.push(SVG_2);
    return SVG_A
}


//Иконка папки.  Рекомендуемый размер ШхВ = 18х18. 
function SVG_Directory() {
    let SVG_A = [];
    SVG_A.push(89.37); //ширина. Габарит при сохранении SVG.
    SVG_A.push(89.37); //высота. Габарит при сохранении SVG.
    let Color = G.D.C.Icon;
    let SVG_1 = document.createElementNS(NS_svg, "path");
    SVG_1.style.fill = Color;
    SVG_1.style.fillRule = "evenodd";//Не закрашивает внутреннюю область
    SVG_1.setAttribute("d", "M15.64 8.94c-1.78,0 -3.48,0.7 -4.74,1.96 -1.26,1.26 -1.96,2.96 -1.96,4.74l0 55.86c0,2.37 0.94,4.64 2.61,6.32 1.68,1.67 3.96,2.61 6.32,2.61l53.63 0c4.93,0 8.93,-4 8.93,-8.93l0 -40.22c0,-2.37 -0.94,-4.64 -2.61,-6.32 -1.68,-1.67 -3.95,-2.62 -6.32,-2.62l-27.41 0c-2.4,0 -4.61,-1.28 -5.81,-3.35l-3.87 -6.7c-1.2,-2.07 -3.41,-3.35 -5.8,-3.35l-12.97 0zm-2.23 6.7l0 17.87c0,0.6 0.23,1.17 0.65,1.58 0.42,0.42 0.99,0.66 1.58,0.66l58.09 0c1.23,0 2.24,-1 2.24,-2.24l0 -2.23c0,-1.18 -0.47,-2.32 -1.31,-3.16 -0.84,-0.84 -1.98,-1.31 -3.16,-1.31l-27.41 0c-4,0 -7.68,-2.13 -9.68,-5.58l-3.87 -6.7c-0.4,-0.7 -1.14,-1.12 -1.93,-1.12l-12.97 0c-0.59,0 -1.16,0.23 -1.58,0.65 -0.42,0.42 -0.65,0.99 -0.65,1.58z");
    SVG_A.push(SVG_1);
    return SVG_A
}

//Иконка галочка (CheckBox).  Рекомендуемый размер ШхВ = 18х18. 
function SVG_CheckBox() {
    let SVG_A = [];
    SVG_A.push(79.3); //ширина. Габарит при сохранении SVG.
    SVG_A.push(79.3); //высота. Габарит при сохранении SVG.
    let SVG_1 = document.createElementNS(NS_svg, "path");
    SVG_1.style.fill = G.D.C.Icon;
    SVG_1.setAttribute("d", "M18.96 36.56l11.15 18.31c0.36,0.59 1,0.95 1.69,0.95 0.7,0 1.34,-0.36 1.7,-0.95l26.85 -44.08c1.7,-2.81 5.36,-3.7 8.17,-1.99 2.8,1.71 3.69,5.37 1.98,8.17l-30.23 49.65c-1.8,2.95 -5.01,4.75 -8.47,4.75 -3.46,0 -6.66,-1.8 -8.46,-4.75l-14.54 -23.87c-1.1,-1.82 -1.16,-4.09 -0.14,-5.95 1.02,-1.86 2.95,-3.04 5.08,-3.1 2.13,-0.04 4.11,1.05 5.22,2.86z");
    SVG_A.push(SVG_1);
    return SVG_A
}