//Последовательность запросов данных для отображения.
//DrawNNPage():запрос данных: Список нейронных сетей. -> Отрисовка NNListWin();
//По умолчанию, 1 в списке выбранная НС G.Page.NN.SelectNameNN;
//NNListWin(): запрос данных: Настройки выборной нейронной сети. -> Отрисовка NNSetWin() и DrawChart()


//Прорисовка дизайна приложения
function DrawNNPage() {

    //Получение размера окна приложения
    let View = GetViewSize();

    //------------------------------------------------------------------------------------------------------------------
    //Размеры пустых контейнеров
    //Меню
    let menu = {};
    menu.t = G.D.S.GapPage;
    menu.l = G.D.S.GapPage;
    menu.h = 40;
    menu.w = View.w - 2 * G.D.S.GapPage;

    //Окно графика
    let chart = {};
    chart.t = menu.t + menu.h + G.D.S.GapWin;
    chart.l = G.D.S.GapPage;
    chart.h = 0.6 * (View.h - chart.t);
    chart.w = View.w - 2 * G.D.S.GapPage;

    //Окно списка нейронные сети
    let nnList = {};
    nnList.t = chart.t + chart.h + G.D.S.GapWin;
    nnList.l = G.D.S.GapPage;
    nnList.h = View.h - nnList.t - G.D.S.GapPage;//оставшаяся высота
    nnList.w = G.D.S.SideWinW;//по окну создать

    //Окно настройки НС
    let nnSet = {}
    nnSet.t = nnList.t;
    nnSet.h = nnList.h;
    nnSet.w = View.w - nnList.w - G.D.S.GapWin - 2 * G.D.S.GapPage;
    nnSet.l = View.w - nnSet.w - G.D.S.GapPage;

    //console.log("menu.t=" + menu.t);
    //console.log("info.t=" + info.t);
    //console.log("chart.t=" + chart.t);


    //------------------------------------------------------------------------------------------------------------------
    //Создаем контейнер "Background". Все последующие элементы будут помещены в этот контейнер
    let DivBackground = Background(View.w, View.h);

    //Размещение контейнеров
    let DivMenu = WindowContainer([menu.t, "", menu.l, ""], [menu.w, menu.h], DivBackground)
    G.C.DivContainer = Container([chart.t, "", chart.l, ""], [chart.w, chart.h], DivBackground);

    let DivNNList = WindowContainer([nnList.t, "", nnList.l, ""], [nnList.w, nnList.h], DivBackground);
    let DivNNSet = WindowContainer([nnSet.t, "", nnSet.l, ""], [nnSet.w, nnSet.h], DivBackground);

    G.NN.DivNNList = DivNNList;//через глобальную переменную, чтобы вызывать функцию без аргументов
    G.NN.DivNNSet = DivNNSet;


    //Наполнение контейнеров
    MainMenu(DivMenu);
    ChartWin("Standard");

    //Список нейронных сетей. Проверка наличия данные для отображения?
    if (!("List" in G.NN)) {
        let Message = {
            "Type": "NNList",
        };
        MessageSend(Message);
        //После прихода ответа, будет вызвана ф-ция,  NNListWin();
    } else {
        //Список есть отрисовываем.
        NNListWin();
    }

}


//Функция создает и размещает окно списка НС. Также запустит 
function NNListWin() {

    //console.log("NNListWin ");

    inDiv = G.NN.DivNNList;
    //0.Очишаем
    inDiv.innerHTML = "";

    //Очистка списка каталогов
    if (G.S.FoldersNN != undefined) {//Для НС назначен каталог(Не по умолчанию)
        let FoldersNN = {};
        for (i = 0; i < G.NN.List.length; i++) {
            for (let NameNN in G.S.FoldersNN) {
                if (G.NN.List[i] == NameNN) {
                    FoldersNN[NameNN] = G.S.FoldersNN[NameNN];
                    break;
                }
            }
        }
        G.S.FoldersNN = FoldersNN;
    }





    //Размеры окна
    let SizeWin = GetDivSizeContent(inDiv);
    //------------------------------------------------------------------------------------------------------------------

    //Разметка для элементов
    let l0 = G.D.S.GapIn;//первый столбец
    let t1 = G.D.S.GapIn;

    //-------------------------

    //кнопки
    let hB = 30;//Высота кнопки
    let wB = Math.round(SizeWin.w - 4 * G.D.S.GapIn) / 3;//Ширина кнопки

    //Контейнер для списка со скролом
    let tcl = t1 + G.D.S.ContFontSizeNormal + G.D.S.GapIn;
    let hcl = SizeWin.h - tcl - hB - 3 * G.D.S.GapIn;
    let wcl = SizeWin.w - 2 * G.D.S.GapIn;
    let DivCont = Container([tcl, "", l0, ""], [wcl, hcl], inDiv);
    //добавляем скролл
    DivCont = ModDivScrollV(DivCont, "NNListWin");

    //Меню верхнее
    let FavoritesDivColor = G.D.C.TWinLight;
    let ArchiveDivColor = G.D.C.TWin;
    if (G.Page.NN.SelectedNNTab == "Archive") {
        FavoritesDivColor = G.D.C.TWin;
        ArchiveDivColor = G.D.C.TWinLight;
    }

    //"Нейронные сети"
    FavoritesDiv = TextSimpleClick([t1, "", l0, ""], ["", ""], FavoritesDivColor, G.D.S.FontSizeNormal, "normal", G.L[G.S.L].nn1, inDiv);
    let l = l0 + GetDivPS_Parent(FavoritesDiv).w + 2 * G.D.S.GapIn;
    //"Архив"
    ArchiveDiv = TextSimpleClick([t1, "", l, ""], ["", ""], ArchiveDivColor, G.D.S.FontSizeNormal, "normal", G.L[G.S.L].nn2, inDiv);

    FavoritesDiv.onclick = function () {
        G.Page.NN.SelectedNNTab = "Favorites";//Имя вкладки окна списка НС, открываемая при входе: Favorites,Archive.
        NNListWin();

    }
    ArchiveDiv.onclick = function () {
        G.Page.NN.SelectedNNTab = "Archive";//Имя вкладки окна списка НС, открываемая при входе: Favorites,Archive.
        NNListWin();
    }

    //Есть ли в текущем катологе NameNN
    let NNisFolder = function (NameNN) {
        if (G.S.FoldersNN != undefined && G.S.FoldersNN[NameNN] != undefined) {//Для НС назначен каталог(Не по умолчанию)
            if (G.Page.NN.SelectedNNTab != G.S.FoldersNN[NameNN]) {//В текущем каталоге НС NameNN, нет
                return false;
            }
        } else if (G.Page.NN.SelectedNNTab != "Favorites") {//Для НС не назначен каталог(по умолчанию) и это не "Favorites" список
            return false;
        }
        return true;
    }


    //Выбираем НС по умолчанию
    if (!G.Page.NN.SelectNameNN || !NNisFolder(G.Page.NN.SelectNameNN)) {
        for (i = 0; i < G.NN.List.length; i++) {
            if (NNisFolder(G.NN.List[i])) {
                G.Page.NN.SelectNameNN = G.NN.List[i];
                break;
            }
        }
        if (!NNisFolder(G.Page.NN.SelectNameNN)) {
            G.Page.NN.SelectNameNN = "";
            NNSetWin();
        }
    }
    //console.log("G.Page.NN.SelectNameNN = " + G.Page.NN.SelectNameNN);




    //Три кнопки "Удалить" "Дублировать" "Создать"
    if (G.Page.NN.SelectNameNN) {//есть выбранная НС
        //Кнопка "Удалить"
        let lb = G.D.S.GapIn;
        //"Удалить"
        Div = ButtonText(["", t1, lb, ""], [wB, hB], G.L[G.S.L].Delete, inDiv);
        Div.onclick = function () {
            let Message = {
                "Type": "NNDelete",
                "Name": G.Page.NN.SelectNameNN,
            };
            delete G.NN.N[G.Page.NN.SelectNameNN];

            /*
            //Контроль
            for (let Name in G.NN.N) {
                if (G.Page.NN.SelectNameNN == Name) {
                    console.log("ОШИБКА!!! Не удалось удалить G.Page.NN.SelectNameNN = " + G.Page.NN.SelectNameNN);;
                }
            }
            */
            //Выделяем следующую НС
            if (G.NN.List.length > 1) {// Список всех НС в БД содержит мин 2 НС
                for (let i = 0; i < G.NN.List.length - 1; i++) {
                    if (G.Page.NN.SelectNameNN == G.NN.List[i]) {
                        G.Page.NN.SelectNameNN = G.NN.List[i + 1];//выделим следующую НС
                        break;
                    }
                    if (i == G.NN.List.length - 2) {
                        G.Page.NN.SelectNameNN = G.NN.List[i];
                    }
                }
            } else {//нечего выделять
                //delete G.NN.N["SelectName"];
                NNSetWin();
            }
            MessageSend(Message);
            // MessageSend({ "Type": "NNList" });//Чтение списка НС из БД


        }

        //Кнопка "Дублировать"   
        lb = 2 * G.D.S.GapIn + wB;
        //"Дублировать"
        Div = ButtonText(["", t1, lb, ""], [wB, hB], G.L[G.S.L].Copy, inDiv);
        Div.onclick = function () {
            /*
            //Создаем уникальное имя дубликата
            let NameClone = G.Page.NN.SelectNameNN + "c";
            let unique = false;
            let n = 0;
            while (!unique) {
                unique = true;
                for (let i = 1; i < G.NN.List.length; i++) {
                    if (NameClone == G.NN.List[i]) {
                        unique = false;
                        NameClone = G.Page.NN.SelectNameNN + "c" + n;
                    }
                }
                n++;
            }
            G.S.FoldersNN[NameClone] = G.Page.NN.SelectedNNTab;//Назначим текущий каталог
            */
            let Message = {
                "Type": "NNClone",
                "Name": G.Page.NN.SelectNameNN,
                //"NameClone": NameClone,
            };
            //G.Page.NN.SelectNameNN = NameClone;
            MessageSend(Message);
            //MessageSend({ "Type": "NNList" });//Чтение списка НС из БД
        }
    }
    //Кнопка "Создать"
    lb = 3 * G.D.S.GapIn + 2 * wB;
    //"Создать"
    DivButtonCreateNN = ButtonText(["", t1, lb, ""], [wB, hB], G.L[G.S.L].Create, inDiv);
    DivButtonCreateNN.onclick = function () {
        let d = UnixToDate(Date.now());
        let NewName = d.date + " " + d.time;
        G.S.FoldersNN[NewName] = G.Page.NN.SelectedNNTab;//Назначим текущий каталог
        let Message = {
            "Type": "NNSetCreateDefault",
            "NewName": NewName,
        };
        MessageSend(Message);

        //MessageSend({ "Type": "NNList" });//Чтение списка НС из БД
    }

    //console.log("G.S.FoldersNN = " + G.S.FoldersNN);

    //Список НС.
    let ti = 0;
    let h2 = G.D.S.ContFontSizeNormal;//15
    let aDivList = [];
    //let counter=0;
    for (let i = 0; i < G.NN.List.length; i++) {//Каждая итерация добавит одну строку списка НС
        let NameNN = G.NN.List[i];

        if (!NNisFolder(NameNN)) {
            continue;
        }
        //ti += h2 + G.D.S.GapIn;
        //counter++;

        let color = G.D.C.TWin;
        let l = l0;
        if (G.NN.ListTraining.includes(NameNN)) {//Эта НС есть в списке G.NN.ListTraining
            ImageSVG([ti, "", l, ""], [h2, h2], SVG_Working(), DivCont);//Иконка если НС обучается
            l += h2;
        }
        let DivList = TextSimpleClick([ti, "", l, ""], ["", ""], color, G.D.S.FontSizeNormal, "normal", NameNN, DivCont);
        aDivList.push(DivList);
        //Клик на названии НС.
        DivList.onclick = function () {
            G.Page.NN.SelectNameNN = NameNN;
            //для перерисовки цветов 
            for (let j = 0; j < aDivList.length; j++) {
                //if (G.NN.List[j] == NameNN) {
                if (aDivList[j].innerHTML == NameNN) {
                    aDivList[j].style.color = G.D.C.TWinLight;
                } else {
                    aDivList[j].style.color = G.D.C.TWin;
                }
            }

            //Есть данные для отображения?
            if (!(NameNN in G.NN.N)) {//Данных нет
                let Message = {
                    "Type": "NNLoad",
                    "Name": NameNN,
                };
                MessageSend(Message);
                //После прихода ответа, будет вызвана функция,  NNSetWin();
            } else {//Данных имеются
                NNSetWin();
            }
        };


        ti += h2 + G.D.S.GapIn;


        if (G.Page.NN.SelectNameNN == NameNN) {//эмуляция клика на кнопке, во время первой прорисовки
            DivList.onclick();
        }
    }

    DivCont.UpdateScroll();
}

//Иконка сохранения НС
let NNProcessSave;

//Функция создает и размещает окно "Настройки".
function NNSetWin() {
    //console.log("NNSetWin ");

    let inDiv = G.NN.DivNNSet;
    //0. Очишаем
    inDiv.innerHTML = "";


    //Размеры окна
    let SizeWin = GetDivSizeContent(inDiv);
    //------------------------------------------------------------------------------------------------------------------
    //Список нейронных сетей. Проверка наличия данные для отображения?
    if (!(G.Page.NN.SelectNameNN in G.NN.N)) {
        return;
    }

    //Контейнер под шапкой //со скролом
    let ht = 50;
    let DivCont = Container([ht, "", 0, ""], ["100%", SizeWin.h - ht], inDiv);

    //Меню НС
    let NNMenuItem = [
        { N: G.L[G.S.L].nn3, F: NNSetWin_General, P: "General", },//"Общее"
        { N: G.L[G.S.L].nn4, F: NNSetWin_Architecture, P: "Architecture", },//"Архитектура"
        { N: G.L[G.S.L].nn5, F: NNSetWin_DataSet, P: "DataSet", },//"Набор Д."
        { N: G.L[G.S.L].nn6, F: NNSetWin_InputOutput, P: "InputOutput", },//"Параметры Д."
        { N: G.L[G.S.L].nn7, F: NNSetWin_Convergence, P: "Convergence", },//"Сходимость"
        { N: G.L[G.S.L].nn8, F: NNSetWin_Trigger, P: "Trigger", },//"Триггер"
        { N: G.L[G.S.L].nn9, F: NNSetWin_Training, P: "Training", },//"Обучение"
        { N: G.L[G.S.L].nn10, F: NNSetWin_Test, P: "Test", },//"Тест"

    ];

    //Некоторые общие размеры
    let NNSetDesing = {};
    NNSetDesing.LW = 420;//Ширина левый столбец
    NNSetDesing.RW = 500;//Максимальная Ширина правый столбец
    NNSetDesing.LWTextFrameInput = 160;//Ширина полей заполнения левый столбец



    //Шапка - меню.
    let l = G.D.S.GapIn;
    for (let i = 0; i < NNMenuItem.length; i++) {
        NNMenuItem[i].Div = TextSimpleClick([G.D.S.GapIn, "", l, ""], ["", ""], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", NNMenuItem[i].N, inDiv);
        NNMenuItem[i].Div.onclick = function () {
            for (let i = 0; i < NNMenuItem.length; i++) {
                NNMenuItem[i].Div.style.color = G.D.C.TWin;
            }
            NNMenuItem[i].Div.style.color = G.D.C.TWinLight;
            DivCont.innerHTML = "";
            G.Page.NN.SelectedTab = NNMenuItem[i].P;
            NNMenuItem[i].F(DivCont, NNSetDesing);
        }
        l += GetDivPS_Parent(NNMenuItem[i].Div).w + 2 * G.D.S.GapIn;
    }
    //Авто выделение при первой отрисовки экрана.
    for (let i = 0; i < NNMenuItem.length; i++) {
        if (G.Page.NN.SelectedTab == NNMenuItem[i].P) {
            NNMenuItem[i].Div.onclick();
        }
    }
    //Иконка сохранения НС
    let sSVG = G.D.S.ContFontSizeNormal;
    NNProcessSave = ImageSVG([G.D.S.GapIn, "", l, ""], [sSVG, sSVG], SVG_Working(), inDiv);//Иконка если НС обучается
    NNProcessSave.style.visibility = "hidden";//Скрываем иконку сохранения НС               




}

//Функция сохранить настройки НС. После сохранения прейдёт обновлённая НС.
function SaveNNSet(NNSet, OldNameNN) {
    if (!NNSet.Name) {//нет имени
        return;
    }
    let Message = {
        "Type": "NNSave",
        "OldName": OldNameNN,
        "NNSet": NNSet,
    };

    NNProcessSave.style.visibility = "visible";//Отображаем иконку сохранения НС           

    MessageSend(Message);
    //G.NN.N[Name].Set = NNSet;
    if (OldNameNN != NNSet.Name) {
        G.Page.NN.SelectNameNN = NNSet.Name;
        MessageSend({ "Type": "NNList" });//Чтение списка НС из БД
    }
}

//Кратковременная вспышка прогресса
function NNProcessSaveTemp() {

    NNProcessSave.style.visibility = "visible";//Отображаем иконку сохранения НС           
    setTimeout(function () { NNProcessSave.style.visibility = "hidden"; }, 500);
}


//Общее
function NNSetWin_General(DivCont, SD) {
    //console.log("NNSetWin_General ");

    let NameNN = G.Page.NN.SelectNameNN;
    let NNSet = G.NN.N[NameNN].Set;
    //Размеры окна
    let SizeWin = GetDivSizeContent(DivCont);

    //Размеры
    let ContLW = SD.LW;
    let ContRL = ContLW + G.D.S.GapIn;
    let ContRW = SizeWin.w - ContRL;
    if (ContRW > SD.RW) {
        ContRW = SD.RW;
    }
    let t = 0;
    let l0 = G.D.S.GapIn;
    let l1 = l0 + G.D.S.Tab;
    let h = G.D.S.ContFontSizeNormal;
    let w1 = SD.LWTextFrameInput;

    let DivContL = Container([0, "", 0, ""], [ContLW, "100%"], DivCont);//Контейнер со скролом Левый
    DivContL = ModDivScrollV(DivContL, "NNSetWin_GeneralL");//добовляем скрол

    let DivContR = Container([0, "", ContRL, ""], [ContRW, "100%"], DivCont);//Контейнер со скролом Правый
    DivContR = ModDivScrollV(DivContR, "NNSetWin_GeneralR");//добавляем скролл

    //Контент левый столбец.
    //"Название"
    TextSimple([t, "", l0, ""], ["", ""], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", G.L[G.S.L].nng010, DivContL);
    let Div_Name = TextFrameInput([t, "", "", l0], [w1, h], 30, NNSet.Name, DivContL);
    Div_Name.onchange = function () {    //событие окончание изменение содержания поля ввода текста (потеря фокуса)        
        let NewNameNN = Div_Name.value;
        //Проверим есть ли уже НС с таким именем
        for (; ;) {
            let End = true;
            for (let Name of G.NN.List) {
                if (Name == NewNameNN) {
                    //Уже есть такая НС
                    NewNameNN = NewNameNN + "_d";
                    End = false;
                }
            }
            if (End) {
                break;
            }
        }
        NNSet.Name = NewNameNN;


        //delete G.S.FoldersNN[NameNN];
        //Для нового имени сохраним положение в папке
        G.S.FoldersNN[NNSet.Name] = G.Page.NN.SelectedNNTab;

        GUISettingsSave();
        SaveNNSet(NNSet, NameNN);
        //Удалим из объекта старую НС, чтобы она не подхватывалась 
        delete G.NN.N[NameNN];

        //Добавить коректировку списока участия в торговле
    };
    t += h;

    //Участие в торговле. (изменяет настройку робота)
    let CheckBoxOn = false;
    if (NameNN in G.Bot.NNWeight) {
        CheckBoxOn = true;
    }
    //"Участие в автоторговле"
    TextSimple([t, "", l0, ""], ["", ""], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", G.L[G.S.L].nng020, DivContL);
    if (G.BotStatusWork) {//Статус робота -  работает
        CheckBoxInactive([t, "", "", l0], [h, h], CheckBoxOn, DivContL);
    } else {//Статус робота - не работает
        //CheckBox
        let fnCheckBoxOn = function (On) {
            if (On) {
                G.Bot.NNWeight[NameNN] = 1;//добавляем вес
            } else {
                delete G.Bot.NNWeight[NameNN];//удаляем вес
            }
            Message = {
                "Type": "BotSave",
                "Bot": G.Bot,
            };
            MessageSend(Message);
            NNSetWin();
        };
        CheckBox([t, "", "", l0], [h, h], CheckBoxOn, fnCheckBoxOn, DivContL);
    }
    t += h;

    //Переместить в каталог архив.
    //"Архивировать"
    let ContentBArchive = G.L[G.S.L].nng030;
    if (G.Page.NN.SelectedNNTab == "Archive") {//Есть ли в текущем каталоге НС NameNN
        //"Отменить"
        ContentBArchive = G.L[G.S.L].Cancel;
    }
    //"Переместить в архив"
    TextSimple([t, "", l0, ""], ["", ""], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", G.L[G.S.L].nng031, DivContL);
    let Div_Archive = ButtonText([t, "", "", l0], [w1, h], ContentBArchive, DivContL);
    Div_Archive.onclick = function () {
        if (G.Page.NN.SelectedNNTab == "Archive") {
            G.S.FoldersNN[NameNN] = "Favorites";
        } else {
            G.S.FoldersNN[NameNN] = "Archive";
        }
        GUISettingsSave();
        //NNSetWin();
        NNListWin()
    }
    t += 2 * h;

    //"Время обучения"
    TextSimple([t, "", l1, ""], ["", ""], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", G.L[G.S.L].nng041, DivContL);
    TextSimple([t, "", "", l0], ["", ""], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", DurationMsToDate(NNSet.TimeTrain), DivContL);
    t += h;
    // "Время генерации данных"
    TextSimple([t, "", l1, ""], ["", ""], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", G.L[G.S.L].nng042, DivContL);
    TextSimple([t, "", "", l0], ["", ""], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", DurationMsToDate(NNSet.TimeInputOutput), DivContL);
    t += 2 * h;
    TextSimple([t, "", l0, ""], ["", ""], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", G.L[G.S.L].nng050, DivContL);
    t += h;
    let Hta = GetDivSizeContent(DivContL).h - t - G.D.S.GapIn;
    let Wta = GetDivSizeContent(DivContL).w - 2 * G.D.S.GapIn;

    let DivDescription = TextFrameArea([t, "", l0, ""], [Wta, Hta], 1000, NNSet.Description, DivContL);

    DivDescription.onchange = function () {    //событие окончание изменение содержания поля ввода текста (потеря фокуса)
        NNSet.Description = DivDescription.value;
        SaveNNSet(NNSet, NameNN);
    }

    t = 0;
    //"Справка"
    TextSimple([t, "", 0, ""], ["", ""], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", G.L[G.S.L].Help, DivContR);
    t += 2 * h;
    let Htext1 = G.L[G.S.L].hnng010;//Справка.Меню Торговля. Вкладка Общее. 

    let DivHelp1 = TextSimple([t, "", 0, ""], ["", ""], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", Htext1, DivContR);
    ModDivPadding(["", "", "", G.D.S.GapIn], DivHelp1);
    DivHelp1.style.whiteSpace = "normal"; //Устанавливаем перенос строки автоматический
    //Справка. Стоп.



    DivContL.UpdateScroll();
    DivContR.UpdateScroll();



    //let NameChart = "Price" + NNSet.Symbol;
    //G.C.S.Display = [NameChart];
    //Manager_G_C_S_Display();

    let SelectSymbol = NNSet.DataTrain[G.Page.NN.DataSetSelectList[NameNN]].Symbol;
    GetPrice(SelectSymbol, false);

}

//Архитектура
function NNSetWin_Architecture(DivCont, SD) {
    DivCont.innerHTML = "";

    let NameNN = G.Page.NN.SelectNameNN;
    let NNSet = G.NN.N[NameNN].Set;
    //Размеры окна
    let SizeWin = GetDivSizeContent(DivCont);

    //Размеры
    let ContLW = SD.LW;
    let ContRL = ContLW + G.D.S.GapIn;
    let ContRW = SizeWin.w - ContRL;
    if (ContRW > SD.RW) {
        ContRW = SD.RW;
    }
    let t = 0;
    let l0 = G.D.S.GapIn;
    let l1 = l0 + G.D.S.Tab;
    let h = G.D.S.ContFontSizeNormal;
    let w1 = SD.LWTextFrameInput;



    //Контейнер со скролом Левый
    let DivContL = Container([0, "", 0, ""], [ContLW, "100%"], DivCont);
    DivContL = ModDivScrollV(DivContL, "NNSetWin_ArchitectureL");//добавляем скролл
    //Контейнер со скроолом Правый
    let DivContR = Container([0, "", ContRL, ""], [ContRW, "100%"], DivCont);
    DivContR = ModDivScrollV(DivContR, "NNSetWin_ArchitectureR");//добавляем скролл


    //"Тип архитектуры"
    TextSimple([t, "", l0, ""], ["", h], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", G.L[G.S.L].nna010, DivContL);
    //let Div_Name = TextFrameInput([t, "", "", l0], [w1, h], 10, NNSet.NN.Architect, DivContL);
    let Div_Name = ListSelect([t, "", "", l0], [w1, h], NNSet.NN.Architect, [NNSet.NN.Architect], DivContL);
    Div_Name.fnSelectContent = function (SelectContent) {//Изменение 
    }

    t += 2 * h;

    let DivContainerArchitectSetup = Container([t, "", 0, ""], ["100%", ""], DivContL);//контейнер для перерисовки
    t += h;

    let NNSetNNArchitectSetup = NNSet.NN.ArchitectSetup;//Параметры архитектуры. Слайс параметров, для каждой архитектуры имеет свою интерпретацию

    //Перерисовывает текстовую информацию. Не перерисовывает график.
    let ReDrawArchitectSetup = function () {
        DivContainerArchitectSetup.innerHTML = "";
        let tR = 0;
        //"Параметры архитектуры:"
        TextSimple([tR, "", l0, ""], ["", ""], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", G.L[G.S.L].nna020, DivContainerArchitectSetup);
        tR += h;
        //Кнопка "Добавить" "Удалить"
        let hB2 = h;//Высота кнопки
        let wB2 = Math.round(w1 / 2);//Ширина кнопки
        for (let i = 0; i < NNSetNNArchitectSetup.length; i++) {
            //"слой №"
            let Content = G.L[G.S.L].nna030 + " №" + (i + 1);
            if (i == 0) {
                //" (вход)"
                Content += " (" + G.L[G.S.L].nna031 + ")";
            }
            if (i == NNSetNNArchitectSetup.length - 1) {
                //" (выход)"
                Content += " (" + G.L[G.S.L].nna032 + ")";
            }
            DemarcationLine([tR, "", G.D.S.GapIn, ""], GetDivSizeContent(DivContL).w - 2 * G.D.S.GapIn, "horizontal", DivContainerArchitectSetup);
            TextSimple([tR, "", l1, ""], ["", h], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", Content, DivContainerArchitectSetup);

            if (i < NNSetNNArchitectSetup.length - 1) {//Кроме последней
                let Div_ArchitectSetup = TextFrameInput([tR, "", "", l0], [w1, h], 4, NNSetNNArchitectSetup[i], DivContainerArchitectSetup);
                Div_ArchitectSetup.oninput = function () {   //событие изменение содержания поля ввода текста
                    NNSetNNArchitectSetup[i] = Number(Div_ArchitectSetup.value);
                };
                tR += h;
                //"Добавить"
                Div = ButtonText([tR, "", "", l0], [wB2, hB2], G.L[G.S.L].Add, DivContainerArchitectSetup);
                Div.onclick = function () {
                    // начиная с индекса i удалим 0 элементов и добавим 1
                    NNSetNNArchitectSetup.splice(i + 1, 0, 1);
                    ReDrawArchitectSetup();
                }
                if (NNSetNNArchitectSetup.length > 2) {
                    //"Удалить"
                    Div = ButtonText([tR, "", "", l0 + wB2], [wB2, hB2], G.L[G.S.L].Delete, DivContainerArchitectSetup);
                    Div.onclick = function () {
                        // начиная с индекса i удалим 1 элементов 
                        NNSetNNArchitectSetup.splice(i, 1);
                        ReDrawArchitectSetup();
                    }
                }

                tR += h;
                tR += G.D.S.GapIn;
            } else {//последняя

                TextSimpleA([tR, "", "", l0], [w1, h], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", "right", NNSetNNArchitectSetup[i], DivContainerArchitectSetup);

                tR += h;
                tR += h;

                //"Перестроить архитектуру"
                TextSimple([tR, "", l0, ""], ["", h], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", G.L[G.S.L].nna040, DivContainerArchitectSetup);
                //"Генерация"
                let DivGenerate = ButtonText([tR, "", "", l0], [w1, h], G.L[G.S.L].nna050, DivContainerArchitectSetup);
                DivGenerate.onclick = function () {
                    NNSet.NN.ArchitectSetup = NNSetNNArchitectSetup;
                    SaveNNSet(NNSet, NameNN);

                }
                tR += h;
                //"Внимание! Генерация удалит данные обучения."
                TextSimple([tR, "", l0, ""], ["", h], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", G.L[G.S.L].nna051, DivContainerArchitectSetup);
                tR += h;
                tR += h;


                //Прореживание 
                //"Значение слабой связи"
                TextSimple([tR, "", l0, ""], ["", ""], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", G.L[G.S.L].nna060, DivContainerArchitectSetup);
                let Div_PartDelete = TextFrameInput([tR, "", "", l0], [w1, h], 10, G.PartDelete, DivContainerArchitectSetup);
                Div_PartDelete.oninput = function () {//событие изменение содержания поля ввода текста
                    AutoVerificationNumber(this);//Проверка ввода данных
                };
                Div_PartDelete.onchange = function () {    //событие окончание изменение содержания поля ввода текста (потеря фокуса)
                    NNProcessSaveTemp();
                    G.PartDelete = Number(Div_PartDelete.value);
                    if (G.TypeArchitecturePlot == "Pruning") {
                        DrawArchitecturePlot(NameNN);
                    }
                }
                tR += h;

                let Div_PlotPruning;
                let Div_PlotFluctuation;
                //Отобразить на схеме. "Удаляемые аксоны"
                TextSimple([tR, "", l0, ""], ["", h], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", G.L[G.S.L].nna061, DivContainerArchitectSetup);


                let ContD = G.L[G.S.L].Display;//"Отобразить"
                if (G.TypeArchitecturePlot == "Pruning") {
                    ContD = G.L[G.S.L].Hide;//"Скрыть"
                }
                Div_PlotPruning = ButtonText([tR, "", "", l0], [w1, h], ContD, DivContainerArchitectSetup);
                Div_PlotPruning.onclick = function () {
                    let ContD;
                    if (G.TypeArchitecturePlot == "Pruning") {
                        G.TypeArchitecturePlot = "Default";
                        ContD = G.L[G.S.L].Display;//"Отобразить"
                    } else {
                        G.TypeArchitecturePlot = "Pruning";
                        ContD = G.L[G.S.L].Hide;//"Скрыть"
                    }
                    Div_PlotFluctuation.innerHTML = G.L[G.S.L].Display;//"Отобразить"

                    Div_PlotPruning.innerHTML = ContD;
                    DrawArchitecturePlot(NameNN);
                }
                tR += h;

                //"Удалить слабые связи"
                TextSimple([tR, "", l0, ""], ["", h], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", G.L[G.S.L].nna062, DivContainerArchitectSetup);
                // "Прореживание"
                let DivPruningNeuron = ButtonText([tR, "", "", l0], [w1, h], G.L[G.S.L].nna063, DivContainerArchitectSetup);
                DivPruningNeuron.onclick = function () {
                    NNProcessSave.style.visibility = "visible";//Отображаем иконку сохранения НС           
                    let Message = {
                        "Type": "NNPruning",
                        "Name": NameNN,
                        "PartDelete": G.PartDelete,
                    };
                    MessageSend(Message);
                }
                tR += 2 * h;

                //Добавление 
                //"Значение колебания веса"
                TextSimple([tR, "", l0, ""], ["", ""], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", G.L[G.S.L].nna070, DivContainerArchitectSetup);
                let Div_PartAdd = TextFrameInput([tR, "", "", l0], [w1, h], 10, G.PartAdd, DivContainerArchitectSetup);
                Div_PartAdd.oninput = function () {//событие изменение содержания поля ввода текста
                    AutoVerificationNumber(this);//Проверка ввода данных
                };
                Div_PartAdd.onchange = function () {    //событие окончание изменение содержания поля ввода текста (потеря фокуса)
                    NNProcessSaveTemp();
                    G.PartAdd = Number(Div_PartAdd.value);
                    if (G.TypeArchitecturePlot == "Extension") {
                        DrawArchitecturePlot(NameNN);
                    }
                }
                tR += h;

                //Отобразить на схеме
                //"Расширяемые нейроны"
                TextSimple([tR, "", l0, ""], ["", h], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", G.L[G.S.L].nna071, DivContainerArchitectSetup);

                let ContF = G.L[G.S.L].Display;//"Отобразить"
                if (G.TypeArchitecturePlot == "Extension") {
                    ContF = G.L[G.S.L].Hide;//"Скрыть"
                }
                Div_PlotFluctuation = ButtonText([tR, "", "", l0], [w1, h], ContF, DivContainerArchitectSetup);
                Div_PlotFluctuation.onclick = function () {
                    let ContF;
                    if (G.TypeArchitecturePlot == "Extension") {
                        G.TypeArchitecturePlot = "Default";
                        ContF = G.L[G.S.L].Display;//"Отобразить"
                    } else {
                        G.TypeArchitecturePlot = "Extension";
                        ContF = G.L[G.S.L].Hide;//"Скрыть"
                    }
                    Div_PlotPruning.innerHTML = G.L[G.S.L].Display;//"Отобразить"

                    Div_PlotFluctuation.innerHTML = ContF;
                    DrawArchitecturePlot(NameNN);
                }
                tR += h;



                //"Шум веса"
                TextSimple([tR, "", l0, ""], ["", ""], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", G.L[G.S.L].nna072, DivContainerArchitectSetup);
                let Div_PartAddNoise = TextFrameInput([tR, "", "", l0], [w1, h], 10, G.PartAddNoise, DivContainerArchitectSetup);
                Div_PartAddNoise.oninput = function () {//событие изменение содержания поля ввода текста
                    AutoVerificationNumber(this);//Проверка ввода данных
                };
                Div_PartAddNoise.onchange = function () {    //событие окончание изменение содержания поля ввода текста (потеря фокуса)
                    NNProcessSaveTemp();
                    G.PartAddNoise = Number(Div_PartAddNoise.value);
                }
                tR += h;

                //"Добавить нейроны"
                TextSimple([tR, "", l0, ""], ["", h], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", G.L[G.S.L].nna073, DivContainerArchitectSetup);
                // "Расширение"
                let DivExtensionNeuron = ButtonText([tR, "", "", l0], [w1, h], G.L[G.S.L].nna074, DivContainerArchitectSetup);
                DivExtensionNeuron.onclick = function () {
                    NNProcessSave.style.visibility = "visible";//Отображаем иконку сохранения НС           
                    let Message = {
                        "Type": "NNExtension",
                        "Name": NameNN,
                        "PartAdd": G.PartAdd,
                        "PartAddNoise": G.PartAddNoise,
                    };
                    MessageSend(Message);
                }
                tR += h;

                //Отслеживание колебания весов
                let CheckBoxOn = true;
                if (!NNSet.NN.Fluctuation) {
                    CheckBoxOn = false;
                }
                //CheckBox
                let fnCheckBoxOn = function (On) {
                    if (On) {
                        NNSet.NN.Fluctuation = true;
                    } else {
                        NNSet.NN.Fluctuation = false;
                    }
                    SaveNNSet(NNSet, NameNN);
                };
                //"Наблюдать колебания весов"
                TextSimple([tR, "", l0, ""], ["", h], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", G.L[G.S.L].nna075, DivContainerArchitectSetup);
                CheckBox([tR, "", "", l0], [h, h], CheckBoxOn, fnCheckBoxOn, DivContainerArchitectSetup);
                tR += 2 * h;

                //Статистические данные."Статистика"
                TextSimple([tR, "", l0, ""], ["", h], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", G.L[G.S.L].Statistics, DivContainerArchitectSetup);
                tR += h;

                //"Вычислительная мощность"
                TextSimple([tR, "", l0, ""], ["", h], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", G.L[G.S.L].nna080, DivContainerArchitectSetup);
                //Для полносвязаной НС Вычислительная мощность, это сумма произведений количества нейронов и аксонов в каждом слое.
                //Вычислительная мощность = (Nа * Nн)+ (Nа * Nн)+ ...
                //Для простоты вычислений это количество аксонов 
                //Но мы будем учитывать и нейроны, так как там изменяеться смещение
                //Вычислительная мощность = N аксонаов + N нейронов
                let NeuronN = NNSet.NN.Neuron.length;//Количество нейронов, без входного, но с выходным слоям.
                let AxonN = NNSet.NN.Axon.length;//Количество аксонов.
                let ComputingPower = NeuronN + AxonN;
                TextSimple([tR, "", "", l0], [w1, h], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", ComputingPower, DivContainerArchitectSetup);
                tR += 2 * h;

                //Таблица. Статистика весов и смещений, послойная
                //разметка таблицы, по столбцам
                let Cap = {};
                let lc = G.D.S.GapIn;

                Cap.Name = {};
                Cap.Name.l = lc;//координата с лева
                Cap.Name.n = G.L[G.S.L].nna090; //Шапка таблицы. "Элемент"
                lc += 100;

                Cap.Min = {};
                Cap.Min.l = lc;
                Cap.Min.n = G.L[G.S.L].Minimum;//Шапка таблицы. "Минимум"
                lc += 100;

                Cap.Max = {};
                Cap.Max.l = lc;
                Cap.Max.n = G.L[G.S.L].Maximum;//Шапка таблицы. "Максимум"
                lc += 100;

                Cap.Average = {};
                Cap.Average.l = lc;
                Cap.Average.n = G.L[G.S.L].Average;//Шапка таблицы. "Среднее"

                //Заголовок."Распределение весов и смещений, по слоям:"
                TextSimple([tR, "", l0, ""], ["", ""], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", G.L[G.S.L].nna091, DivContainerArchitectSetup);
                tR += h;
                for (let key in Cap) {//Шапка
                    TextSimple([tR, "", Cap[key].l, ""], ["", ""], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", Cap[key].n, DivContainerArchitectSetup);
                }
                tR += h;
                DemarcationLine([tR, "", G.D.S.GapIn, ""], GetDivSizeContent(DivContL).w - 2 * G.D.S.GapIn, "horizontal", DivContainerArchitectSetup);

                let NNSetNNLayerN = NNSet.NN.LayerN;//[]int Количество нейронов в i слое, начиная со входящего.
                let NNSetNNLayerID = NNSet.NN.LayerID //[]int Индекс первого нейрона в i слое, начиная со входящего.
                let LayerN = NNSetNNLayerN.length;//Количество слоев   
                for (let nLayers = 0; nLayers < LayerN; nLayers++) {//Перебор слоёв
                    let maxB = -Infinity;//Максимальное смещение нейрона в слое
                    let minB = Infinity;//Минимальное смещение нейрона в слое
                    let sumB = 0;//Сумма смещений нейронов в слое
                    let nB = 0;//Количество нейронов в слое
                    let maxW = -Infinity;//Максимальный вес аксона в слое
                    let minW = Infinity;//Минимальное вес аксона в слое
                    let sumW = 0;//Сумма весов аксона в слое
                    let nW = 0;//Количество аксонов в слое
                    for (let n = 0; n < NNSetNNLayerN[nLayers]; n++) {//Перебор нейронов в слое.
                        let IDNeuron = n + NNSetNNLayerID[nLayers];//Вычисляем оригинальный ID нейрона
                        let Neuron = NNSet.NN.Neuron[IDNeuron];
                        //console.log("Neuron= " + Neuron);
                        if (Neuron != undefined) {
                            maxB = (maxB < Neuron.Bias) ? Neuron.Bias : maxB;//вычисление максимального значения
                            minB = (minB > Neuron.Bias) ? Neuron.Bias : minB;//вычисление минимального значения
                            nB++;//Счетчик количества.
                            sumB += Neuron.Bias;//Счетчик суммы  
                            if (nLayers != LayerN - 1) {//В последнем слое аксонов нет
                                let IDAxonOut = Neuron.IDAxonOut;//Слайс ID аксонов выходящих из IDNeuron.
                                if (IDAxonOut != null) {
                                    for (let a = 0; a < IDAxonOut.length; a++) {//Перебор аксонов выходящих из нейрона IDNeuron в текущем слое.
                                        let IDAxon = IDAxonOut[a];//Вычисляем оригинальный ID аксона
                                        let Axon = NNSet.NN.Axon[IDAxon];
                                        maxW = (maxW < Axon.Weight) ? Axon.Weight : maxW;//вычисление максимального значения
                                        minW = (minW > Axon.Weight) ? Axon.Weight : minW;//вычисление минимального значения
                                        nW++;//Счетчик количества.
                                        sumW += Axon.Weight;//Счетчик суммы  
                                    }
                                }
                            }
                        }
                    }
                    //Слой окончен можно подводить итоги.
                    let avgB = sumB / nB;//Среднеарифметическое смещений нейронов в слое
                    let avgW = sumW / nW;//Среднеарифметическое весов аксона в слое

                    //отрисовка блока строк текущего слоя
                    //"слой №"
                    TextSimple([tR, "", Cap["Name"].l, ""], ["", ""], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", G.L[G.S.L].nna030 + " №" + (nLayers + 1), DivContainerArchitectSetup);//Номер слоя
                    tR += h;
                    let f = 3;// округление значений
                    //"нейрон"
                    TextSimple([tR, "", Cap["Name"].l + G.D.S.Tab, ""], ["", ""], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", G.L[G.S.L].nna092, DivContainerArchitectSetup);//Смещение нейрона
                    TextSimple([tR, "", Cap["Min"].l, ""], ["", ""], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", minB.toFixed(f), DivContainerArchitectSetup);
                    TextSimple([tR, "", Cap["Max"].l, ""], ["", ""], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", maxB.toFixed(f), DivContainerArchitectSetup);
                    TextSimple([tR, "", Cap["Average"].l, ""], ["", ""], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", avgB.toFixed(f), DivContainerArchitectSetup);
                    tR += h;
                    if (nLayers != LayerN - 1) {//В последнем слое аксонов нет
                        //"аксон"
                        TextSimple([tR, "", Cap["Name"].l + G.D.S.Tab, ""], ["", ""], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", G.L[G.S.L].nna093, DivContainerArchitectSetup);//Вес аксона
                        TextSimple([tR, "", Cap["Min"].l, ""], ["", ""], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", minW.toFixed(f), DivContainerArchitectSetup);
                        TextSimple([tR, "", Cap["Max"].l, ""], ["", ""], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", maxW.toFixed(f), DivContainerArchitectSetup);
                        TextSimple([tR, "", Cap["Average"].l, ""], ["", ""], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", avgW.toFixed(f), DivContainerArchitectSetup);
                        tR += h;
                    }
                    DemarcationLine([tR, "", G.D.S.GapIn, ""], GetDivSizeContent(DivContL).w - 2 * G.D.S.GapIn, "horizontal", DivContainerArchitectSetup);
                }
            }
        }
        DivContainerArchitectSetup.style.height = tR + "px";//Корректировка высоты контейнера
        DivContL.UpdateScroll();
    }

    ReDrawArchitectSetup();






    //Справка
    t = 0;
    //"Справка"
    TextSimple([t, "", 0, ""], ["", ""], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", G.L[G.S.L].Help, DivContR);
    t += 2 * h;
    let Htext1 = G.L[G.S.L].hnna010



    let DivHelp1 = TextSimple([t, "", 0, ""], ["", ""], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", Htext1, DivContR);
    ModDivPadding(["", "", "", G.D.S.GapIn], DivHelp1);
    DivHelp1.style.whiteSpace = "normal"; //Устанавливаем перенос строки автоматический
    //Справка. Стоп.





    //Обновление скрола. Вызывается когда размер DivContent изменился в следствии изменения контента. 
    DivContL.UpdateScroll();
    DivContR.UpdateScroll();


    //G.C.S.Display = [];
    //Manager_G_C_S_Display();
    DrawArchitecturePlot(NameNN);
}

//Данные. Набор. (Набор данных для обучения)
function NNSetWin_DataSet(DivCont, SD) {

    DivCont.innerHTML = "";

    let NameNN = G.Page.NN.SelectNameNN;
    let NNSet = G.NN.N[NameNN].Set;
    /*
        if (!(NameNN in G.Page.NN.DataSetSelectList)) {
            G.Page.NN.DataSetSelectList[NameNN] = 0;
        }
    */
    let SelectSymbol = NNSet.DataTrain[G.Page.NN.DataSetSelectList[NameNN]].Symbol;

    //Размеры окна
    let SizeWin = GetDivSizeContent(DivCont);

    //Размеры
    let ContLW = SD.LW;
    let ContLH = SizeWin.h - G.D.S.ButtonH - 2 * G.D.S.GapIn;
    let ContRL = ContLW + G.D.S.GapIn;
    let ContRW = SizeWin.w - ContRL;
    if (ContRW > SD.RW) {
        ContRW = SD.RW;
    }
    let t = 0;
    let l0 = G.D.S.GapIn;
    let l1 = l0 + G.D.S.Tab;
    let h = G.D.S.ContFontSizeNormal;
    let w1 = SD.LWTextFrameInput;



    //Контейнер со скролом Левый
    let DivContL = Container([0, "", 0, ""], [ContLW, "100%"], DivCont);
    DivContL = ModDivScrollV(DivContL, "NNSetWin_TrainingL");//добавляем скролл
    //Контейнер со скроолом Правый
    let DivContR = Container([0, "", ContRL, ""], [ContRW, "100%"], DivCont);
    DivContR = ModDivScrollV(DivContR, "NNSetWin_TrainingR");//добавляем скролл

    //"Набор данных для обучения"
    TextSimple([t, "", l0, ""], ["", ""], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", G.L[G.S.L].nnds010, DivContL);
    t += h;
    //Размеры списка.
    let l01 = l0;
    let w01 = 150;
    let l02 = l01 + w01;
    let w02 = 150;
    let w03 = SD.LWTextFrameInput / 2;

    //Шапка списка.
    //"Пара"
    TextSimple([t, "", l01, ""], ["", ""], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", G.L[G.S.L].Symbol, DivContL);
    //"Продолжительность"
    TextSimpleA([t, "", l02, ""], [w02, ""], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", "right", G.L[G.S.L].Duration, DivContL);
    t += h;

    //Список.
    for (let i = 0; i < NNSet.DataTrain.length; i++) {
        let Symbol = NNSet.DataTrain[i].Symbol;
        let D = DurationMsToDate(NNSet.DataTrain[i].PriceTimeEnd - NNSet.DataTrain[i].PriceTimeStart);
        let Color = G.D.C.TWin;
        if (i == G.Page.NN.DataSetSelectList[NameNN]) {
            Color = G.D.C.TWinLight;
        }

        let DivSelect = TextSimpleClick([t, "", l01, ""], ["", ""], Color, G.D.S.FontSizeNormal, "normal", Symbol, DivContL);
        //Клик на названии НС.
        DivSelect.onclick = function () {
            G.Page.NN.DataSetSelectList[NameNN] = i;
            NNSetWin_DataSet(DivCont, SD);
        };
        TextSimpleA([t, "", l02, ""], [w02, ""], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", "right", D, DivContL);
        if (NNSet.DataTrain.length > 1) {
            //"Удалить"
            let DivDel = ButtonText([t, "", "", l0], [w03, ""], G.L[G.S.L].Delete, DivContL);
            DivDel.onclick = function () {
                // начиная с индекса i удалим 1 элементов 
                NNSet.DataTrain.splice(i, 1);

                if (G.Page.NN.DataSetSelectList[NameNN] == NNSet.DataTrain.length) {
                    G.Page.NN.DataSetSelectList[NameNN]--;
                }
                SaveNNSet(NNSet, NameNN);
            }
        }
        t += h;
    }
    t += h;
    //"Добавить"
    let DivAdd = ButtonText([t, "", "", l0], [w03, ""], G.L[G.S.L].Add, DivContL);
    DivAdd.onclick = function () {
        NNSet.DataTrain.push(NNSet.DataTrain[G.Page.NN.DataSetSelectList[NameNN]]);
        G.Page.NN.DataSetSelectList[NameNN] = NNSet.DataTrain.length - 1;
        SaveNNSet(NNSet, NameNN);
    }
    t += 2 * h;

    //"Параметры"
    TextSimple([t, "", l0, ""], ["", ""], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", G.L[G.S.L].nnds020, DivContL);
    t += h;

    //"Пара"
    TextSimple([t, "", l0, ""], ["", ""], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", G.L[G.S.L].Symbol, DivContL);

    //let click=function(){
    //   DivContL.UpdateScroll();
    // }
    let DivListSelect = ListSelect([t, "", "", l0], [w1, h], SelectSymbol, G.S.TopSymbol, DivContL);
    DivListSelect.fnSelectContent = function (SelectContent) {//Изменение пары
        //console.log("SelectContent= " + SelectContent);
        //NNSet.Symbol = SelectContent;
        NNSet.DataTrain[G.Page.NN.DataSetSelectList[NameNN]].Symbol = SelectContent;

        //G.C.S.Display = ArrReplacement(G.C.S.Display, "Price" + NameNN, "Price" + SelectContent);
        GetPrice(SelectContent, false);
        //Внимание!!! Возникнит ошибка, если добавленная пара не успела подгрузиться с сайта Binance

        SaveNNSet(NNSet, NameNN);
    }
    t += 2 * h;

    //Интервал обучения
    let PriceTimeStart = NNSet.DataTrain[G.Page.NN.DataSetSelectList[NameNN]].PriceTimeStart;
    let PriceTimeEnd = NNSet.DataTrain[G.Page.NN.DataSetSelectList[NameNN]].PriceTimeEnd;



    let fTimeStartOnchange = function (value) {   //событие изменение содержания поля ввода текста
        NNSet.DataTrain[G.Page.NN.DataSetSelectList[NameNN]].PriceTimeStart = DateToUnix(value);
        SaveNNSet(NNSet, NameNN);
    };
    let fTimeEndOnchange = function (value) {   //событие изменение содержания поля ввода текста
        NNSet.DataTrain[G.Page.NN.DataSetSelectList[NameNN]].PriceTimeEnd = DateToUnix(value);
        SaveNNSet(NNSet, NameNN);
    };
    t = ModuleTextInterval(t, w1, NameNN, PriceTimeStart, PriceTimeEnd, fTimeStartOnchange, fTimeEndOnchange, DivContL);

    t += 2 * h;


    //Справка
    t = 0;
    //"Справка"
    TextSimple([t, "", 0, ""], ["", ""], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", G.L[G.S.L].Help, DivContR);
    t += 2 * h;
    let Htext = G.L[G.S.L].hnnds010;



    let DivHelp = TextSimple([t, "", 0, ""], ["", ""], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", Htext, DivContR);
    ModDivPadding(["", "", "", G.D.S.GapIn], DivHelp);
    DivHelp.style.whiteSpace = "normal"; //Устанавливаем перенос строки автоматический
    //Справка. Стоп.


    DivContL.UpdateScroll();
    DivContR.UpdateScroll();

    GetPrice(SelectSymbol, false);


}

//Данные. Параметры.
function NNSetWin_InputOutput(DivCont, SD) {
    DivCont.innerHTML = "";


    let NameNN = G.Page.NN.SelectNameNN;
    let NNSet = G.NN.N[NameNN].Set;

    //Статистика Выходных данных
    if (!(NameNN in G.InputOutputDataStatistic)) {
        G.InputOutputDataStatistic[NameNN] = {};
        //Нет статистики. Значения по умолчанию.
        G.StatisticOut[NameNN] = {};
        G.StatisticOut[NameNN].WaitOrder_Max = "";
        G.StatisticOut[NameNN].WaitOrder_Min = "";
        G.StatisticOut[NameNN].WaitOrder_Avg = "";
        G.StatisticOut[NameNN].WaitOrder_N = "";
        G.StatisticOut[NameNN].WidthSignalSale_Max = "";
        G.StatisticOut[NameNN].WidthSignalSale_Min = "";
        G.StatisticOut[NameNN].WidthSignalSale_Avg = "";
        G.StatisticOut[NameNN].WidthSignalSale_N = "";
        G.StatisticOut[NameNN].WidthSignalBuy_Max = "";
        G.StatisticOut[NameNN].WidthSignalBuy_Min = "";
        G.StatisticOut[NameNN].WidthSignalBuy_Avg = "";
        G.StatisticOut[NameNN].WidthSignalBuy_N = "";
        G.StatisticOut[NameNN].IncomeOrder_Max = "";
        G.StatisticOut[NameNN].IncomeOrder_Min = "";
        G.StatisticOut[NameNN].IncomeOrder_Avg = "";
        G.StatisticOut[NameNN].IncomeOrder_N = "";
        G.StatisticOut[NameNN].IncomeOrder_Sum = "";
    }
    //Статистика Входных данных
    if (!(NameNN in G.StatisticIn)) {
        //Нет статистики. Значения по умолчанию.
        G.StatisticIn[NameNN] = {};
        G.StatisticIn[NameNN].RangeCapture_Max = "";
        G.StatisticIn[NameNN].RangeCapture_Min = "";
        G.StatisticIn[NameNN].RangeCapture_Avg = "";
        G.StatisticIn[NameNN].RangeCapture_N = "";
        G.StatisticIn[NameNN].AmplitudeCapture_Max = "";
        G.StatisticIn[NameNN].AmplitudeCapture_Min = "";
        G.StatisticIn[NameNN].AmplitudeCapture_Avg = "";
        G.StatisticIn[NameNN].AmplitudeCapture_N = "";
        G.StatisticIn[NameNN].AmplitudePoint_Max = "";
        G.StatisticIn[NameNN].AmplitudePoint_Min = "";
        G.StatisticIn[NameNN].AmplitudePoint_Avg = "";
        G.StatisticIn[NameNN].AmplitudePoint_N = "";


    }
    WSMessageHandle["InputDataStatistic"] = function (M) {
        //console.log("Получены данные статистики StatisticIn :");
        //console.log(JSON.stringify(M));
        G.StatisticIn[NameNN] = M.StatisticIn;
        NNProcessSave.style.visibility = "hidden";//Скрываем иконку сохранения НС               
        NNSetWin_InputOutput(DivCont, SD);
    };

    WSMessageHandle["OutputDataStatistic"] = function (M) {
        //console.log("Получены данные статистики OutputDataStatistic :");
        //console.log(JSON.stringify(M));
        G.StatisticOut[NameNN] = M.StatisticOut;
        NNProcessSave.style.visibility = "hidden";//Скрываем иконку сохранения НС               
        NNSetWin_InputOutput(DivCont, SD);
    };

    //Размеры окна
    let SizeWin = GetDivSizeContent(DivCont);

    //Размеры
    let ContLW = SD.LW;
    let ContRL = ContLW + G.D.S.GapIn;
    let ContRW = SizeWin.w - ContRL;
    if (ContRW > SD.RW) {
        ContRW = SD.RW;
    }
    let t = 0;
    let l0 = G.D.S.GapIn;
    let l1 = l0 + G.D.S.Tab;
    let h = G.D.S.ContFontSizeNormal;
    let w1 = SD.LWTextFrameInput; // ширина полей ввода и кнопок

    //Контейнер со скроолом Левый
    let DivContL = Container([0, "", 0, ""], [ContLW, "100%"], DivCont);
    DivContL = ModDivScrollV(DivContL, "NNSetWin_InputOutputL");//добавляем скролл
    //Контейнер со скроолом Правый
    let DivContR = Container([0, "", ContRL, ""], [ContRW, "100%"], DivCont);
    DivContR = ModDivScrollV(DivContR, "NNSetWin_InputOutputR");//добовляем скрол


    //"Входные данные"
    TextSimple([t, "", l0, ""], ["", ""], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", G.L[G.S.L].nndp010, DivContL);
    t += h;

    //Тип Алгоритма генерации входных данных."Алгоритм компрессии"
    TextSimple([t, "", l1, ""], ["", ""], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", G.L[G.S.L].nndp020, DivContL);
    //"Сглаженный", "Экстремум"
    Dict_ACTN_R = [G.L[G.S.L].nndp021, G.L[G.S.L].nndp022];
    Dict_ACTN_E = ["Smooth", "Extremum"];

    let DivListSelect = ListSelect([t, "", "", l0], [w1, h], Translation(NNSet.AlgorithmCompressionType, Dict_ACTN_R, Dict_ACTN_E), Dict_ACTN_R, DivContL);
    DivListSelect.fnSelectContent = function (SelectContent) {//Изменение пары
        //console.log("SelectContent= " + SelectContent);
        NNSet.AlgorithmCompressionType = Translation(SelectContent, Dict_ACTN_R, Dict_ACTN_E)
        //G.C.S.Display = ArrReplacement(G.C.S.Display, "Price" + NameNN, "Price" + SelectContent);
        SaveNNSet(NNSet, NameNN);
        DivCont.innerHTML = "";
        NNSetWin_InputOutput(DivCont, SD)
        return;
    }
    t += 2 * h;
    switch (NNSet.AlgorithmCompressionType) {
        case "Smooth"://Сглаженный
            // "Глубина сглаживания"
            TextSimple([t, "", l1, ""], ["", ""], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", G.L[G.S.L].nndp030, DivContL);
            let Div_AC_Smooth_Depth = TextFrameInput([t, "", "", l0], [w1, h], 10, NNSet.AC_Smooth_Depth, DivContL);
            Div_AC_Smooth_Depth.oninput = function () {//событие изменение содержания поля ввода текста
                AutoVerificationNumber(this);//Проверка ввода данных
            };
            Div_AC_Smooth_Depth.onchange = function () {    //событие окончание изменение содержания поля ввода текста (потеря фокуса)
                NNSet.AC_Smooth_Depth = Number(Div_AC_Smooth_Depth.value);
                SaveNNSet(NNSet, NameNN);
            }
            t += h;

            //"Минимальный зазор"
            TextSimple([t, "", l1, ""], ["", ""], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", G.L[G.S.L].nndp040, DivContL);
            let Div_AC_Smooth_Gap = TextFrameInput([t, "", "", l0], [w1, h], 10, NNSet.AC_Smooth_Gap, DivContL);
            Div_AC_Smooth_Gap.oninput = function () {//событие изменение содержания поля ввода текста
                AutoVerificationNumber(this);//Проверка ввода данных
            };
            Div_AC_Smooth_Gap.onchange = function () {    //событие окончание изменение содержания поля ввода текста (потеря фокуса)
                NNSet.AC_Smooth_Gap = Number(Div_AC_Smooth_Gap.value);
                SaveNNSet(NNSet, NameNN);
            }
            t += h;
            //"Нелинейность зазора"
            TextSimple([t, "", l1, ""], ["", ""], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", G.L[G.S.L].nndp050, DivContL);
            let Div_AC_Smooth_NonlinearGap = TextFrameInput([t, "", "", l0], [w1, h], 10, NNSet.AC_Smooth_NonlinearGap, DivContL);
            Div_AC_Smooth_NonlinearGap.oninput = function () {//событие изменение содержания поля ввода текста
                AutoVerificationNumber(this);//Проверка ввода данных
            };
            Div_AC_Smooth_NonlinearGap.onchange = function () {    //событие окончание изменение содержания поля ввода текста (потеря фокуса)
                NNSet.AC_Smooth_NonlinearGap = Number(Div_AC_Smooth_NonlinearGap.value);
                SaveNNSet(NNSet, NameNN);
            }
            t += h;
            //"Максимальный зазор". Зазор на последнем нейроне = Минимальный зазор * (Нелинейность зазора ^ кол. нейронов в 1 слое)
            TextSimple([t, "", l1, ""], ["", ""], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", G.L[G.S.L].nndp060, DivContL);
            let Smooth_MaxG = NNSet.AC_Smooth_Gap * Math.pow(NNSet.AC_Smooth_NonlinearGap, NNSet.NIn);
            TextSimple([t, "", "", l0], ["", ""], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", Smooth_MaxG.toFixed(5), DivContL);
            t += h;

            break;
        case "Extremum"://Экстремум
            //"Минимальный зазор"
            TextSimple([t, "", l1, ""], ["", ""], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", G.L[G.S.L].nndp040, DivContL);
            let Div_AC_Extremum_Gap = TextFrameInput([t, "", "", l0], [w1, h], 10, NNSet.AC_Extremum_Gap, DivContL);
            Div_AC_Extremum_Gap.oninput = function () {//событие изменение содержания поля ввода текста
                AutoVerificationNumber(this);//Проверка ввода данных
            };
            Div_AC_Extremum_Gap.onchange = function () {    //событие окончание изменение содержания поля ввода текста (потеря фокуса)
                NNSet.AC_Extremum_Gap = Number(Div_AC_Extremum_Gap.value);
                SaveNNSet(NNSet, NameNN);
            }
            t += h;
            //"Нелинейность зазора"
            TextSimple([t, "", l1, ""], ["", ""], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", G.L[G.S.L].nndp050, DivContL);
            let Div_AC_Extremum_NonlinearGap = TextFrameInput([t, "", "", l0], [w1, h], 10, NNSet.AC_Extremum_NonlinearGap, DivContL);
            Div_AC_Extremum_NonlinearGap.oninput = function () {//событие изменение содержания поля ввода текста
                AutoVerificationNumber(this);//Проверка ввода данных
            };
            Div_AC_Extremum_NonlinearGap.onchange = function () {    //событие окончание изменение содержания поля ввода текста (потеря фокуса)
                NNSet.AC_Extremum_NonlinearGap = Number(Div_AC_Extremum_NonlinearGap.value);
                SaveNNSet(NNSet, NameNN);
            }
            t += h;
            //"Максимальный зазор". Зазор на последнем нейроне = Минимальный зазор * (Нелинейность зазора ^ кол. нейронов в 1 слое)
            TextSimple([t, "", l1, ""], ["", ""], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", G.L[G.S.L].nndp060, DivContL);
            let Extremum_MaxG = NNSet.AC_Extremum_Gap * Math.pow(NNSet.AC_Extremum_NonlinearGap, NNSet.NIn);
            TextSimple([t, "", "", l0], ["", ""], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", Extremum_MaxG.toFixed(5), DivContL);
            t += h;
            break;
    }
    //"График"
    TextSimple([t, "", l1, ""], ["", ""], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", G.L[G.S.L].Graph, DivContL); //сглаживания, точки сжатия.
    //"Отобразить"
    let DivCSPreview = ButtonText([t, "", "", l0], [w1, h], G.L[G.S.L].Display, DivContL);
    DivCSPreview.onclick = function () {
        NNProcessSave.style.visibility = "visible";//Отображаем иконку сохранения НС    
        let Message = {
            "Type": "GeneratorInputData",
            "NameNN": NameNN,
        };
        delete G.C.N["Compression" + NameNN];
        delete G.C.N["Smooth" + NameNN];
        MessageSend(Message);
    }
    t += 2 * h;


    //"Алгоритм нормализации". Тип Алгоритма нормолизации входных данных
    TextSimple([t, "", l1, ""], ["", ""], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", G.L[G.S.L].nndp070, DivContL);
    //"Относительный""Абсолютный"
    Dict_AN_R = [G.L[G.S.L].nndp071, G.L[G.S.L].nndp072];
    Dict_AN_E = ["Relative", "Absolute"];

    let DivListSelect2 = ListSelect([t, "", "", l0], [w1, h], Translation(NNSet.AlgorithmNormalizationInputs, Dict_AN_R, Dict_AN_E), Dict_AN_R, DivContL);
    DivListSelect2.fnSelectContent = function (SelectContent) {
        console.log("SelectContent= " + SelectContent);
        NNSet.AlgorithmNormalizationInputs = Translation(SelectContent, Dict_AN_R, Dict_AN_E)
        console.log("NNSet.AlgorithmNormalizationInputs= " + NNSet.AlgorithmNormalizationInputs);

        SaveNNSet(NNSet, NameNN);
        DivCont.innerHTML = "";
        NNSetWin_InputOutput(DivCont, SD)
        return;
    }
    t += h;
    //"Концентрация"
    TextSimple([t, "", l1, ""], ["", ""], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", G.L[G.S.L].nndp080, DivContL);
    let Div_Concentration = TextFrameInput([t, "", "", l0], [w1, h], 10, NNSet.ANI_Concentration, DivContL);
    Div_Concentration.oninput = function () {//событие изменение содержания поля ввода текста
        AutoVerificationNumber(this);//Проверка ввода данных
    };
    Div_Concentration.onchange = function () {    //событие окончание изменение содержания поля ввода текста (потеря фокуса)
        NNSet.ANI_Concentration = Number(Div_Concentration.value);
        SaveNNSet(NNSet, NameNN);
    }
    t += h;
    //"Предел"
    TextSimple([t, "", l1, ""], ["", ""], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", G.L[G.S.L].nndp090, DivContL);
    let Div_Limit = TextFrameInput([t, "", "", l0], [w1, h], 10, NNSet.ANI_Limit, DivContL);
    Div_Limit.oninput = function () {//событие изменение содержания поля ввода текста
        AutoVerificationNumber(this);//Проверка ввода данных
    };
    Div_Limit.onchange = function () {    //событие окончание изменение содержания поля ввода текста (потеря фокуса)
        NNSet.ANI_Limit = Number(Div_Limit.value);
        SaveNNSet(NNSet, NameNN);
    }
    t += h;
    //"Автонастройка нормализации"
    TextSimple([t, "", l1, ""], ["", ""], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", G.L[G.S.L].nndp100, DivContL);
    //"Обновить"
    let DivNormalizationInputsAutoSet = ButtonText([t, "", "", l0], [w1, h], G.L[G.S.L].Refresh, DivContL);
    DivNormalizationInputsAutoSet.onclick = function () {
        NNProcessSave.style.visibility = "visible";//Отображаем иконку сохранения НС    

        let Message = {
            "Type": "NormalizationInputsAutoSet",
            "NameNN": NameNN,
        };
        MessageSend(Message);

    }


    t += h;//+ G.D.S.FrameSize

    let CheckBoxOn = true;
    if (!NNSet.ANI_AutoUpdate) {
        CheckBoxOn = false;
    }
    //CheckBox
    let fnCheckBoxOn = function (On) {
        if (On) {
            NNSet.ANI_AutoUpdate = true;
        } else {
            NNSet.ANI_AutoUpdate = false;
        }
        SaveNNSet(NNSet, NameNN);
    };
    //"Автообновление"
    TextSimple([t, "", l1, ""], ["", ""], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", G.L[G.S.L].nndp110, DivContL);
    CheckBox([t, "", "", l0], [h, h], CheckBoxOn, fnCheckBoxOn, DivContL);
    t += 2 * h;//+ G.D.S.FrameSize




    //График Плотность распределения
    if (NNSet.ANI_DensityX != null && NNSet.ANI_BezierX != null) {

        //"График плотности распределения амплитуды (кр.)"
        TextSimple([t, "", l1, ""], ["", ""], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", G.L[G.S.L].nndp120, DivContL);
        t += h;
        //"График кривой нормализации (зел.)"
        TextSimple([t, "", l1, ""], ["", ""], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", G.L[G.S.L].nndp121, DivContL);
        t += 2 * h;

        //Плотность распределения для выбранного алгоритма.
        // NNSet.ANI_DensityY Плотность в точке X. Где максимум = 1.0
        // NNSet.ANI_DensityX  Для "Absolute":  Амплитуда захвата.[%]. Для "Relative": Амплитуда соседних точек компрессии.[%]
        let Data = [];   //Data = входящая [X, Y,  ...]; 
        for (let i = 0; i < NNSet.ANI_DensityX.length; i++) {
            Data.push(NNSet.ANI_DensityX[i]);
            Data.push(NNSet.ANI_DensityY[i]);
        }
        //console.log("Data " + Data);
        let SizeWinDivContL = GetDivSizeContent(DivContL);
        wCart = SizeWinDivContL.w - l1 - G.D.S.GapIn;
        hCart = 180;
        let DivContainer = Container([t, "", l1, ""], [wCart, hCart], DivContL);
        let DivChart = MiniChartContainer(G.D.S.ContFontSizeNormal, 20, DivContainer);
        let Limit = MiniChart(Data, G.D.C.Palette[4], "auto", "auto", "auto", "auto", DivChart);


        //График Bezier
        //Плотность распределения для выбранного алгоритма.
        // NNSet.ANI_DensityY Плотность в точке X. Где максимум = 1.0
        // NNSet.ANI_DensityX  Для "Absolute":  Амплитуда захвата.[%]. Для "Relative": Амплитуда соседних точек компрессии.[%]
        Data = [];   //Data = входящая [X, Y,  ...]; 
        for (let i = 0; i < NNSet.ANI_BezierX.length; i++) {
            Data.push(NNSet.ANI_BezierX[i]);
            Data.push(NNSet.ANI_BezierY[i]);
        }
        //console.log("Data " + Data);
        MiniChart(Data, G.D.C.Palette[7], Limit.MinX, Limit.MaxX, Limit.MinY, Limit.MaxY, DivChart);

        t += hCart + h;
        let ANI_Px = "";
        let ANI_Py = "";

        for (let i = 0; i < NNSet.ANI_Px.length; i++) {
            ANI_Px += NNSet.ANI_Px[i].toFixed(2);
            ANI_Py += NNSet.ANI_Py[i].toFixed(2);
            if (i < NNSet.ANI_Px.length - 1) {
                ANI_Px += "; ";
                ANI_Py += "; ";
            }

        }
        //"Опорные точки Безье X"
        TextSimple([t, "", l0, ""], ["", ""], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", G.L[G.S.L].nndp130 + " X", DivContL);
        TextSimple([t, "", "", l0], ["", ""], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", ANI_Px, DivContL);
        t += h;
        //"Опорные точки Безье Y"
        TextSimple([t, "", l0, ""], ["", ""], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", G.L[G.S.L].nndp130 + " Y", DivContL);
        TextSimple([t, "", "", l0], ["", ""], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", ANI_Py, DivContL);
        t += 2 * h;
    }

    //"Сила шума"
    TextSimple([t, "", l1, ""], ["", ""], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", G.L[G.S.L].nndp140, DivContL);
    let Div_NoiseInput = TextFrameInput([t, "", "", l0], [w1, h], 10, NNSet.NoiseInput, DivContL);
    Div_NoiseInput.oninput = function () {//событие изменение содержания поля ввода текста
        AutoVerificationNumber(this);//Проверка ввода данных
    };
    Div_NoiseInput.onchange = function () {    //событие окончание изменение содержания поля ввода текста (потеря фокуса)
        NNSet.NoiseInput = Number(Div_NoiseInput.value);
        SaveNNSet(NNSet, NameNN);
    }
    t += 2 * h;

    //"Выходные данные"
    TextSimple([t, "", l0, ""], ["", ""], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", G.L[G.S.L].nndp150, DivContL);
    t += h;
    //"Размытие сигнала продажи"
    TextSimple([t, "", l1, ""], ["", ""], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", G.L[G.S.L].nndp160, DivContL);
    let Div_StopSale = TextFrameInput([t, "", "", l0], [w1, h], 10, NNSet.StopSale, DivContL);
    Div_StopSale.oninput = function () {//событие изменение содержания поля ввода текста
        AutoVerificationNumber(this);//Проверка ввода данных
    };
    Div_StopSale.onchange = function () {    //событие окончание изменение содержания поля ввода текста (потеря фокуса)
        NNSet.StopSale = Number(Div_StopSale.value);
        SaveNNSet(NNSet, NameNN);
    }
    t += h;

    //"Размытие сигнала покупки"
    TextSimple([t, "", l1, ""], ["", ""], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", G.L[G.S.L].nndp161, DivContL);
    let Div_StopBuy = TextFrameInput([t, "", "", l0], [w1, h], 10, NNSet.StopBuy, DivContL);
    Div_StopBuy.oninput = function () {//событие изменение содержания поля ввода текста
        AutoVerificationNumber(this);//Проверка ввода данных
    };
    Div_StopBuy.onchange = function () {    //событие окончание изменение содержания поля ввода текста (потеря фокуса)
        NNSet.StopBuy = Number(Div_StopBuy.value);
        SaveNNSet(NNSet, NameNN);
    }
    t += h;
    //"Зазор между сигналами"
    TextSimple([t, "", l1, ""], ["", ""], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", G.L[G.S.L].nndp162, DivContL);
    let Div_Gap = TextFrameInput([t, "", "", l0], [w1, h], 10, NNSet.Gap, DivContL);
    Div_Gap.oninput = function () {//событие изменение содержания поля ввода текста
        AutoVerificationNumber(this);//Проверка ввода данных
    };
    Div_Gap.onchange = function () {    //событие окончание изменение содержания поля ввода текста (потеря фокуса)
        NNSet.Gap = Number(Div_Gap.value);
        SaveNNSet(NNSet, NameNN);
    }
    t += h;
    //"График"
    TextSimple([t, "", l1, ""], ["", ""], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", G.L[G.S.L].Graph, DivContL);// сигналов сделки.
    //"Просмотр"
    let DivCOPreview = ButtonText([t, "", "", l0], [w1, h], G.L[G.S.L].Display, DivContL);
    DivCOPreview.onclick = function () {
        NNProcessSave.style.visibility = "visible";//Отображаем иконку сохранения НС    
        let Message = {
            "Type": "GeneratorOutputData",
            "NameNN": NameNN,
        };
        delete G.C.N["OutputData" + NameNN];
        MessageSend(Message);
    }
    t += 2 * h;

    //"Статистика"
    TextSimple([t, "", l0, ""], ["", ""], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", G.L[G.S.L].Statistics, DivContL);
    t += h;

    //"Пара"
    TextSimple([t, "", l0, ""], ["", ""], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", G.L[G.S.L].Symbol, DivContL);
    let DivListSelect3 = ListSelect([t, "", "", l0], [w1, h], NNSet.DataStatisticSymbol, G.S.TopSymbol, DivContL);
    DivListSelect3.fnSelectContent = function (SelectContent) {//Изменение пары
        //console.log("SelectContent= " + SelectContent);
        NNSet.DataStatisticSymbol = SelectContent;
        SaveNNSet(NNSet, NameNN);
        GetPrice(SelectContent, false);
    }
    t += 2 * h;

    //Интервал Статистика
    let fTimeStartOnchange = function (value) {   //событие изменение содержания поля ввода текста
        NNSet.DataStatisticTimeStart = DateToUnix(value);
        SaveNNSet(NNSet, NameNN);
    };
    let fTimeEndOnchange = function (value) {   //событие изменение содержания поля ввода текста
        NNSet.DataStatisticTimeEnd = DateToUnix(value);
        SaveNNSet(NNSet, NameNN);
    };
    t = ModuleTextInterval(t, w1, NameNN, NNSet.DataStatisticTimeStart, NNSet.DataStatisticTimeEnd, fTimeStartOnchange, fTimeEndOnchange, DivContL);
    t += 2 * h;
    //"Статистика для интервала:"
    TextSimple([t, "", l0, ""], ["", ""], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", G.L[G.S.L].nndp170, DivContL);
    //"Обновить"
    let DivCSPreviewUpdate = ButtonText([t, "", "", l0], [w1, h], G.L[G.S.L].Refresh, DivContL);
    DivCSPreviewUpdate.onclick = function () {
        DivCSPreview.onclick();
        DivCOPreview.onclick();
    }
    t += h;
    //"Количество замеров"
    TextSimple([t, "", l1, ""], ["", ""], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", G.L[G.S.L].nndp180, DivContL);
    let Div_StatisticIn_NSamples = TextFrameInput([t, "", "", l0], [w1, h], 10, NNSet.StatisticIn_NSamples, DivContL);
    Div_StatisticIn_NSamples.oninput = function () {//событие изменение содержания поля ввода текста
        AutoVerificationNumber(this);//Проверка ввода данных
    };
    Div_StatisticIn_NSamples.onchange = function () {    //событие окончание изменение содержания поля ввода текста (потеря фокуса)
        NNSet.StatisticIn_NSamples = Number(Div_StatisticIn_NSamples.value);
        SaveNNSet(NNSet, NameNN);
    }
    t += h;


    //Таблица. 
    //Размеры
    let lTable = ContLW - w1 - l0 - G.D.S.ScrollThickness - 50;//50 увеличение
    let wTable = (ContLW - lTable - l0 - G.D.S.ScrollThickness) / 3;

    let SIn = G.StatisticIn[NameNN];
    let SOut = G.StatisticOut[NameNN];



    //Талица. 1 строка."Захват входных данных"
    let S0 = [G.L[G.S.L].nndp190, SIn.RangeCapture_Max, SIn.RangeCapture_Min, SIn.RangeCapture_Avg];
    //Талица. 2 строка."Амплитуда захвата"
    let S1 = [G.L[G.S.L].nndp191, SIn.AmplitudeCapture_Max, SIn.AmplitudeCapture_Min, SIn.AmplitudeCapture_Avg];
    //Талица. 3 строка."Амплитуда соседних точек"
    let S2 = [G.L[G.S.L].nndp192, SIn.AmplitudePoint_Max, SIn.AmplitudePoint_Min, SIn.AmplitudePoint_Avg];
    //Талица. 4 строка."Ожидание сделки"
    let S3 = [G.L[G.S.L].nndp193, SOut.WaitOrder_Max, SOut.WaitOrder_Min, SOut.WaitOrder_Avg];
    //Талица. 5 строка."Ширина сигнала продажи"
    let S4 = [G.L[G.S.L].nndp194, SOut.WidthSignalSale_Max, SOut.WidthSignalSale_Min, SOut.WidthSignalSale_Avg];
    //Талица. 6 строка."Ширина сигнала покупки"
    let S5 = [G.L[G.S.L].nndp195, SOut.WidthSignalBuy_Max, SOut.WidthSignalBuy_Min, SOut.WidthSignalBuy_Avg];
    //Талица. 7 строка."Доход от сделки, в %"
    let S6 = [G.L[G.S.L].nndp196, SOut.IncomeOrder_Max, SOut.IncomeOrder_Min, SOut.IncomeOrder_Avg];
    let S = [S0, S1, S2, S3, S4, S5, S6];



    //Верхняя шапка    
    for (let j = 0; j < 3; j++) {
        //"макс.""мин.""средн."
        let Content = [G.L[G.S.L].Max, G.L[G.S.L].Min, G.L[G.S.L].Avg][j];
        let l = lTable + wTable * j;
        TextSimpleA([t, "", l, ""], [wTable, h], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", "right", Content, DivContL);
    }
    t += h;
    let tt = t;

    for (let i = 0; i < S.length; i++) {//строки

        for (let j = 0; j < S[i].length; j++) {//Столбцы
            let Content = S[i][j];
            if (j == 0) {
                TextSimple([tt, "", l0, ""], ["", ""], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", Content, DivContL);
            } else {
                let ll = lTable + wTable * (j - 1);
                if (i == 0 || i == 3 || i == 4 || i == 5) {
                    //"Захват входных данных"
                    //"Ожидание сделки"
                    //"Ширина сигнала продажи"
                    //"Ширина сигнала покупки"
                    if (Content !== "") {
                        Content = DurationMsToDateN(Content, 2);
                    }
                } else {
                    //"Амплитуда захватах"
                    //console.log("Contente=" + Content);
                    if (Content !== "") {
                        Content = RoundingToN(Content, 1) + "%";
                    }
                }
                TextSimpleA([tt, "", ll, ""], [wTable, h], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", "right", Content, DivContL);
            }


        }
        tt += h;
    }
    t = tt;
    t += h;
    //"Входной слой НС"
    TextSimple([t, "", l0, ""], ["", ""], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", G.L[G.S.L].nndp200, DivContL);
    TextSimple([t, "", "", l0], ["", ""], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", NNSet.NIn, DivContL);
    t += h;
    //"Доход, в %"
    TextSimple([t, "", l0, ""], ["", ""], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", G.L[G.S.L].nndp201, DivContL);
    let Content = SOut.IncomeOrder_Sum;
    if (Content != "") { Content = Content.toExponential(3); }
    TextSimple([t, "", "", l0], ["", ""], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", Content, DivContL);
    t += h;
    //"Количество сделок"
    TextSimple([t, "", l0, ""], ["", ""], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", G.L[G.S.L].nndp202, DivContL);
    TextSimple([t, "", "", l0], ["", ""], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", SOut.IncomeOrder_N, DivContL);
    t += h;

    DivContL.UpdateScroll();


    //Справка
    t = 0;
    //"Справка"
    TextSimple([t, "", 0, ""], ["", ""], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", G.L[G.S.L].Help, DivContR);
    t += 2 * h;
    let Htext1 = G.L[G.S.L].hnndp010;
    let Htext2 = G.L[G.S.L].hnndp020;

    let DivHelp1 = TextSimple([t, "", 0, ""], ["", ""], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", Htext1, DivContR);
    ModDivPadding(["", "", "", G.D.S.GapIn], DivHelp1);
    DivHelp1.style.whiteSpace = "normal"; //Устанавливаем перенос строки автоматический

    let hDivHelp1 = GetDivSizeContent(DivHelp1).h;
    t += hDivHelp1;
    let himg = 232;
    let wimg = 436;
    let limg = (ContRW - wimg) / 2 - G.D.S.GapIn;
    ImageContainer([t, "", limg, ""], [wimg, himg], "GeneratorOutput.png", DivContR);
    t += himg + h;

    let DivHelp2 = TextSimple([t, "", 0, ""], ["", ""], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", Htext2, DivContR);
    ModDivPadding(["", "", "", G.D.S.GapIn], DivHelp2);
    DivHelp2.style.whiteSpace = "normal"; //Устанавливаем перенос строки автоматический

    DivContR.UpdateScroll();

    //Справка. Стоп.
    let Symbol = NNSet.DataStatisticSymbol;

    GetPrice(Symbol, false);



    // DrawChart();
}

//Сходимость
function NNSetWin_Convergence(DivCont, SD) {

    let NameNN = G.Page.NN.SelectNameNN;
    let NNSet = G.NN.N[NameNN].Set;
    //Размеры окна
    let SizeWin = GetDivSizeContent(DivCont);

    //Размеры
    let ContLW = SD.LW;
    let ContRL = ContLW + G.D.S.GapIn;
    let ContRW = SizeWin.w - ContRL;
    if (ContRW > SD.RW) {
        ContRW = SD.RW;
    }
    let t = 0;
    let l0 = G.D.S.GapIn;
    let l1 = l0 + G.D.S.Tab;
    let h = G.D.S.ContFontSizeNormal;
    let w1 = SD.LWTextFrameInput;



    //Контейнер со скролом Левый
    let DivContL = Container([0, "", 0, ""], [ContLW, "100%"], DivCont);
    DivContL = ModDivScrollV(DivContL, "NNSetWin_ConvergenceL");//добавляем скролл
    //Контейнер со скроолом Правый
    let DivContR = Container([0, "", ContRL, ""], [ContRW, "100%"], DivCont);
    DivContR = ModDivScrollV(DivContR, "NNSetWin_ConvergenceR");//добавляем скролл


    let Content;
    //"Пройдено эпох обучения"
    TextSimple([t, "", l0, ""], ["", ""], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", G.L[G.S.L].nnc010, DivContL);
    Content = (NNSet.ErrorTrade_Iteration) ? NNSet.ErrorTrade_Iteration[NNSet.ErrorTrade_Iteration.length - 1].toFixed(2) : 0;
    TextSimple([t, "", "", l0], ["", ""], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", Content, DivContL);
    t += 2 * h;

    //"Сходимость"
    //TextSimple([t, "", l0, ""], ["", ""], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", G.L[G.S.L].nnc020, DivContL);
    //t += h;

    //"Сходимость средняя"
    TextSimple([t, "", l0, ""], ["", ""], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", G.L[G.S.L].g01, DivContL);
    Content = (NNSet.ErrorTrade_Average) ? NNSet.ErrorTrade_Average[NNSet.ErrorTrade_Average.length - 1].toFixed(6) : "-";
    TextSimple([t, "", "", l0], ["", ""], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", Content, DivContL);
    t += h;

    //Ошибки по характеру торгового сигнала [Epoch][Buy,NoSignal,Sale] 
    //"Сходимость нет сигнала"
    TextSimple([t, "", l0, ""], ["", ""], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", G.L[G.S.L].g02, DivContL);
    Content = (NNSet.ErrorTrade_NoSignal) ? NNSet.ErrorTrade_NoSignal[NNSet.ErrorTrade_NoSignal.length - 1].toFixed(6) : "-";
    TextSimple([t, "", "", l0], ["", ""], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", Content, DivContL);
    t += h;
    //"Сходимость покупка"
    TextSimple([t, "", l0, ""], ["", ""], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", G.L[G.S.L].g08, DivContL);
    Content = (NNSet.ErrorTrade_Buy) ? NNSet.ErrorTrade_Buy[NNSet.ErrorTrade_Buy.length - 1].toFixed(6) : "-";
    TextSimple([t, "", "", l0], ["", ""], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", Content, DivContL);
    t += h;
    //"Сходимость продажа"
    TextSimple([t, "", l0, ""], ["", ""], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", G.L[G.S.L].g07, DivContL);
    Content = (NNSet.ErrorTrade_Sale) ? NNSet.ErrorTrade_Sale[NNSet.ErrorTrade_Sale.length - 1].toFixed(6) : "-";
    TextSimple([t, "", "", l0], ["", ""], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", Content, DivContL);
    t += 2 * h;

    //"Деление эпохи"
    TextSimple([t, "", l0, ""], ["", ""], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", G.L[G.S.L].nnc030, DivContL);

    let Div_Momentum = TextFrameInput([t, "", "", l0], [w1, h], 10, NNSet.SubEpochShow, DivContL);
    Div_Momentum.oninput = function () {   //событие изменение содержания поля ввода текста
        AutoVerificationNumber(this);//Проверка ввода данных
        if (Number(Div_Momentum.value) < 1) {
            Div_Momentum.value = 1;
        }
        Div_Momentum.value = Number(Div_Momentum.value).toFixed(0);
    };
    Div_Momentum.onchange = function () {    //событие окончание изменение содержания поля ввода текста (потеря фокуса)
        NNSet.SubEpochShow = Number(Div_Momentum.value);
        SaveNNSet(NNSet, NameNN);
    }
    t += 2 * h;



    //"Алгоритмы оптимизации"
    TextSimple([t, "", l0, ""], ["", ""], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", G.L[G.S.L].nnc040, DivContL);
    let Div_Optimization = ListSelect([t, "", "", l0], [w1, h], NNSet.NN.Optimization, ["SGD", "Momentum", "MomentumE", "Adam", "RMSProp"], DivContL);
    Div_Optimization.fnSelectContent = function (SelectContent) {// 
        NNSet.NN.Optimization = SelectContent;
        SaveNNSet(NNSet, NameNN);
    }
    t += h;
    //"Скорость обучения"
    TextSimple([t, "", l0, ""], ["", ""], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", G.L[G.S.L].nnc050, DivContL);
    let Div_Rate = TextFrameInput([t, "", "", l0], [w1, h], 10, NNSet.NN.Rate, DivContL);
    Div_Rate.oninput = function () {   //событие изменение содержания поля ввода текста
        AutoVerificationNumber(this);//Проверка ввода данных
    };
    Div_Rate.onchange = function () {    //событие окончание изменение содержания поля ввода текста (потеря фокуса)
        NNSet.NN.Rate = Number(Div_Rate.value);
        SaveNNSet(NNSet, NameNN);
    }
    t += h;

    if (NNSet.NN.Optimization == "Momentum" || NNSet.NN.Optimization == "MomentumE") {
        //"Момент обучения"
        TextSimple([t, "", l0, ""], ["", ""], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", G.L[G.S.L].nnc060, DivContL);

        let Div_Momentum = TextFrameInput([t, "", "", l0], [w1, h], 10, NNSet.NN.Momentum, DivContL);
        Div_Momentum.oninput = function () {   //событие изменение содержания поля ввода текста
            AutoVerificationNumber(this);//Проверка ввода данных
        };
        Div_Momentum.onchange = function () {    //событие окончание изменение содержания поля ввода текста (потеря фокуса)
            NNSet.NN.Momentum = Number(Div_Momentum.value);
            SaveNNSet(NNSet, NameNN);
        }
        t += h;
    }
    t += h;
    //"Функция активации"
    TextSimple([t, "", l0, ""], ["", ""], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", G.L[G.S.L].nnc070, DivContL);
    t += h;
    //"Скрытые слои"
    TextSimple([t, "", l0, ""], ["", ""], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", G.L[G.S.L].nnc080, DivContL);
    let ActivationHide = NNSet.NN.Activation[1];
    let Div_ActivationHide = ListSelect([t, "", "", l0], [w1, h], ActivationHide, ["Sigmoid", "Tanh", "ReLU", "LeakyReLU", "ELU"], DivContL);
    Div_ActivationHide.fnSelectContent = function (SelectContent) {// 
        for (let i = 1; i < NNSet.NN.Activation.length - 1; i++) {
            NNSet.NN.Activation[i] = SelectContent;
        }
        SaveNNSet(NNSet, NameNN);
    }
    t += h;
    //"Выходной слой"
    TextSimple([t, "", l0, ""], ["", ""], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", G.L[G.S.L].nnc090, DivContL);
    let ActivationEnd = NNSet.NN.Activation[NNSet.NN.Activation.length - 1];
    let Div_ActivationEnd = ListSelect([t, "", "", l0], [w1, h], ActivationEnd, ["Sigmoid", "Tanh", "ReLU", "LeakyReLU", "ELU"], DivContL);
    Div_ActivationEnd.fnSelectContent = function (SelectContent) {// 
        NNSet.NN.Activation[NNSet.NN.Activation.length - 1] = SelectContent;
        SaveNNSet(NNSet, NameNN);
    }
    t += 5 * h;
    TextSimple([t, "", 0, ""], ["", ""], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", "", DivContL);





    DivContL.UpdateScroll();

    //Справка
    t = 0;
    //"Справка"
    TextSimple([t, "", 0, ""], ["", ""], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", G.L[G.S.L].Help, DivContR);
    t += 2 * h;
    let Htext1 = G.L[G.S.L].hnnc010;
    let Htext2 = G.L[G.S.L].hnnc020;

    let DivHelp1 = TextSimple([t, "", 0, ""], ["", ""], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", Htext1, DivContR);
    ModDivPadding(["", "", "", G.D.S.GapIn], DivHelp1);
    DivHelp1.style.whiteSpace = "normal"; //Устанавливаем перенос строки автоматический


    let hDivHelp1 = GetDivSizeContent(DivHelp1).h;
    t += hDivHelp1;
    let himg = 206 / 1.15;
    let wimg = 481 / 1.15;
    let limg = (ContRW - wimg) / 2 - G.D.S.GapIn;
    ImageContainer([t, "", limg, ""], [wimg, himg], "Convergence.png", DivContR);
    t += himg + h;

    let DivHelp2 = TextSimple([t, "", 0, ""], ["", ""], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", Htext2, DivContR);
    ModDivPadding(["", "", "", G.D.S.GapIn], DivHelp2);
    DivHelp2.style.whiteSpace = "normal"; //Устанавливаем перенос строки автоматический


    DivContR.UpdateScroll();





    //Справка. Стоп.

    //График сходимости
    /*
    let Data = [];
    if (NNSet.NN.ErrorEpoch) {
        //NNSet.NN.ErrorEpoch История сходимости обучения НС. Среднеарифметическая относительная ошибка по эпохам
        //Приведем NNSet.NN.ErrorEpoch [Y,...] к масиву типа [X, Y,  ...]         
        for (let i = 0; i < NNSet.NN.ErrorEpoch.length; i++) {
            //Data.push(i, NNSet.NN.ErrorEpoch[i]);
            Data[i * 2] = i;
            Data[i * 2 + 1] = NNSet.NN.ErrorEpoch[i];
        }
    }
    UpdateDataChart("Convergence", NameNN, Data, "iteration", "convergence")
*/

    //Ошибки по характеру торгового сигнала [Epoch][Buy,NoSignal,Sale] 
    let DataAverage = [];
    let DataNoSignal = [];

    let DataBuy = [];
    let DataSale = [];
    /*
        if (NNSet.ErrorTrade) {
            //NNSet.NN.ErrorEpoch История сходимости обучения НС. Среднеарифметическая относительная ошибка по эпохам
            //Приведем NNSet.NN.ErrorEpoch [Y,...] к масиву типа [X, Y,  ...]         
            for (let i = 0; i < NNSet.ErrorTrade.length; i++) {
                DataBuy[i * 2] = i;
                DataBuy[i * 2 + 1] = NNSet.ErrorTrade[i][0];
                DataNoSignal[i * 2] = i;
                DataNoSignal[i * 2 + 1] = NNSet.ErrorTrade[i][1];
                DataSale[i * 2] = i;
                DataSale[i * 2 + 1] = NNSet.ErrorTrade[i][2];
            }
        }
    */
    if (NNSet.ErrorTrade_Iteration) {
        //NNSet.NN.ErrorEpoch История сходимости обучения НС. Среднеарифметическая относительная ошибка по эпохам
        //Приведем NNSet.ErrorTrade_ к масиву типа [X, Y,  ...]         
        for (let i = 0; i < NNSet.ErrorTrade_Iteration.length; i++) {
            DataAverage[i * 2] = NNSet.ErrorTrade_Iteration[i];
            DataAverage[i * 2 + 1] = NNSet.ErrorTrade_Average[i];
            DataBuy[i * 2] = NNSet.ErrorTrade_Iteration[i];
            DataBuy[i * 2 + 1] = NNSet.ErrorTrade_Buy[i];
            DataNoSignal[i * 2] = NNSet.ErrorTrade_Iteration[i];
            DataNoSignal[i * 2 + 1] = NNSet.ErrorTrade_NoSignal[i];
            DataSale[i * 2] = NNSet.ErrorTrade_Iteration[i];
            DataSale[i * 2 + 1] = NNSet.ErrorTrade_Sale[i];
        }
    }

    UpdateDataChart("ConvergenceAverage", NameNN, DataAverage, "iteration", "convergence")
    UpdateDataChart("ConvergenceNoSignal", NameNN, DataNoSignal, "iteration", "convergence")
    UpdateDataChart("ConvergenceBuy", NameNN, DataBuy, "iteration", "convergence")
    UpdateDataChart("ConvergenceSale", NameNN, DataSale, "iteration", "convergence")


}

//Триггер
function NNSetWin_Trigger(DivCont, SD) {

    let NameNN = G.Page.NN.SelectNameNN;
    let NNSet = G.NN.N[NameNN].Set;
    //Размеры окна
    let SizeWin = GetDivSizeContent(DivCont);

    //Размеры
    let ContLW = SD.LW;
    let ContRL = ContLW + G.D.S.GapIn;
    let ContRW = SizeWin.w - ContRL;
    if (ContRW > SD.RW) {
        ContRW = SD.RW;
    }
    let t = 0;
    let l0 = G.D.S.GapIn;
    let l1 = l0 + G.D.S.Tab;
    let h = G.D.S.ContFontSizeNormal;
    let w1 = SD.LWTextFrameInput;



    //Контейнер со скролом Левый
    let DivContL = Container([0, "", 0, ""], [ContLW, "100%"], DivCont);
    DivContL = ModDivScrollV(DivContL, "NNSetWin_TriggerL");//добавляем скролл
    //Контейнер со скроолом Правый
    let DivContR = Container([0, "", ContRL, ""], [ContRW, "100%"], DivCont);
    DivContR = ModDivScrollV(DivContR, "NNSetWin_TriggerR");//добавляем скролл

    //"Настройки поиска лучшего триггера:"
    TextSimple([t, "", l0, ""], ["", ""], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", G.L[G.S.L].nnt010, DivContL);
    t += h;
    //"Алгоритм"
    TextSimple([t, "", l0, ""], ["", ""], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", G.L[G.S.L].nnt020, DivContL);
    //"Доход", "Точность", "Ручной"
    let Dict_TA_R = [G.L[G.S.L].nnt021, G.L[G.S.L].nnt022, G.L[G.S.L].nnt023];
    let Dict_TA_E = ["Income", "Accuracy", "Manual"];

    let DivListSelectTA = ListSelect([t, "", "", l0], [w1, h], Translation(NNSet.TriggerAlgorithm, Dict_TA_R, Dict_TA_E), Dict_TA_R, DivContL);
    DivListSelectTA.fnSelectContent = function (SelectContent) {
        //console.log("SelectContent= " + SelectContent);
        NNSet.TriggerAlgorithm = Translation(SelectContent, Dict_TA_R, Dict_TA_E)
        console.log("NNSet.TriggerAlgorithm= " + NNSet.TriggerAlgorithm);
        SaveNNSet(NNSet, NameNN);
    }
    t += h;

    switch (NNSet.TriggerAlgorithm) {
        case "Income":
            {//+модуль, чтобы let не ругалась
                //"Размер матрицы"
                TextSimple([t, "", l1, ""], ["", ""], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", G.L[G.S.L].nnt030, DivContL);
                let Div_MatrixSize = TextFrameInput([t, "", "", l0], [w1, h], 10, NNSet.TriggerIncomeMatrixSize, DivContL);
                Div_MatrixSize.oninput = function () {//событие изменение содержания поля ввода текста
                    AutoVerificationNumber(this);//Проверка ввода данных
                };
                Div_MatrixSize.onchange = function () {    //событие окончание изменение содержания поля ввода текста (потеря фокуса)
                    NNSet.TriggerIncomeMatrixSize = Number(Div_MatrixSize.value);
                    SaveNNSet(NNSet, NameNN);
                }
                t += h;
                //"Радиус поиска"
                TextSimple([t, "", l1, ""], ["", ""], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", G.L[G.S.L].nnt040, DivContL);
                let Div_TriggerRadius = TextFrameInput([t, "", "", l0], [w1, h], 10, NNSet.TriggerIncomeRadius, DivContL);
                Div_TriggerRadius.oninput = function () {//событие изменение содержания поля ввода текста
                    AutoVerificationNumber(this);//Проверка ввода данных
                };
                Div_TriggerRadius.onchange = function () {    //событие окончание изменение содержания поля ввода текста (потеря фокуса)
                    NNSet.TriggerIncomeRadius = Number(Div_TriggerRadius.value);
                    SaveNNSet(NNSet, NameNN);
                }
                t += 3 * h;



                if (NNSet.TriggerIncomeMatrix != null) {
                    //Есть данные поиска триггера

                    //Информация о лучшем триггере
                    let BestTrigger = NNSet.TriggerIncomeMatrix[NNSet.TriggerIncomeBestBi][NNSet.TriggerIncomeBestSi];
                    // console.log("BestTrigger=" + BestTrigger);
                    //"Результаты поиска лучшего триггера:"
                    TextSimple([t, "", l0, ""], ["", ""], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", G.L[G.S.L].nnt050, DivContL);
                    t += h;
                    //"Триггер покупки"
                    TextSimple([t, "", l1, ""], ["", ""], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", G.L[G.S.L].nnt051, DivContL);
                    TextSimple([t, "", "", l0], ["", ""], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", BestTrigger.TriggerBuy.toFixed(1), DivContL);
                    t += h;
                    //"Триггер продажи"
                    TextSimple([t, "", l1, ""], ["", ""], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", G.L[G.S.L].nnt052, DivContL);
                    TextSimple([t, "", "", l0], ["", ""], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", BestTrigger.TriggerSale.toFixed(1), DivContL);
                    t += h;
                    //"Доход, в %."
                    TextSimple([t, "", l1, ""], ["", ""], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", G.L[G.S.L].nnt053, DivContL);
                    TextSimple([t, "", "", l0], ["", ""], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", BestTrigger.Income.toExponential(3), DivContL);
                    t += h;
                    //"Количество сделок"
                    TextSimple([t, "", l1, ""], ["", ""], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", G.L[G.S.L].nnt054, DivContL);
                    TextSimple([t, "", "", l0], ["", ""], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", BestTrigger.NOrder, DivContL);
                    t += 2 * h;

                    //Максимальный доход и количество сделок
                    let MaxIncome = -Infinity;
                    let MaxNOrder = -Infinity;
                    let MaxTrigger = -Infinity;
                    let MinTrigger = Infinity;

                    let nStep = NNSet.TriggerIncomeMatrix.length
                    for (let iTB = 0; iTB < nStep; iTB++) { //покупка от -100 до 0(не включительно)
                        for (let iTS = 0; iTS < nStep; iTS++) { //продажа от 100 до 0(не включительно)

                            let Income = NNSet.TriggerIncomeMatrix[iTB][iTS].Income
                            let NOrder = NNSet.TriggerIncomeMatrix[iTB][iTS].NOrder
                            //let TriggerBuy = -iTB * Step;//Триггер покупки. Значения: -100-0
                            //let TriggerSale = iTS * Step;//Триггер продажи. Значения: 0-100
                            let TriggerBuy = NNSet.TriggerIncomeMatrix[iTB][iTS].TriggerBuy;//Триггер покупки. Значения: -100-0
                            let TriggerSale = NNSet.TriggerIncomeMatrix[iTB][iTS].TriggerSale;//Триггер продажи. Значения: 0-100
                            if (Income > 0) {
                                if (MaxIncome < Income) {
                                    MaxIncome = Income;
                                }
                                if (MaxNOrder < NOrder) {
                                    MaxNOrder = NOrder;
                                }
                                if (MaxTrigger < TriggerSale) {
                                    MaxTrigger = TriggerSale;
                                }
                                if (MinTrigger > TriggerBuy) {
                                    MinTrigger = TriggerBuy;
                                }
                            }

                        }
                    }

                    let Limit = {};
                    Limit.Min = 0;
                    Limit.Max = MaxIncome;

                    //Скролл двигается линейно, а значения меняться логарифмически
                    let Base = 20;//нелинейность
                    //Полоса зеленого цвета."Нижний предел"
                    TextSimple([t, "", l0, ""], ["", ""], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", G.L[G.S.L].nnt060, DivContL);
                    let DivMinLimit = TextFrameInput([t, "", "", l0], [w1, h], 10, Limit.Min.toExponential(3), DivContL);//поле ввода 
                    t += h;
                    let SetValue1;
                    let ScrollMove1 = function (value) {//При перемещении ползунка, в функцию отправляется значение (0-1)
                        let vLog = ToLogScale(value, Base);//Преобразует значение x (от 0 до 1) из линейной шкалы, в значение y (от 0 до 1) нелинейной шкалы. Base от 1 до 20. Степень нелинейности
                        let vIncome = MaxIncome * vLog;//преобразуем в Income
                        //console.log("value = " + value + "  v = " + v);
                        if (vIncome > 0.9999 * Limit.Max) {
                            vIncome = 0.9999 * Limit.Max;
                            //if ( vIncome==MaxIncome) { vIncome=MaxIncome-1}

                            vLog = vIncome / MaxIncome;
                            value = FromLogScale(vLog, Base); //Преобразует значение y (от 0 до 1) нелинейной шкалы в значение x (от 0 до 1) линейной шкалы. Base от 1 до 20. Степень нелинейности
                            SetValue1(value);//Сместить скролл
                        }
                        DivMinLimit.value = vIncome.toExponential(3);
                        Limit.Min = vIncome;
                        ReDrawMatrixPlotLimit(Limit.Min, Limit.Max);
                    };
                    SetValue1 = ScrollBar([t, "", l0, ""], GetDivSizeContent(DivContL).w - 2 * l0, "horizontal", ScrollMove1, DivContL);
                    DivMinLimit.oninput = function () { //событие изменение содержания поля ввода текста
                        AutoVerificationNumber(this);//Проверка ввода данных
                        let value = Number(DivMinLimit.value) / MaxIncome;
                        //let vLog = ToLogScale(value, 10);//Преобразует значение x (от 0 до 1) из линейной шкалы, в значение y (от 0 до 1) нелинейной шкалы. Base от 1 до 20. Степень нелинейности
                        SetValue1(value);//Сместить скролл
                        ScrollMove1(value);//имитировать движение ползунка

                    };
                    SetValue1(0);//Сместить скролл
                    t += h;

                    //Полоса красного цвета."Верхний предел"
                    TextSimple([t, "", l0, ""], ["", ""], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", G.L[G.S.L].nnt062, DivContL);
                    let DivMaxLimit = TextFrameInput([t, "", "", l0], [w1, h], 10, Limit.Max.toExponential(3), DivContL);//поле ввода 
                    t += h;
                    let SetValue2;
                    let ScrollMove2 = function (value) {//При перемещении ползунка, в функцию отправляется значение (0-1)
                        let vLog = ToLogScale(value, Base);//Преобразует значение x (от 0 до 1) из линейной шкалы, в значение y (от 0 до 1) нелинейной шкалы. Base от 1 до 20. Степень нелинейности
                        let vIncome = MaxIncome * vLog;//преобразуем в Income
                        if (vIncome < Limit.Min / 0.9999 || vIncome == 0) {
                            vIncome = Limit.Min / 0.9999;
                            if (vIncome == 0) { vIncome = 0.0001 * MaxIncome }
                            vLog = vIncome / MaxIncome;
                            value = FromLogScale(vLog, Base); //Преобразует значение y (от 0 до 1) нелинейной шкалы в значение x (от 0 до 1) линейной шкалы. Base от 1 до 20. Степень нелинейности
                            SetValue2(value);//Сместить скролл
                        }
                        DivMaxLimit.value = vIncome.toExponential(3);
                        Limit.Max = vIncome;
                        ReDrawMatrixPlotLimit(Limit.Min, Limit.Max);
                    };
                    SetValue2 = ScrollBar([t, "", l0, ""], GetDivSizeContent(DivContL).w - 2 * l0, "horizontal", ScrollMove2, DivContL);
                    DivMaxLimit.oninput = function () {//событие изменение содержания поля ввода текста
                        AutoVerificationNumber(this);//Проверка ввода данных
                        let value = Number(DivMaxLimit.value) / MaxIncome;
                        SetValue2(value);//Сместить скролл
                        ScrollMove2(value);//имитировать движение ползунка
                    };
                    SetValue2(1);//Сместить скрол
                    t += h;
                    t += h;

                    //"Статистика"
                    TextSimple([t, "", l0, ""], ["", ""], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", G.L[G.S.L].Statistics, DivContL);
                    t += h;
                    //"Максимальный доход, в %."
                    TextSimple([t, "", l1, ""], ["", ""], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", G.L[G.S.L].nnt070, DivContL);
                    TextSimple([t, "", "", l0], ["", ""], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", MaxIncome.toExponential(3), DivContL);
                    t += h;
                    //"Максимальное количество сделок"
                    TextSimple([t, "", l1, ""], ["", ""], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", G.L[G.S.L].nnt071, DivContL);
                    TextSimple([t, "", "", l0], ["", ""], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", MaxNOrder, DivContL);
                    t += h;
                    // "Максимальное значение триггера"
                    TextSimple([t, "", l1, ""], ["", ""], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", G.L[G.S.L].nnt072, DivContL);
                    TextSimple([t, "", "", l0], ["", ""], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", MaxTrigger.toFixed(1), DivContL);
                    t += h;
                    //"Минимальное значение триггера"
                    TextSimple([t, "", l1, ""], ["", ""], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", G.L[G.S.L].nnt073, DivContL);
                    TextSimple([t, "", "", l0], ["", ""], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", MinTrigger.toFixed(1), DivContL);
                    t += h;
                    t += h;

                }
                DrawMatrixPlot(NameNN, NNSet.TriggerAlgorithm);//, NNSet.TriggerMatrixIncome
            }
            break;
        case "Accuracy":
            {//+модуль, чтобы let не ругалась
                //"Размер матрицы"
                TextSimple([t, "", l1, ""], ["", ""], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", G.L[G.S.L].nnt030, DivContL);
                let Div_MatrixSize = TextFrameInput([t, "", "", l0], [w1, h], 10, NNSet.TriggerAccuracyMatrixSize, DivContL);
                Div_MatrixSize.oninput = function () {//событие изменение содержания поля ввода текста
                    AutoVerificationNumber(this);//Проверка ввода данных
                };
                Div_MatrixSize.onchange = function () {    //событие окончание изменение содержания поля ввода текста (потеря фокуса)
                    NNSet.TriggerAccuracyMatrixSize = Number(Div_MatrixSize.value);
                    SaveNNSet(NNSet, NameNN);
                }
                t += h;
                //"Радиус поиска"
                TextSimple([t, "", l1, ""], ["", ""], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", G.L[G.S.L].nnt040, DivContL);
                let Div_TriggerRadius = TextFrameInput([t, "", "", l0], [w1, h], 10, NNSet.TriggerAccuracyRadius, DivContL);
                Div_TriggerRadius.oninput = function () {//событие изменение содержания поля ввода текста
                    AutoVerificationNumber(this);//Проверка ввода данных
                };
                Div_TriggerRadius.onchange = function () {    //событие окончание изменение содержания поля ввода текста (потеря фокуса)
                    NNSet.TriggerAccuracyRadius = Number(Div_TriggerRadius.value);
                    SaveNNSet(NNSet, NameNN);
                }
                t += 3 * h;


                if (NNSet.TriggerAccuracyMatrix != null) {
                    //Есть данные поиска триггера

                    //Информация о лучшем триггере
                    let BestTrigger = NNSet.TriggerAccuracyMatrix[NNSet.TriggerAccuracyBestBi][NNSet.TriggerAccuracyBestSi];
                    //console.log("BestTrigger=" + BestTrigger);
                    //"Результаты поиска лучшего триггера:"
                    TextSimple([t, "", l0, ""], ["", ""], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", G.L[G.S.L].nnt050, DivContL);
                    t += h;
                    //"Триггер покупки"
                    TextSimple([t, "", l1, ""], ["", ""], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", G.L[G.S.L].nnt051, DivContL);
                    TextSimple([t, "", "", l0], ["", ""], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", BestTrigger.TriggerBuy.toFixed(1), DivContL);
                    t += h;
                    //"Триггер продажи"
                    TextSimple([t, "", l1, ""], ["", ""], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", G.L[G.S.L].nnt052, DivContL);
                    TextSimple([t, "", "", l0], ["", ""], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", BestTrigger.TriggerSale.toFixed(1), DivContL);
                    t += h;
                    //"Точность"
                    TextSimple([t, "", l1, ""], ["", ""], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", G.L[G.S.L].nnt081, DivContL);
                    TextSimple([t, "", "", l0], ["", ""], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", BestTrigger.Accuracy.toFixed(3), DivContL);
                    t += h;
                    //"Количество правильных сделок"
                    TextSimple([t, "", l1, ""], ["", ""], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", G.L[G.S.L].nnt082, DivContL);
                    TextSimple([t, "", "", l0], ["", ""], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", BestTrigger.NCorrect, DivContL);
                    t += h;
                    //"Количество пропущенных сделок"
                    TextSimple([t, "", l1, ""], ["", ""], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", G.L[G.S.L].nnt083, DivContL);
                    TextSimple([t, "", "", l0], ["", ""], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", BestTrigger.NSkipped, DivContL);
                    t += h;
                    //"Количество ошибочных сделок"
                    TextSimple([t, "", l1, ""], ["", ""], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", G.L[G.S.L].nnt084, DivContL);
                    TextSimple([t, "", "", l0], ["", ""], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", BestTrigger.NWrong, DivContL);
                    t += 2 * h;

                    //Максимальная точность
                    let MaxAccuracy = -Infinity;
                    for (let iTB = 0; iTB < NNSet.TriggerAccuracyMatrix.length; iTB++) { //покупка от -100 до 0(не включительно)
                        for (let iTS = 0; iTS < NNSet.TriggerAccuracyMatrix.length; iTS++) { //продажа от 100 до 0(не включительно)
                            let Accuracy = NNSet.TriggerAccuracyMatrix[iTB][iTS].Accuracy
                            //if (Accuracy > 0) {
                            if (MaxAccuracy < Accuracy) {
                                MaxAccuracy = Accuracy;
                            }
                            //}
                        }
                    }

                    let Limit = {};
                    Limit.Min = 0;
                    Limit.Max = MaxAccuracy;

                    //Скролл двигается линейно, а значения меняться логарифмически
                    let Base = 20;//нелинейность
                    //Полоса зеленого цвета."Нижний предел"
                    TextSimple([t, "", l0, ""], ["", ""], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", G.L[G.S.L].nnt060, DivContL);
                    let DivMinLimit = TextFrameInput([t, "", "", l0], [w1, h], 10, Limit.Min.toFixed(3), DivContL);//поле ввода 
                    t += h;
                    let SetValue1;
                    let ScrollMove1 = function (value) {//При перемещении ползунка, в функцию отправляется значение (0-1)
                        let vLog = ToLogScale(value, Base);//Преобразует значение x (от 0 до 1) из линейной шкалы, в значение y (от 0 до 1) нелинейной шкалы. Base от 1 до 20. Степень нелинейности
                        let vIncome = MaxAccuracy * vLog;//преобразуем в Income
                        //console.log("value = " + value + "  v = " + v);
                        if (vIncome > 0.9999 * Limit.Max) {
                            vIncome = 0.9999 * Limit.Max;
                            vLog = vIncome / MaxAccuracy;
                            value = FromLogScale(vLog, Base); //Преобразует значение y (от 0 до 1) нелинейной шкалы в значение x (от 0 до 1) линейной шкалы. Base от 1 до 20. Степень нелинейности
                            SetValue1(value);//Сместить скролл
                        }
                        DivMinLimit.value = vIncome.toFixed(3);
                        Limit.Min = vIncome;
                        ReDrawMatrixPlotLimit(Limit.Min, Limit.Max);
                    };
                    SetValue1 = ScrollBar([t, "", l0, ""], GetDivSizeContent(DivContL).w - 2 * l0, "horizontal", ScrollMove1, DivContL);
                    DivMinLimit.oninput = function () { //событие изменение содержания поля ввода текста
                        AutoVerificationNumber(this);//Проверка ввода данных
                        let value = Number(DivMinLimit.value) / MaxAccuracy;
                        //let vLog = ToLogScale(value, 10);//Преобразует значение x (от 0 до 1) из линейной шкалы, в значение y (от 0 до 1) нелинейной шкалы. Base от 1 до 20. Степень нелинейности
                        SetValue1(value);//Сместить скролл
                        ScrollMove1(value);//имитировать движение ползунка

                    };
                    SetValue1(0);//Сместить скролл
                    t += h;

                    //Полоса красного цвета."Верхний предел"
                    TextSimple([t, "", l0, ""], ["", ""], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", G.L[G.S.L].nnt062, DivContL);
                    let DivMaxLimit = TextFrameInput([t, "", "", l0], [w1, h], 10, Limit.Max.toFixed(3), DivContL);//поле ввода 
                    t += h;
                    let SetValue2;
                    let ScrollMove2 = function (value) {//При перемещении ползунка, в функцию отправляется значение (0-1)
                        let vLog = ToLogScale(value, Base);//Преобразует значение x (от 0 до 1) из линейной шкалы, в значение y (от 0 до 1) нелинейной шкалы. Base от 1 до 20. Степень нелинейности
                        let vIncome = MaxAccuracy * vLog;//преобразуем в Income
                        if (vIncome < Limit.Min / 0.9999 || vIncome == 0) {
                            vIncome = Limit.Min / 0.9999;
                            if (vIncome == 0) { vIncome = 0.0001 * MaxAccuracy }
                            vLog = vIncome / MaxAccuracy;
                            value = FromLogScale(vLog, Base); //Преобразует значение y (от 0 до 1) нелинейной шкалы в значение x (от 0 до 1) линейной шкалы. Base от 1 до 20. Степень нелинейности
                            SetValue2(value);//Сместить скролл
                        }
                        DivMaxLimit.value = vIncome.toFixed(3);
                        Limit.Max = vIncome;
                        ReDrawMatrixPlotLimit(Limit.Min, Limit.Max);
                    };
                    SetValue2 = ScrollBar([t, "", l0, ""], GetDivSizeContent(DivContL).w - 2 * l0, "horizontal", ScrollMove2, DivContL);
                    DivMaxLimit.oninput = function () {//событие изменение содержания поля ввода текста
                        AutoVerificationNumber(this);//Проверка ввода данных
                        let value = Number(DivMaxLimit.value) / MaxAccuracy;
                        SetValue2(value);//Сместить скролл
                        ScrollMove2(value);//имитировать движение ползунка
                    };
                    SetValue2(1);//Сместить скрол
                    t += 2 * h;

                    //"Статистика"
                    TextSimple([t, "", l0, ""], ["", ""], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", G.L[G.S.L].Statistics, DivContL);
                    t += h;
                    //"Максимальная точность"
                    TextSimple([t, "", l1, ""], ["", ""], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", G.L[G.S.L].nnt090, DivContL);
                    TextSimple([t, "", "", l0], ["", ""], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", MaxAccuracy.toFixed(3), DivContL);
                    t += 2 * h;


                }
                DrawMatrixPlot(NameNN, NNSet.TriggerAlgorithm);//, NNSet.TriggerMatrixIncome

            }
            break;
        case "Manual":
            {//+модуль, чтобы let не ругалась
                //"Ручная установка триггера:"
                TextSimple([t, "", l0, ""], ["", ""], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", G.L[G.S.L].nnt100, DivContL);
                t += h;
                //"Триггер покупки. От -100 до 0"
                TextSimple([t, "", l1, ""], ["", ""], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", G.L[G.S.L].nnt110, DivContL);
                let Div_TriggerSetBuy = TextFrameInput([t, "", "", l0], [w1, h], 10, NNSet.TriggerSetBuy, DivContL);
                Div_TriggerSetBuy.oninput = function () {//событие изменение содержания поля ввода текста
                    AutoVerificationNumberNegative(this);//Проверка ввода данных

                };
                Div_TriggerSetBuy.onchange = function () {    //событие окончание изменение содержания поля ввода текста (потеря фокуса)
                    if (Number(Div_TriggerSetBuy.value) > 0) {
                        Div_TriggerSetBuy.value = 0;
                    }
                    if (Number(Div_TriggerSetBuy.value) < -100) {
                        Div_TriggerSetBuy.value = -100;
                    }

                    NNSet.TriggerSetBuy = Number(Div_TriggerSetBuy.value);
                    SaveNNSet(NNSet, NameNN);
                }
                t += h;

                //"Триггер продажи. От 100 до 0"
                TextSimple([t, "", l1, ""], ["", ""], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", G.L[G.S.L].nnt120, DivContL);
                let Div_TriggerSetSale = TextFrameInput([t, "", "", l0], [w1, h], 10, NNSet.TriggerSetSale, DivContL);
                Div_TriggerSetSale.oninput = function () {//событие изменение содержания поля ввода текста
                    AutoVerificationNumber(this);//Проверка ввода данных

                };
                Div_TriggerSetSale.onchange = function () {    //событие окончание изменение содержания поля ввода текста (потеря фокуса)

                    if (Number(Div_TriggerSetSale.value) < 0) {
                        Div_TriggerSetSale.value = 0;
                    }
                    if (Number(Div_TriggerSetSale.value) > 100) {
                        Div_TriggerSetSale.value = 100;
                    }
                    NNSet.TriggerSetSale = Number(Div_TriggerSetSale.value);
                    SaveNNSet(NNSet, NameNN);
                }
                t += h;
            }
            break;
    }



    DivContL.UpdateScroll();




    //Справка
    t = 0;
    //"Справка"
    TextSimple([t, "", 0, ""], ["", ""], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", G.L[G.S.L].Help, DivContR);
    t += 2 * h;
    let Htext1 = G.L[G.S.L].hnnt010


    let DivHelp1 = TextSimple([t, "", 0, ""], ["", ""], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", Htext1, DivContR);
    ModDivPadding(["", "", "", G.D.S.GapIn], DivHelp1);
    DivHelp1.style.whiteSpace = "normal"; //Устанавливаем перенос строки автоматический
    let hDivHelp1 = GetDivSizeContent(DivHelp1).h;
    t += hDivHelp1;

    DivContR.UpdateScroll();


}

//Обучение
function NNSetWin_Training(DivCont, SD) {


    let NameNN = G.Page.NN.SelectNameNN;
    let NNSet = G.NN.N[NameNN].Set;

    //Размеры окна
    let SizeWin = GetDivSizeContent(DivCont);

    //Размеры
    let ContLW = SD.LW;
    let ContLH = SizeWin.h - G.D.S.ButtonH - 2 * G.D.S.GapIn;
    let ContRL = ContLW + G.D.S.GapIn;
    let ContRW = SizeWin.w - ContRL;
    if (ContRW > SD.RW) {
        ContRW = SD.RW;
    }
    let t = 0;
    let l0 = G.D.S.GapIn;
    let l1 = l0 + G.D.S.Tab;
    let h = G.D.S.ContFontSizeNormal;
    let w1 = SD.LWTextFrameInput;



    //Контейнер со скролом Левый
    let DivContL = Container([0, "", 0, ""], [ContLW, "100%"], DivCont);
    DivContL = ModDivScrollV(DivContL, "NNSetWin_TrainingL");//добавляем скролл
    //Контейнер со скроолом Правый
    let DivContR = Container([0, "", ContRL, ""], [ContRW, "100%"], DivCont);
    DivContR = ModDivScrollV(DivContR, "NNSetWin_TrainingR");//добавляем скролл



    //"Сброс обучения"
    TextSimple([t, "", l0, ""], ["", ""], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", G.L[G.S.L].nnl010, DivContL);
    //"Сброс"
    let Div_ClearTraining = ButtonText([t, "", "", l0], [w1, h], G.L[G.S.L].Reset, DivContL);
    Div_ClearTraining.onclick = function () {
        NNProcessSave.style.visibility = "visible";//Отображаем иконку сохранения НС    

        ClearErrorNN(NameNN);
        let Message = {
            "Type": "NNClearTraining",
            "NameNN": NameNN,
        };
        MessageSend(Message);

    }
    t += 2 * h;



    //Ограничение оперативной памяти
    //"Использование оперативной памяти"
    TextSimple([t, "", l0, ""], ["", ""], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", G.L[G.S.L].nnl020, DivContL);
    t += h;

    let CheckBoxOn = true;
    if (!NNSet.MemoryFullData) {
        CheckBoxOn = false;
    }
    //CheckBox
    let fnCheckBoxOn = function (On) {
        if (On) {
            NNSet.MemoryFullData = true;
        } else {
            NNSet.MemoryFullData = false;
        }
        SaveNNSet(NNSet, NameNN);
    };
    //"Все данные обучения будут загружены в ОП"
    TextSimple([t, "", l0, ""], ["", h], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", G.L[G.S.L].nnl030, DivContL); //сглаживания, точки сжатия.
    CheckBox([t, "", "", l0], [h, h], CheckBoxOn, fnCheckBoxOn, DivContL);
    t += h;


    //"Точночть данных обучения "
    TextSimple([t, "", l0, ""], ["", ""], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", G.L[G.S.L].nnl040, DivContL);
    //"8 знаков", "16 знаков"
    let ListContent_Accuracy = [G.L[G.S.L].nnl041, G.L[G.S.L].nnl042];
    let SelectContent_Accuracy = ListContent_Accuracy[0];
    if (NNSet.DT_Float64) {
        SelectContent_Accuracy = ListContent_Accuracy[1];
    }


    let DivListSelectAccuracy = ListSelect([t, "", "", l0], [w1, h], SelectContent_Accuracy, ListContent_Accuracy, DivContL);
    DivListSelectAccuracy.fnSelectContent = function (SelectContent) {
        //console.log("SelectContent= " + SelectContent);
        NNSet.DT_Float64 = false;
        if (SelectContent == ListContent_Accuracy[1]) {
            NNSet.DT_Float64 = true;
        }
        //console.log(" NNSet.DT_Float64= " + NNSet.DT_Float64);
        SaveNNSet(NNSet, NameNN);
    }
    t += h;


    //"Размер данных, [Гб]"
    TextSimple([t, "", l0, ""], ["", ""], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", G.L[G.S.L].nnl050, DivContL);
    let Content1 = RoundingToN(NNSet.MemoryInfoData, 3);
    TextSimple([t, "", "", l0], ["", ""], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", Content1, DivContL);
    /*
    t += h;
    TextSimple([t, "", l0, ""], ["", ""], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", "Размер НС", DivContL);
    let Content2 = RoundingToN(NNSet.MemoryInfoNN, 4);
    TextSimple([t, "", "", l0], ["", ""], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", Content2, DivContL);
    */
    t += 2 * h;


    //"Автосохранение каждые n минут"
    TextSimple([t, "", l0, ""], ["", ""], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", G.L[G.S.L].nnl060, DivContL);
    let Div_AutoSaveTime = TextFrameInput([t, "", "", l0], [w1, h], 6, NNSet.AutoSaveTime, DivContL);
    Div_AutoSaveTime.oninput = function () {   //событие изменение содержания поля ввода текста
        AutoVerificationNumber(this);//Проверка ввода данных
    };
    Div_AutoSaveTime.onchange = function () {    //событие окончание изменение содержания поля ввода текста (потеря фокуса)
        NNSet.AutoSaveTime = Math.round(Number(Div_AutoSaveTime.value));
        SaveNNSet(NNSet, NameNN);
    }
    t += 2 * h;




    //"Количество эпох обучения"
    TextSimple([t, "", l0, ""], ["", ""], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", G.L[G.S.L].nnl070, DivContL);
    let Div_Epoch = TextFrameInput([t, "", "", l0], [w1, h], 6, NNSet.NN.Epoch, DivContL);
    Div_Epoch.oninput = function () {   //событие изменение содержания поля ввода текста
        AutoVerificationNumber(this);//Проверка ввода данных
    };
    Div_Epoch.onchange = function () {    //событие окончание изменение содержания поля ввода текста (потеря фокуса)
        NNSet.NN.Epoch = Math.round(Number(Div_Epoch.value));
        SaveNNSet(NNSet, NameNN);
    }
    t += 2 * h;




    //Кнопка Начать/Прервать/Продолжить
    let wB = w1;
    let hB = G.D.S.ButtonH;
    if (G.NN.ListTraining.includes(NameNN)) {//Эта НС есть в списке G.NN.ListTraining
        //"Остановить"
        Div = ButtonText([t, "", "", l0], [wB, hB], G.L[G.S.L].Stop, DivContL);
        Div.onclick = function () {
            let Message = {
                "Type": "CancelProcess",
                "NameProcess": "TraineNN" + NameNN, //Вырианты: "Bot" отмена торговли,"TraineNN"+NameNN отмена обучения НС, "TestingNN"+NameNN отмена теста НС
            };
            MessageSend(Message);
        }
    } else {

        //"Начать"
        let Content = G.L[G.S.L].Start;
        if (NNSet.ErrorTrade_Iteration) {
            //"Продолжить"
            Content = G.L[G.S.L].Resume;
        }

        Div = ButtonText([t, "", "", l0], [wB, hB], Content, DivContL);

        Div.onclick = function () {
            let Message = {
                "Type": "NNStartTrain",//"BuildNN"
                "NameNN": NameNN,
            };
            MessageSend(Message);
        }
    }
    t += hB;
    t += h;


    //Оповещения.
    let DivContainerAlerts = Container([t, "", 0, ""], ["100%", ""], DivContL);//контейнер для оповещения
    DivContainerAlerts.innerHTML = "";
    let ID = "TrainNN" + NameNN;//генерируем ID
    G.Af[ID] = function () { //ф-ция принимающая инфо с сервера
        //console.log("G.A[ID] " + G.A[ID]);

        if (!(ID in G.A)) {
            return;
        }
        DivContainerAlerts.innerHTML = "";

        let Alerts = G.A[ID];
        //console.log(" Alerts = " + Alerts);
        let tt = 0;

        //Структура [Alerts.Name{ .Symbol, .Progress},]
        for (let i = 0; i < Alerts.length; i++) {
            let Content = "";
            switch (Alerts[i].Name) {
                case "GeneratorOut":
                    //"Выходные данные. Набор " ". Выполнено " 
                    Content = G.L[G.S.L].nnl080 + Alerts[i].Symbol + G.L[G.S.L].nnl081 + Alerts[i].Progress + "%";
                    break;
                case "GeneratorIn":
                    //"Входных данные. Набор "". Выполнено "
                    Content = G.L[G.S.L].nnl082 + Alerts[i].Symbol + G.L[G.S.L].nnl081 + Alerts[i].Progress + "%";
                    break;
                case "TrainNN":
                    //"Обучение. Выполнено "
                    Content = G.L[G.S.L].nnl083 + Alerts[i].Progress + "%";
                    break;
                case "SearchTrigger":
                    //"Поиск триггера. Процесс... "
                    Content = G.L[G.S.L].nnl084;
                    break;
                case "EndTrainNN" || "BuildNN":
                    //"Готово. "
                    Content += G.L[G.S.L].nnl085;
                    break;
                case "CancelTrainNN":
                    //"Прерывание. "
                    Content += G.L[G.S.L].nnl086;
                    break;
            }
            TextSimple([tt, "", l0, ""], ["", ""], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", Content, DivContainerAlerts);
            tt += h;
        }
        DivContainerAlerts.style.height = tt + "px";
        t += tt;
        DivContL.UpdateScroll();//обновляем скролл
    };
    G.Af[ID]();



    //Справка
    t = 0;
    //"Справка"
    TextSimple([t, "", 0, ""], ["", ""], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", G.L[G.S.L].Help, DivContR);
    t += 2 * h;
    let Htext = G.L[G.S.L].hnnl010;



    let DivHelp = TextSimple([t, "", 0, ""], ["", ""], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", Htext, DivContR);
    ModDivPadding(["", "", "", G.D.S.GapIn], DivHelp);
    DivHelp.style.whiteSpace = "normal"; //Устанавливаем перенос строки автоматический
    //Справка. Стоп.


    DivContL.UpdateScroll();
    DivContR.UpdateScroll();



    let SelectSymbol = NNSet.DataTrain[G.Page.NN.DataSetSelectList[NameNN]].Symbol;
    GetPrice(SelectSymbol, false);


}

//Тест
function NNSetWin_Test(DivCont, SD) {
    let NameNN = G.Page.NN.SelectNameNN;
    let NNSet = G.NN.N[NameNN].Set;


    //Размеры окна
    let SizeWin = GetDivSizeContent(DivCont);

    //Размеры
    let ContLW = SD.LW;
    let ContLH = SizeWin.h - G.D.S.ButtonH - 2 * G.D.S.GapIn;
    let ContRL = ContLW + G.D.S.GapIn;
    let ContRW = SizeWin.w - ContRL;
    if (ContRW > SD.RW) {
        ContRW = SD.RW;
    }
    let t = 0;
    let l0 = G.D.S.GapIn;
    let l1 = l0 + G.D.S.Tab;
    let h = G.D.S.ContFontSizeNormal;
    let w1 = SD.LWTextFrameInput;



    //Контейнер со скролом Левый
    let DivContL = Container([0, "", 0, ""], [ContLW, "100%"], DivCont);


    DivContL = ModDivScrollV(DivContL, "NNSetWin_TestL");//добавляем скролл
    //Контейнер со скролом Правый
    let DivContR = Container([0, "", ContRL, ""], [ContRW, "100%"], DivCont);
    DivContR = ModDivScrollV(DivContR, "NNSetWin_TestR");//добавляем скролл

    //  "Пара"
    TextSimple([t, "", l0, ""], ["", ""], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", G.L[G.S.L].Symbol, DivContL);
    let DivListSelect = ListSelect([t, "", "", l0], [w1, h], NNSet.TestSymbol, G.S.TopSymbol, DivContL);
    DivListSelect.fnSelectContent = function (SelectContent) {//Изменение пары
        //console.log("SelectContent= " + SelectContent);
        NNSet.TestSymbol = SelectContent;
        SaveNNSet(NNSet, NameNN);
        GetPrice(SelectContent, false);
    }
    t += 2 * h;


    //Интервал тестирования
    let fTimeStartOnchange = function (value) {   //событие изменение содержания поля ввода текста
        NNSet.TestTimeStart = DateToUnix(value);
        SaveNNSet(NNSet, NameNN);
    };
    let fTimeEndOnchange = function (value) {   //событие изменение содержания поля ввода текста
        NNSet.TestTimeEnd = DateToUnix(value);
        SaveNNSet(NNSet, NameNN);
    };
    t = ModuleTextInterval(t, w1, NameNN, NNSet.TestTimeStart, NNSet.TestTimeEnd, fTimeStartOnchange, fTimeEndOnchange, DivContL);

    t += 2 * h;
    //Кнопка Начать/Прервать
    let wB = w1;
    let hB = G.D.S.ButtonH;

    let DivButton = ButtonText([t, "", "", l0], [wB, hB], "", DivContL);
    if (G.NN.ListTasting.includes(NameNN)) {//Эта НС есть в списке G.NN.ListTasting
        //DivButton.innerHTML = "Прервать";
        DivButton.innerHTML = "Stop";

    } else {
        //DivButton.innerHTML = "Начать";
        DivButton.innerHTML = "Start";


    }

    DivButton.onclick = function () {
        if (G.NN.ListTasting.includes(NameNN)) {//Эта НС есть в списке G.NN.ListTasting
            let Message = {
                "Type": "CancelProcess",
                "NameProcess": "TestingNN" + NameNN, //Варианты: "Bot" отмена торговли,"TraineNN"+NameNN отмена обучения НС, "TestingNN"+NameNN отмена теста НС
            };
            MessageSend(Message);
            G.NN.ListTasting = ArrDelete(G.NN.ListTasting, NameNN);
            //DivButton.innerHTML = "Начать";
            DivButton.innerHTML = "Start";
        } else {
            let Message = {
                "Type": "TestingTrainedNN",
                "NameNN": NameNN,
            };
            delete G.C.N["OutputTest" + NameNN];
            delete G.C.N["NNOutTest" + NameNN];
            delete G.C.N["OrderTest" + NameNN];
            MessageSend(Message);
            G.NN.ListTasting.push(NameNN);
            DivButton.innerHTML = "Stop";
        }
        console.log("G.NN.ListTasting = " + G.NN.ListTasting);

    }




    t += hB;
    t += h;


    //Оповещения.
    let DivContainerAlerts = Container([t, "", 0, ""], ["100%", ""], DivContL);//контейнер для оповещения
    DivContainerAlerts.innerHTML = "";
    let ID = "TestingTrainedNN" + NameNN;//генерируем ID
    G.Af[ID] = function () { //ф-ция принимающая инфо с сервера
        //console.log("G.A[ID] " + G.A[ID]);

        if (!(ID in G.A)) {
            return;
        }
        DivContainerAlerts.innerHTML = "";

        let Alerts = G.A[ID];
        console.log(" Alerts = " + Alerts);
        let tt = 0;

        //Структура [Alerts.Name{ .Symbol, .Progress},]
        for (let i = 0; i < Alerts.length; i++) {
            let Content = "";
            switch (Alerts[i].Name) {
                case "Testing":
                    //"Тестирование НС. Выполнено "
                    Content = G.L[G.S.L].nnv010 + Alerts[i].Progress + "%.";
                    TextSimple([tt, "", l0, ""], ["", ""], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", Content, DivContainerAlerts);
                    tt += h;
                    // "Доход " " %. Количество сделок "
                    Content = G.L[G.S.L].nnv020 + Alerts[i].Income.toFixed(1) + G.L[G.S.L].nnv021 + Alerts[i].NOrder + ".";
                    break;
                case "Completed":
                    //"Готово. "
                    Content += G.L[G.S.L].nnv030;
                    break;
                case "CancelTestingNN":
                    //"Прерывание. "
                    Content += G.L[G.S.L].nnv040;
                    break;
            }
            TextSimple([tt, "", l0, ""], ["", ""], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", Content, DivContainerAlerts);
            tt += h;
        }
        DivContainerAlerts.style.height = tt + "px";
        t += tt;
        DivContL.UpdateScroll();//обновляем скролл
    };
    G.Af[ID]();

    DivContL.UpdateScroll();//обновляем скролл




    //Справка
    t = 0;

    //"Справка"
    TextSimple([t, "", 0, ""], ["", ""], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", G.L[G.S.L].Help, DivContR);
    t += 2 * h;
    let Htext = G.L[G.S.L].hnnv010;

    let DivHelp = TextSimple([t, "", 0, ""], ["", ""], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", Htext, DivContR);
    ModDivPadding(["", "", "", G.D.S.GapIn], DivHelp);
    DivHelp.style.whiteSpace = "normal"; //Устанавливаем перенос строки автоматический
    //Справка. Стоп.

    DivContL.UpdateScroll();
    DivContR.UpdateScroll();

    GetPrice(NNSet.TestSymbol, false);
}




function ClearErrorNN(NameNN) {
    //AName = ["Convergence" + NameNN, "ConvergenceNoSignal" + NameNN, "ConvergenceBuy" + NameNN, "ConvergenceSale" + NameNN];
    AName = ["ConvergenceAverage" + NameNN, "ConvergenceNoSignal" + NameNN, "ConvergenceBuy" + NameNN, "ConvergenceSale" + NameNN];

    for (let i = 0; i < AName.length; i++) {
        Name = AName[i];
        delete G.C.N[Name];
    }
}

